
      program mettab

      parameter(ka = 1, max = 8)
      logical filex
      real a(6), shift(6), stdd(6), werte(max)
c      character ta(6)*5
      character line*132, form*20, text(6)*24, char(max)*132
      character*80 metfile, cycfile, datfile, inpfile, title
      data text /'  A       Delt     Stdd','  B       Delt     Stdd',
     *           '  C       Delt     Stdd','Alpha     Delt     Stdd',
     *           ' Beta     Delt     Stdd','Gamma     Delt     Stdd'/
c      data ta /'A','B','C','Alpha','Beta','Gamma'/


c --- Input-File lesen:

c      write(*,'(2x,$a)') 'Please type the input filename: '
      read(*,'(a)') inpfile

      call outfil(cycfile,inpfile,'cyc',laenge,0)
      call outfil(metfile,inpfile,'met',laenge,0)

      ist = 0
      open(ka,file=inpfile,status='old',err=1000)
      call getinp(ka,'TIT','eee',werte,char,max,num,nn,ist)
      if(ist.eq.11) goto 1100
      title(1:80) = char(1)(1:80)


      ist = 0
      open(ka,file=inpfile,status='old',err=1000)
      call getinp(ka,'DAT','eee',werte,char,max,num,nn,ist)
      if(ist.eq.11) goto 1100
      datfile(1:80) = char(1)(1:80)

      ist = 1
      call getinp(ka,'MET','eee',werte,char,max,num,nn,ist)
      if(ist.eq.11) goto 1100
      do 10 i=1,6
         a(i) = werte(i)
 10   continue

      close(ka)

c --- Zyklus-File lesen:

      open(ka,file=cycfile,status='old',err=1200)

      do 50 i=1,6

 20      read(ka,'(a)',end=50,err=1300) line
         ix = index(line,text(i))
         if(ix.eq.0) goto 20

 30      read(ka,'(a)',err=1300) line
         if(index(line,'|').gt.0) goto 30

         backspace(ka)
         backspace(ka)
         form = '(   x,(f10.0,2f9.0))'
         write(form(2:4),'(i3)') ix - 4 
         read(ka,fmt=form,err=1300) a(i), shift(i), stdd(i)
c         write(*,'(a,a,a,f10.5,2f9.5)') 
c     *   'Gitterkonstante ',ta(i),': ',a(i), shift(i), stdd(i)
         rewind(ka)

 50   continue
      
      close(ka)


c --- Temperatur aus dem Datenfile lesen:

      open(ka,file=datfile,status='old',err=1600)
 80   ist = 1
      call getinp(ka,'   ','   ',werte,char,max,num,nn,ist)
      if(ist.ne.1) goto 1700
      if(char(1)(1:3).ne.'DUO'.and.char(1)(1:3).ne.'duo'.and.
     *   char(1)(1:3).ne.'DAT'.and.char(1)(1:3).ne.'dat'.and.
     *   char(1)(1:3).ne.'NEU'.and.char(1)(1:3).ne.'neu') goto 80
      if(num.ne.8) goto 80
      temp = werte(6)
      close(ka)


c --- Gitterkonstanten in das Ausgabe-File schreiben:
      
      inquire(file=metfile,exist=filex)
      if(filex) then
        open(ka,file=metfile,status='old',err=1800)
 120    read(ka,*,end=200,err=1900)
        goto 120
      else
        open(ka,file=metfile,status='unknown',err=1800)
        write(ka,'(a78)') title
        write(ka,'(a)') 'TITELENDE     FOR'
        write(ka,'(3a)') 
     *'    T/K       a        da         b        db',
     *'         c        dc       Alpha    dAlpha     Beta',
     *'     dBeta      Gamma    dGamma'
      end if
 200  write(ka,'(f8.2,6(1x,f10.5,f9.5))') temp,(a(i),stdd(i),i=1,6)
      close(ka)

      goto 2000


c --- Fehlermeldungen:

 1000 write(*,'(2x,a)') 'Cannot open input file'
      goto 2000
 1100 write(*,'(2x,a)') 'Error reading input file'
      goto 2000
 1200 write(*,'(2x,a)') 'Cannot open cycle file'
      goto 2000
 1300 write(*,'(2x,a)') 'Error reading cycle file'
      goto 2000
 1600 write(*,'(2x,a)') 'Cannot open data file'
      goto 2000
 1700 write(*,'(2x,a)') 'Error reading data file'
      goto 2000
 1800 write(*,'(2x,a)') 'Cannot open output file'
      goto 2000
 1900 write(*,'(2x,a)') 'Error reading output file'


c --- Ende:

 2000 continue
      end
c******************************************************************************
c***          Eine Zeile einer Datei mit oder ohne Code einlesen            ***
c******************************************************************************

      subroutine getinp(ke,code,ecod,werte,char,max,num,nn,ist)

c     ke:      Kanalnummer
c     code:    Zeilencode, z. B. 'TIT'
c              code = '   ': Zeile ohne Code einlesen
c     ecod:    Code, bei dem das Einlesen abgebrochen wird
c     char:    Daten als Character-String abgespeichert
c     werte:   Daten als Realwerte abgespeichert
c     ist:     Eingabe: = 0 : Zeichenkette einlesen --> char
c                       = 1 : Daten einer Zeile als Realwerte (werte) und
c                             zusaetzlich als character (char) abspeichern 
c              Ausgabe: = 11 : Codewort nicht gefunden!
c                       = 13 : Ende beim Einlesen gefunden!
c     nn:      Zeilennummer
c     line:    Eingelesene Eingabe-Zeile
c              (einschliesslich aller Fortsetzungszeilen)
c     LMAX     Maximale Anzahl der Zeichen pro Zeile 
c     MAXLINE: Maximale Anzahl der Zeichen pro Eingabe-Zeile 
c              (einschliesslich der Fortsetzungszeilen)
c     max:     Maximale Anzahl der Werte pro Eingabe-Zeile
c     num:     Anzahl der gefundenen Werte pro Eingabe-Zeile


      parameter(MAXLINE = 250, LMAX = 132)
      real werte(max)
      character zeile*(LMAX), code*3, ecod*3, char(max)*(LMAX)
      character line*(MAXLINE)


c -- Initialisierung:

      ibeg = 1

      do 5 k=1,max
         char(k) = ' '
5     continue


c --- Zeile einlesen:

 10   k = 0
      line = ' '

 11   zeile = ' '
      read(ke,'(a)',end=1100) zeile
c      write(*,'(a,a)') 'Z = ',zeile(1:70)
      nn = nn + 1

      do 20 i=1,LMAX
         if(zeile(i:i).eq.'\\') then
           if(i.eq.1) then
             goto 11
           else
             if(zeile(i-1:i-1).eq.' ') goto 11
           end if
         end if
         k = k + 1
         if(k.gt.MAXLINE) goto 30
         line(k:k) = zeile(i:i)
 20   continue

c --- Nach der Kennung suchen:

 30   if(code.ne.'   ') then

        if(ecod.ne.'eee'.and.line(1:3).eq.ecod) then
          backspace(ke)
          goto 1300
        end if
        if(line(1:3).ne.code(1:3)) goto 10

c --- ">" suchen:

        do 100 i=1,MAXLINE
           if(line(i:i).eq.'>') then
             ibeg = i + 1
             goto 110
           end if
100     continue
        stop 'ERROR: ">" is missing'

      end if


c --- Daten der Zeile abspeichern:

110   num = 0
      do 500 k=1,max
   
         if(ibeg.gt.MAXLINE) return 

c --- Anfang suchen:
 
         do 200 j=ibeg,MAXLINE
            if(line(j:j).ne.' '.and.line(j:j).ne.',') then
              ibeg = j
              num = num + 1
              goto 250
            end if
200      continue

c --- Ende suchen:

250      if(ist.ne.0) then
           do 300 j=ibeg,MAXLINE
              if(line(j:j).eq.' '.or.line(j:j).eq.',') then
                iend = j - 1
                goto 350
              end if
300        continue
         end if

c --- Daten aus der Zeichenkette einlesen:

350      if(ist.eq.0) then
           m = MAXLINE - ibeg + 1
           char(1)(1:m) = line(ibeg:MAXLINE)
           return
         else if(ist.ge.1) then
           read(line(ibeg:iend),'(f15.0)',err=355) werte(k)
355        m = iend - ibeg + 1 
           char(k)(1:m) = line(ibeg:iend)
         end if
  
         ibeg = iend + 1

500   continue

      return


c --- Fehlermeldungen und Warnungen zurueckgeben:
 
1100  ist = 11
      return
1300  ist = 13
      return

      end


C******************************************************************************
C***            Name der Ausgabe-Datei erzeugen                             ***
C******************************************************************************

      subroutine outfil(name,file,filspe,laenge,nr)

      parameter(MAX = 80)
      character filspe*3, file*80, name*80, form*4


c --- Initialisierung:

      name = ' '

c --- Zehnerpotenz der Zahl NR bestimmen:

      nz = 0
      if(nr.gt.0) nz = int(alog10(real(nr))) + 1

c --- Ende suchen:

      do 50 i = MAX,1,-1
         if(file(i:i).eq.'.') then
           iend = i - 1
           goto 60
         end if
50    continue

c --- Anfang suchen:

60    do 100 i = MAX,1,-1
         if(file(i:i).eq.'/'.or.file(i:i).eq.']') then
           ibeg = i + 1
           goto 120
         end if
100   continue
      ibeg = 1    

c --- Basisnamen abspeichern:
      
      n = 0
120   do 200 i = ibeg,iend
         if(file(i:i).ne.' ') then
           n = n + 1
           name(n:n) = file(i:i)
         end if
200   continue     
    
c --- Laufende Nummer und Extension anhaengen:

      form = '(i )'
      write(form(3:3),'(i1)') nz
      if(nz.gt.0) write(name(n+1:n+nz),form) nr
      name(n+nz+1:n+nz+1) = '.'
      name(n+nz+2:n+nz+4) = filspe(1:3)
      laenge = n + nz + 4

      return
      end
