# SIMPRO Version 1.2     29-May-1996
# bash shell script

# Harald Ritter, Joerg Ihringer
# Institut fuer Kristallographie
# der Universitaet Tuebingen
# Charlottenstrasse 33
# D-72070 Tuebingen
# Germany
# Phone: (0)7071/29-6058


echo 'This is SIMPRO 1.2 (1996)'

# Test input:
if [ $# = 1 ]; then
   inpfile=$1
   jobtyp="r"
elif [ $# = 2 ]; then
   inpfile=$2 
   if [ "$1" = "-r" ]; then
      jobtyp="r"
   elif [ "$1" = "-m" ]; then
      jobtyp="m"
   else
      echo 'simpro: illegal option'
   fi
else
  echo 'Usage: simpro [-option] filename'
  echo ' -r  Profile refinement (default)'
  echo ' -m  Filmlift data refinement'
  exit
fi

# Start SIMPRO:
if [ -e ${inpfile} ]; then
   if [ "${jobtyp}" = "r" ]; then
      echo ${inpfile} | ~/bin/simpro12
   else
      i=0
      DAT="sim.dat"
      file=`dirname $inpfile`/`basename $inpfile .inp`
      for datfile in *.duo; do
          let i=+1
          echo "  "
          echo "  "
          echo "  Data set" $i : ${datfile}
          cp ${datfile} ${DAT}
          echo ${inpfile} | ~/bin/simpro12
          echo "  Writing on file" $file.met
          echo $inpfile | ~/bin/mettab
          mv $file.cyc $file$i.cyc
      done
      rm -f ${DAT}
   fi
else
   echo simpro: cannot open input file ${inpfile}
fi

   






