# SIMPRO  Version 1.2    29-May-1996
# csh shell script

# Harald Ritter, J. Ihringer
# Institut fuer Kristallographie
# der Universitaet Tuebingen
# Charlottenstrasse 33
# D-72070 Tuebingen
# Germany
# Phone: (0)7071/29-6058

#/bin/csh

echo 'This is SIMPRO 1.2 (1996)'

# Eingabe ueberpruefen:

set jobtyp = r
if($#argv > 2 || $#argv < 1) then
  echo 'Usage: simpro [-option] filename'
  echo ' -r  Profile refinement (default)'
  echo ' -m  Filmlift data refinement'
  exit
else if($#argv == 2) then
  switch($argv[1])
    case '-r':
       breaksw
    case '-m':
       set jobtyp = m
       breaksw
    default:
       echo 'simpro: illegal option'
       exit
  endsw
  set inpfile = $2
else
  set inpfile = $1
endif

# Input-filename testen:

if !(-e $inpfile) then
   echo simpro: cannot open input file $inpfile
   exit
endif

set DAT = sim.dat
set filename = $inpfile:r

# SIMPRO 1.2 starten:

switch($jobtyp)
  case 'm':
      @ i=0
      foreach datfile (*.duo)
         @ i+=1
         echo "  "
         echo "  "
         echo "  Data set" $i : $datfile
         cp $datfile $DAT  
         echo $inpfile | simpro12
         echo "  Writing on file" $filename".met"
         echo $inpfile | mettab
         mv $filename".cyc" $filename$i".cyc"
      end
      rm -f $DAT
      breaksw
  case 'r':
      echo $inpfile | simpro12
endsw    

