
c   *****************************
c   *        S I M P R O        *
c   *****************************

c   Version 1.2 vom 18.07.1997

c   Harald Ritter
c   Institut fuer Kristallogroaphie
c   der Universitaet Tuebingen
c   Charlottenstrasse 33
c   D-72070 Tuebingen
c   Tel.: 07071/29-76058


      program simpro
c      subroutine simpro12(inpfile)

      external pkshift

c --- Steuer-Parameter:

      parameter(LPHASE = 3)
      integer ihkl, lhkl, ibac, ieich, ifis, istru

c --- Ein- und Ausgabe:

      parameter(ke = 2, ka = 3, maxline = 132)
      logical filex(LPHASE)
      character*80 inpfile, hklfile, plotfile, outfile, savefile
      character date*9, time*8, line*132

c --- Fit-Parameter:

      parameter(MSZ = 500)
      integer ipar(MSZ), mcycle, maxs, num
      real rjac(MSZ,MSZ), vx(MSZ), eps, relax(30)
      real chisq, rp, rwp, swobs

c --- Zyklus-File:
 
      parameter(MAPA = 5000, kcyc = 4)
      integer iout, isp
      character cycfile*80, param(MAPA)*7
      real out(MAPA,MSZ)

c === Parameter des Datensatzes:

      parameter(IDAT = 1)
      character titel(IDAT)*70
      integer igeo, nprof, nphase
      real rlamda(2), ratio(2), thmin, thmax, wdt, rlim, cthm, ctha,
     *     xmin, xmax

c --- Daten:

      parameter(IDZ = 10000)
      character datfile*80
      integer krr(2,LPHASE,IDZ), mit(IDZ), izahl
      real the(IDZ), obs(IDZ), calc(IDZ), bac(IDZ), gew(IDZ)

c --- Datei mit den Untergrund-Stuetzpunkten:

      parameter(IBZ = 100)
      character bacfile*80
      real pos(IBZ), bck(IBZ)

c --- Datei mit den Eichreflexen:

      external silat
      parameter(MEC = 200)
      character eichfile*80, eichtitle*70
      real th_cal(MEC), th_obs(MEC), silat

c --- Excluded Regions:

      parameter(IEZ = 30)
      integer iexcl
      real excl(2,IEZ)

c --- Parameter:

      character cglb(10)*5
      integer lglb(10)
      real glb(10), aglb(10)

c === Parameter der Phase:

      character phsnm(LPHASE)*4
      integer imo(LPHASE), iord(LPHASE)
      real defint(LPHASE)

c --- Raumgruppe:

      real tran(3,48,LPHASE)
      character symfile*80, spgrp(LPHASE)*60, intaus(LPHASE)*1
      integer ism(3,3,48,LPHASE), laue(LPHASE), nsym(LPHASE), 
     *        icent(LPHASE)


c --- Gitterkonstanten, rez. Gitterkonstanten:

      real gitter(6,LPHASE), celld(6), cellr(13)

c --- Parameter:

      character cpar(20,LPHASE)*5
      integer lpar(19,LPHASE)
      real par(19,LPHASE), apar(19,LPHASE)

c --- Parameter der Reflexe:

      parameter(IRS = 1000, NORD = 6)
      character cint(IRS)*5, intfile(LPHASE)*80
      integer lint(IRS), mult(IRS), iref(IRS,2), nuq(2*NORD,IRS), 
     *        ic(LPHASE), indx(IRS)
      real theta(IRS), rlopo(IRS), hwb(IRS), rint(IRS), riobs(IRS),
     *     aint(IRS), corint(IRS), rsig(IRS), tann(IRS)

c --- Hilfsfelder der Subroutine fis7:

      integer itemp(IRS), ltemp(IRS)
      real ref(3,IRS), rtemp(IRS)

c --- Hilfsfelder der Subroutine jmfit:

      integer mxx(MSZ), myy(MSZ)
      real rjadu(MSZ,MSZ), vxdu(MSZ), bcl(MSZ,MSZ), xloe(MSZ),
     *     deriv(MSZ), dersto(MSZ,IRS)


c --- Initialisierung:

       imoges = 0

c --- Titel des Programms:

      write(*,'(13(/2x,a))')
     *'+-----------------------------------------------------------+',
     *'|                                                           |',
     *'|                        S I M P R O                        |',
     *'|                                                           |',
     *'|                   V e r s i o n   1 . 2                   |',
     *'|                                                           |',
     *'|                  Last updated 18 Aug 1997                 |',
     *'|                                                           |',
     *'|                       Harald Ritter                       |',
     *'| Institut fuer Kristallographie der Universitaet Tuebingen |',
     *'|       Charlottenstr. 33, D-72070 Tuebingen, Germany       |',
     *'|                                                           |',
     *'+-----------------------------------------------------------+'

c --- Datum und Uhrzeit ausgeben:

      call datum(date,time)
      write(*,'(/2x,a,4x,a)') date,time

c --- Felddimensionen ausgeben:

      write(*,'(8(/2x,a,i5))') 
     * 'Maximum number of phases                : ',LPHASE,
     * 'Maximum number of reflections           : ',IRS,
     * 'Maximum number of measured data         : ',IDZ,
     * 'Maximum number background data          : ',IBZ,
     * 'Maximum number of excluded regions      : ',IEZ,
     * 'Maximum number of parameters            : ',MSZ,
     * 'Maximum order of the satellites         : ',NORD,
     * 'Max. number of parameters in CYCLE file : ',MAPA

c --- Name der Eingabe-Datei einlesen und Eingabe-Datei einlesen:

      write(*,'(/2x,$a)') 'Please type the input filename: '
      read(*,'(a)') inpfile
      write(*,*)
      write(*,*)
      call parinp(ke,inpfile,titel(1),datfile,bacfile,eichfile,
     *            intfile,rlamda,ratio,thmin,thmax,igeo,nprof,ihkl,lhkl,
     *            isp,ibac,ieich,ifis,istru,wdt,rlim,cthm,ctha,excl,
     *            iexcl,IEZ,glb,cglb,nphase,phsnm,laue,intaus,spgrp,
     *            imo,iord,gitter,defint,par,cpar,mcycle,eps,relax,
     *            LPHASE,NORD)


c --- Daten einlesen:

      write(*,'(/2x,a)') 'Diffraction data:'
      line = ' '
      line = '  Data file: '//datfile
      call writline(6,line,maxline)
      call datinp(ke,IDZ,datfile,thmin,thmax,step,temp,izahl,
     *            the,obs,gew,bac)

c --- Untergrund-Werte einlesen und Untergrund berechnen:

      if(ibac.eq.1) then
        write(*,'(/2x,a)') 'Background data:'
        line = ' '
        line = '  Data file: '//bacfile
        call writline(6,line,maxline)
        call bacinp(ke,bacfile,pos,bck,ibck,IBZ,excl,iexcl,IEZ)
        call bacalc(pos,bck,ibck,IBZ,the,bac,izahl,IDZ)
      end if

c --- Eichreflexe einlesen und Eichung durchfuehren:

      if(ieich.eq.1) then
        write(*,*)
        line = ' '
        line = '  Scale file: '//eichfile
        call writline(6,line,maxline)
        call eichinp(ke,eichfile,eichtitle,th_obs,th_cal,neich,IRS)
        call eich(th_obs,th_cal,neich,IRS,excl,iexcl,IEZ,
     *            the,izahl,IDZ)
        xmin = the(1)
        xmax = the(izahl)
      else if(ieich.eq.2) then
        write(*,'(/2x,a)') 'Scaling on Silicon pattern:'
        as = silat(temp)
        celld(1) = as
        celld(2) = as
        celld(3) = as
        celld(4) = 90.
        celld(5) = 90.
        celld(6) = 90.
        write(*,'(2x,a,f6.1,a,f9.5)')
     *  'Lattice constant at ',temp,' K = ',as
        call rezi(celld,cellr)
        do 12 k=1,6
           gitter(k,nphase) = celld(k)
           par(13+k,nphase) = cellr(k)
12      continue
      end if
 

      iend = 0
      do 50 ip=1,nphase

         ibeg = iend + 1
         if(imo(ip).eq.1) imoges = imoges + 1

         write(*,'(/2x,a,i2,2a,/2x,a)')
     *        'Phase ',ip,': ',phsnm(ip),'--------------'

         if(ifis.eq.1) then

c --- Symmetriekarten einlesen:

           if(spgrp(ip)(1:10).ne.'          ') then
             ismat = 0
             imo1  = 1
             call syminp(ke,symfile,imo1,ismat,spgrp(ip),
     *                   intaus(ip),laue(ip),icent(ip),ism(1,1,1,ip),
     *                   tran(1,1,ip),nsym(ip))
           end if

c --- Reflexliste berechnen:

           xmin = thmin + pkshift(thmin,glb(1),3)
           xmax = thmax + pkshift(thmax,glb(1),3)
           call fis7(imo(ip),intaus(ip),laue(ip),icent(ip),
     *               ism(1,1,1,ip),tran(1,1,ip),nsym(ip),igeo,iord(ip),
     *               par(8,ip),par(9,ip),par(10,ip),par(11,ip),
     *               gitter(1,ip),rlamda,cthm,ctha,xmin,xmax,
     *               theta(ibeg),iref(ibeg,1),ref(1,ibeg),mult(ibeg),
     *               hwb(ibeg),rlopo(ibeg),nuq(1,ibeg),ic(ip),NORD,
     *               IRS,itemp,ltemp,rtemp)

c --- Reflexliste ausgeben:

           if(ihkl.gt.0) then
             write(*,*)
             call rezi(gitter(1,ip),cellr)
             if(ihkl.eq.2.and.imo(ip).eq.1) then
               call satwrite(6,cellr,par(11,ip),iref(ibeg,1),
     *                       mult(ibeg),theta(ibeg),ic(ip),IRS)
             else
               call hklwrite(6,imo(ip),cellr,par(11,ip),
     *                       iref(ibeg,1),mult(ibeg),theta(ibeg),
     *                       hwb(ibeg),rlopo(ibeg),ic(ip),IRS)
             end if
           end if

c --- Intensitaeten voreinstellen:

           call intsort(laue(ip),defint(ip),ratio,iref(ibeg,1),
     *                  rint(ibeg),cint(ibeg),ic(ip),IRS)

         end if

c --- Pruefen, ob die Datei mit den Intensitaets-Werten vorhanden ist:

         inquire(file=intfile(ip),exist=filex(ip))

c --- Reflexliste einlesen und sortieren:

         if(filex(ip)) then
           call intinp(ke,intfile(ip),imo(ip),iref(ibeg,1),
     *                 mult(ibeg),theta(ibeg),rlopo(ibeg),rint(ibeg),
     *                 rsig(ibeg),cint(ibeg),ic(ip),irf,IRS,ierr)
           if(ierr.eq.1) then
             stop 'Error: Cannot open intensity file.'
           else if(ierr.eq.2) then
             stop 'Error reading intensity file.'
           end if
           write(*,'(/2x,a)') 'Reflection data:'
           line = ' '
           line = '  Data file: '//intfile(ip)
           call writline(6,line,maxline)
           write(*,'(2x,a,i4/)')
     *     'Number of reflections = ',irf
           call intwrite(6,IRS,imo(ip),iref(ibeg,1),mult(ibeg),
     *                   theta(ibeg),rlopo(ibeg),rint(ibeg),
     *                   rsig(ibeg),cint(ibeg),ic(ip))
         end if

         iend = iend + ic(ip)

50    continue


c --- Gemischte hkl-Liste ausgeben:

      ibeg = 1
      nhkl = 0
      do 60 ip=1,nphase
         nhkl = nhkl + ic(ip)
         do 55 i=ibeg,nhkl
            iref(i,2) = ip
55       continue
         ibeg = nhkl + 1         
60    continue
      call indexx(IRS,theta,indx,nhkl)
      if(lhkl.eq.1) then
        write(*,*)
        call hklout(6,hklfile,imoges,titel(1),iref,mult,indx,
     *              theta,hwb,rlopo,nhkl,IRS)
      end if


c --- Kodierung der Parameter:

      write(*,'(/2(/2x,a)/)') 'Coding of variables:',
     *                        '===================='
      call parcod(cglb,cpar,cint,aglb,apar,aint,lglb,lpar,lint,
     *            ipar,iref(1,1),ic,IRS,LPHASE,nphase,nprof,MSZ,
     *            maxs,laue,imo,ratio)
      if(maxs.eq.1) then
        write(*,'(/2x,a)') '1 parameter is adjusted'
      else
        write(*,'(/2x,i4,a)') maxs,' parameters are adjusted'
      end if

c --- Feldueberlauf in OUTCYC abfangen:

      mc = mcycle * (3 * maxs + 10)
      if(mc.gt.MAPA) then
        write(*,'(2(/2x,a))') 
     *  'WARNING: Arrays will exceed in module OUTCYC.',
     *  'Please decrease the number of parameters or cycles.'
        stop
      end if

c --- Parameter anfitten:

      call jmfit_p(ix,maxs,mcycle,eps,relax,nphase,nprof,ibac,
     *             ieich,xmin,xmax,wdt,rlim,rlamda,iref(1,1),
     *             mult,theta,rlopo,hwb,corint,ic,imo,gitter,
     *             the,obs,calc,gew,bac,mit,krr,izahl,excl,iexcl,
     *             glb,aglb,lglb,par,apar,lpar,rint,aint,lint,ipar,
     *             rjac,vx,param,out,iout,chisq,rp,rwp,swobs,num,
     *             dersto,tann,deriv,mxx,myy,rjadu,vxdu,bcl,xloe,
     *             MAPA,MSZ,IEZ,IDZ,IRS,LPHASE)


c --- Parameter auf dem Bildschirm ausgeben:
 
      call outlas_p(6,ix,imo,maxs,relax,phsnm,nphase,nprof,ibac,
     *              gitter,glb,aglb,lglb,par,apar,lpar,rjac,vx,
     *              num,swobs,chisq,rp,rwp,LPHASE,MSZ)


c --- Zyklus-File anlegen:

      nr = 0
      call outfil(cycfile,inpfile,'cyc',laenge,nr)
      write(*,*)
      line = ' '
      line = '  Writing on file '//cycfile
      call writline(6,line,maxline)
      open(kcyc,file=cycfile,status='unknown',err=99986)
      idges = 1
      call outmat(kcyc,ix,idges,isp,mcycle,MAPA,MSZ,IDAT,titel,
     *            param,out,iout)


      iend = 0 
      do 65 ip=1,nphase
         ibeg = iend + 1
         iend = iend + ic(ip)

c --- "Beobachtete" Intensitaeten berechnen:

         zero = 0.
         call iobscalc(nprof,rlim,wdt,glb(1),par(1,ip),
     *                 par(2,ip),par(3,ip),obs,calc,bac,the,mit,
     *                 izahl,IDZ,excl,iexcl,IEZ,theta(ibeg),
     *                 hwb(ibeg),corint(ibeg),riobs(ibeg),ic(ip),IRS)

c ---- "Beobachtete" Intensitaeten ausgeben:

         if(istru.eq.1) then
           zero = 0.
           call iobswrite(6,imo(ip),iref(ibeg,1),mult(ibeg),
     *                    theta(ibeg),corint(ibeg),riobs(ibeg),
     *                    ic(ip),IRS)
         end if

c --- Verfeinerte Intensitaeten ausgeben:

         write(*,*)
         line = ' '
         line = '  Writing on file '//intfile(ip)
         call writline(6,line,maxline)
         call intout(ka,intfile(ip),filex(ip),imo(ip),iref(ibeg,1),
     *               mult(ibeg),theta(ibeg),rlopo(ibeg),rint(ibeg),
     *               cint(ibeg),lint(ibeg),aint(ibeg),ic(ip),IRS,
     *               rjac,MSZ,ierr)

65    continue


c --- Bragg-R-Werte berechnen, auf dem Bildschirm ausgeben und
c     ins Zyklusfile schreiben:

      idges = 1
      call rbragg(kcyc,idges,nphase,LPHASE,IRS,IDAT,riobs,corint,ic)


C --- Zyklusfile schliesen:

      close(kcyc)


c --- Plotfile anlegen:

      nr = 0
      call outfil(plotfile,inpfile,'plt',laenge,nr)
      write(*,*)
      line = ' '
      line = '  Writing on file '//plotfile
      call writline(6,line,maxline)
      call plotout(ka,plotfile,titel(1),step,temp,glb(1),
     *             obs,calc,bac,the,mit,izahl,IDZ)


c --- (hkl)-Datei anlegen:

      nr = 0
      call outfil(hklfile,inpfile,'hkl',laenge,nr)
      write(*,*)
      line = ' '
      line = '  Writing on file '//hklfile
      call writline(6,line,maxline)
      nhkl = ic(1) + ic(2)
      call hklout(ka,hklfile,imoges,titel(1),iref,mult,indx,
     *            theta,hwb,rlopo,nhkl,IRS)


C --- Neue Eingabe-Datei anlegen:

      call savinp(ke,ka,inpfile,savefile)
      outfile = inpfile
      write(6,'(/2x,a)') 'Creating a new INPUT file.'
      call parneu(ke,ka,savefile,outfile,imo,ibac,nphase,rlamda,
     *            ratio,thmin,thmax,gitter,glb,par,LPHASE)


c --- Datum und Uhrzeit ausgeben:

      call datum(date,time)
      write(*,'(/2x,a,4x,a/)') date,time  
      goto 99999


c --- Fehlermeldungen:

99986 stop 'Cannot open CYCLE file'


99999 continue
      end

c******************************************************************************
c*** Bereiche bestimmen, die bei der Verfeinerung beruecksichtigt werden    ***
c******************************************************************************

      subroutine assign(the,krr,mit,izahl,IDZ,LPHASE,glb,wdt,nphase,
     *                  xmin,xmax,excl,iexcl,IEZ,theta,hwb,ic,IRS)

      external pkshift
      parameter(PI = 3.14159265359)
      integer krr(2,LPHASE,IDZ), mit(IDZ), ic(LPHASE) 
      integer ibeg(10), iend(10)
      real theta(IRS), hwb(IRS), the(IDZ), glb(10), excl(2,IEZ)


      ia = 0
      do 20 ip=1,nphase
         iend(ip) = ia + ic(ip)
         ibeg(ip) = ia + 1
         ia = iend(ip)
20    continue      

      do 500 n=1,izahl

         mit(n) = 0
         do 40 ip=1,nphase
            krr(1,ip,n) = 0
            krr(2,ip,n) = 0
40       continue

c --- "Excluded regions" beruecksichtigen:

         do 60 ie=1,iexcl
            if((the(n).gt.excl(1,ie)).and.
     *         (the(n).lt.excl(2,ie))) then
              mit(n) = -1    
              goto 500
            end if
60       continue

         thecor = the(n) + pkshift(the(n),glb(1),3)

         do 200 ip=1,nphase

c            write(*,'(1x,a,f8.3,3(a,i5))') 
c     *      'thecor=',thecor,'   ibeg=',ibeg(ip),
c     *      '   iend=',iend(ip),'   ip=',ip

            k = 0
            do 100 i=ibeg(ip),iend(ip)
               thobs = 360./PI * theta(i)
               rmin  = thobs - wdt * hwb(i)
               rmax  = thobs + wdt * hwb(i)  
               rmin  = amax1(rmin,xmin)
               rmax  = amin1(rmax,xmax)
               if(rmin.le.thecor.and.rmax.ge.thecor) then
                 k = k + 1
                 if(k.eq.1) krr(1,ip,n) = i
               else if(rmin.gt.thecor) then
                 goto 150
               end if
100         continue

150         if(k.gt.0) then
              mit(n) = 1
              ibeg(ip) = krr(1,ip,n)
              krr(2,ip,n) = krr(1,ip,n) + k - 1
            end if

c            if(krr(1,ip,n).gt.0) 
c     *        write(*,'(1x,2(a,i5),a)') 
c     *        '***** krr1=',krr(1,ip,n),'   krr2=',krr(2,ip,n),' *****'

200      continue

500   continue

      return
      end


c******************************************************************************
c***   Bestimmung des Untergrunds aus Untergrund-Stuetzpunkten              ***
c******************************************************************************

      subroutine bacalc(pos,bck,ibck,IBZ,the,bac,izahl,IDZ)

      real the(IDZ), bac(IDZ), pos(IBZ), bck(IBZ)


c --- Ersten Stuetzpunkt bestimmen, der unterhalb the(1) liegt, und falls 
c     keiner unterhalb liegt, den Stuetzpunkt bck(1) an der Stelle pos(1) 
c     nehmen:

      do 10 k=ibck,1,-1
         if(pos(k).lt.the(1)) then
           ib1 = k
           ibeg = 1
           goto 15
         end if
10    continue

c --- Untergrund bestimmen, falls kleinster Untergrundstuetzpunkt
c     groesser als the(1) ist:

      do 12 n=1,izahl
         if(the(n).lt.pos(1)) then
           bac(n) = bck(1)
         else
           ib1 = 1
           ibeg = n
           goto 15
         end if
12    continue


c --- Letzten Stuetzpunkt bestimmen, der oberhalb the(izahl) liegt, und
c     falls keiner oberhalb liegt, den Stuetzpunkt bck(ibck) an der 
c     Stelle pos(ibck) nehmen:

15    do 20 k=1,ibck
         if(pos(k).gt.the(izahl)) then
           ib2 = k
           iend = izahl
           goto 25
         end if
20    continue


c --- Untergrund bestimmen, falls groesster Untergrundstuetzpunkt
c     kleiner als the(izahl) ist:

      do 22 n=izahl,ibeg,-1
         if(the(n).gt.pos(ibck)) then
           bac(n) = bck(ibck)
         else
           ib2 = ibck
           iend = n
           goto 25
         end if
22    continue


c --- Untergrund-Berechnung im Bereich der Untergrund-Werte:

25    if(ib1.lt.ib2) then
        do 100 k=ib1,ib2
           diff = pos(k+1) - pos(k)
           if(diff.eq.0.) goto 100
           stg  = (bck(k+1) - bck(k))/diff
           do 50 n=ibeg,iend
              if(the(n).gt.pos(k+1)) then
                ibeg = n
                goto 100
              else
                bac(n) = stg * (the(n) - pos(k)) + bck(k)
              end if
50         continue 
100     continue
      end if


      return
      end


C******************************************************************************
C***            Einlesen der Untergrund-Daten                               ***
C******************************************************************************

      subroutine bacinp(ke,bacfile,pos,bck,ibck,IBZ,excl,iexcl,IEZ)

      character string*20, title*70, bacfile*80
      real pos(IBZ), bck(IBZ), excl(2,IEZ)

      ix = 0


c --- Oeffnen des Files:

      open(ke,file=bacfile,status='old',err=1200)


c --- Titel lesen:

      read(ke,'(a)') title
      write(*,'(2x,a,a)') 'Title: ',title

c --- Untergrund-Werte einlesen:

      i=0
10    read(ke,'(a)',end=1000,err=1300) string

        do 20 k=1,18
           if(string(k:k+2).eq.'EXC'.or.
     *        string(k:k+2).eq.'exc') then
             ix = 1
             goto 1000
           end if
20      continue

        i=i+1
        if(i.gt.IBZ) then
          write(*,'(2x,a,i3,/2x,a,i3,a)')
     *    'Number of background data > ',IBZ, 
     *	  'Only ',IBZ,' background data are allowed'
          stop
        end if
        backspace ke
        read(ke,*,err=1300) pos(i), bck(i)

      goto 10


1000  ibck = i 
      write(*,'(2x,a,i3)')
     *'Number of background data = ',ibck


c --- Excluded regions einlesen, falls ix=1:

      if(ix.eq.1) then
        i=0
50      read(ke,*,end=60,err=1400) x,y 
	  i=i+1
          if(i.gt.IEZ) then
	    write(*,'(2x,a,i3,/2x,a,i3,a)') 
     *      'Number of excluded regions > ',IEZ,
     *      'Only ',IEZ,' are allowed'
            stop
          end if
          excl(1,i) = x
          excl(2,i) = y 
	goto 50
60      iexcl = i
      end if

      write(*,'(2x,a,i2)') 
     *'Number of excluded regions = ',iexcl


C --- File schliessen:

      close(ke)
      return


1200  stop ' Cannot open background data file'
1300  close(ke)
      stop ' Error reading background data'
1400  close(ke)
      stop ' Error reading excluded regions' 

      end


c******************************************************************************
c***    Gefitteter Untergrund berechnen, incl. der Ableitungen              ***
c******************************************************************************

      subroutine backgr(back,the,xmin,xmax,glb,lglb,aglb,deriv,
     *           maxs,MSZ)

      integer lglb(10)
      real glb(10), aglb(10), deriv(MSZ), dc(6)

      dc(1) = 1.
      back = glb(4)
      arg = (the - (xmax+xmin)/2.)/(xmax-xmin)*2.
      do 100 i=2,6
         dc(i) = arg**(i-1)  
         back = back + glb(3+i) * dc(i)
 100  continue

      do 200 k=1,maxs
         do 170 i=4,9
            if(lglb(i).eq.k) deriv(k) = deriv(k) + aglb(i) * dc(i-3)
 170     continue
 200  continue

      return
      end
c******************************************************************************
c***               Berechnung der Ableitungen und ycalc                     ***
c******************************************************************************
 
      subroutine calcxn_p(ycalc,the,thecor,krr,nprof,nphase,LPHASE,
     *                    rlim,lglb,par,lpar,lint,dersto,deriv,
     *                    maxs,MSZ,tann,theta,hwb,corint,IRS)

      parameter (PI = 3.14159265359, NP = 3)
      integer lglb(10), lpar(19,LPHASE), lint(IRS), krr(2,LPHASE)
      real deriv(MSZ), dersto(MSZ,IRS), tann(IRS), dprof(NP)
      real par(19,LPHASE), theta(IRS), hwb(IRS), corint(IRS) 


      do 600 ip=1,nphase
         if(krr(1,ip).gt.0) then
           do 500 i=krr(1,ip),krr(2,ip)

	      thobs = 360./PI * theta(i) 
              delt  = thecor - thobs

c --- Asymmetrie-Korrektur:

              if(thobs.le.rlim) then
                if(delt.ne.0.) then
                  s = sign(1.,delt)
                else
                  s = 0.
                end if
                xy  = delt * delt * s / tann(i)
                das = 2. * xy / delt * par(3,ip)
                as  = 1. - xy * par(3,ip)  
              else
                das = 0.
                xy  = 0.
                as  = 1.
              end if

c --- Profilberechnung:

              x = delt/hwb(i)
              call profil(nprof,x,par(1,ip),par(2,ip),prof,dprof,NP)
              prof  = prof/hwb(i)
              omega = as * prof 
              ycalc = ycalc + omega * corint(i) 

c --- Schleife ueber alle Parameter: Berechnung der Ableitungen:
 
              do 300 k=1,maxs

c --- Nullpunkt, peak shift parameters und Wellenlaenge:

	         if(lglb(1).eq.k) 
     *             deriv(k) = deriv(k) + dersto(k,i) * 
     *                        (das*prof + as*dprof(1)/hwb(i)/hwb(i)) 
	         if(lglb(2).eq.k) 
     *             deriv(k) = deriv(k) + dersto(k,i) * the *
     *                        (das*prof + as*dprof(1)/hwb(i)/hwb(i)) 
	         if(lglb(3).eq.k) 
     *             deriv(k) = deriv(k) + dersto(k,i) * the**2. *
     *                        (das*prof + as*dprof(1)/hwb(i)/hwb(i)) 
	         if(lglb(10).eq.k) 
     *             deriv(k) = deriv(k) - dersto(k,i) * 
     *                        (das*prof + as*dprof(1)/hwb(i)/hwb(i)) 

c --- eta_1 (Pseudo-Voigt/Pearson VII/1.Parameter der Edgeworth Reihe):

	         if(lpar(1,ip).eq.k) 
     *             deriv(k) = deriv(k) + 
     *                        dersto(k,i) * dprof(2)/hwb(i) * as

c --- eta_2 (2. Parameter der Edgeworth Reihe):

	         if(lpar(2,ip).eq.k) 
     *             deriv(k) = deriv(k) + 
     *                        dersto(k,i) * dprof(3)/hwb(i) * as

c --- Asymmetrie-Parameter:

	         if(lpar(3,ip).eq.k)
     *             deriv(k) = deriv(k) - dersto(k,i) * xy * prof

c --- Halbwertsbreite-Parameter U, V, W:

	         do 110 m=8,10
		    if(lpar(m,ip).eq.k)
     *                deriv(k) = deriv(k) - dersto(k,i) * as *
     *                           (x*dprof(1)/hwb(i) + prof)/hwb(i) 
110              continue

c --- q-Vektor und Gitterkonstanten:

	         do 120 m=11,19
		    if(lpar(m,ip).eq.k)
     *                deriv(k) = deriv(k) + dersto(k,i) * 
     *                (das*prof - as*dprof(1)/hwb(i)/hwb(i)) 
120              continue

c --- Intensitaeten:

                 if(lint(i).eq.k)
     *             deriv(k) = deriv(k) + dersto(k,i) * omega

300           continue

500        continue    
         end if
600   continue

      return
      end


c******************************************************************************
c***                       Datenfile einlesen                               ***
c******************************************************************************

      subroutine datinp(ke,IDZ,datfile,thmin,thmax,step,temp,izahl,
     *                  the,obs,gew,bac)

      parameter(max=8)

      character datfile*80, title*70, filspe*3, char(max)*132
      real the(IDZ), obs(IDZ), gew(IDZ), bac(IDZ), werte(max)


c --- Datenfile oeffnen:

      open(ke,file=datfile,status='old',err=1100)


C --- Titel einlesen:

10    ist = 1
      call getinp(ke,'   ','   ',werte,char,max,num,nn,ist)
      if(ist.eq.11.or.ist.eq.13) goto 1000
      if(char(1)(1:3).ne.'DAT'.and.char(1)(1:3).ne.'dat'.and.
     *   char(1)(1:3).ne.'DUO'.and.char(1)(1:3).ne.'duo'.and.
     *   char(1)(1:3).ne.'NEU'.and.char(1)(1:3).ne.'neu') then
        backspace(ke)
        read(ke,'(a)',end=1000,err=1200) title
        write(*,'(2x,2a)') 'Title: ',title
        goto 10
      end if
      if(num.ne.8) goto 10

c --- Kopfzeile einlesen:

c      ist = 1
c      call getinp(ke,'   ','   ',werte,char,max,num,nn,ist)
      filspe = char(1)(1:3)
c        zeit   = werte(2)
        bla    = werte(3)
        step   = werte(4)
        ble    = werte(5)
        temp   = werte(6)
c        iblock = nint(werte(7))
        num    = nint(werte(8)) 


c --- Daten einlesen:

      izahl = nint((ble-bla)/step) + 1

      if(filspe.eq.'DUO'.or.filspe.eq.'duo') then
        call duoein(ke,IDZ,thmin,thmax,bla,step,izahl,obs,gew,the)
      else if(filspe.eq.'NEU'.or.filspe.eq.'neu') then
        call greein(ke,IDZ,thmin,thmax,bla,step,izahl,obs,gew,the)
      else
        call datein(ke,IDZ,thmin,thmax,izahl,obs,gew,bac,the)
      end if


c --- Datei schliessen:

      close(ke)


c --- Parameter des Datensatzes ausgeben:

      thmin = the(1)
      thmax = the(izahl)
      write(*,'(2x,a,f12.6,a,f12.4,/2x,a,f12.5,a,f12.5,/2x,a,i5)')
     *'stepwidth = ',step,'    temperature = ',temp,
     *'2theta minimum = ',thmin,'    2theta maximum = ',thmax,
     *'Number of values = ',izahl

      return


c -- Fehlermeldungen:

1000  stop ' Data file is empty' 
1100  stop ' Cannot open data file'  
1200  stop ' Error reading data file'

      end


C******************************************************************************
C***                       Datenfile einlesen                               ***
C******************************************************************************

      subroutine datein(ke,IDZ,thmin,thmax,izahl,obs,gew,bac,the)

      real obs(IDZ), gew(IDZ), bac(IDZ), the(IDZ)


c --- Thetabereich nicht eingeschraenkt:

      if(thmax.le.0.) then

        n = 0
10      read(ke,*,end=1000,err=1200) x, y, sigma, back
        n = n + 1
        the(n) = x
        obs(n) = y
        if(sigma.le.0.) sigma = 1.
        gew(n) = sigma * sigma
        bac(n) = back
        if(n.eq.IDZ) goto 1000
        goto 10


c --- Thetabereich eingeschraenkt:

      else

        n = 0
20      read(ke,*,end=1000,err=1200) x, y, sigma, back
        if(x.gt.thmax) goto 1000
        if(x.ge.thmin) then
          n = n + 1
          the(n) = x
          obs(n) = y
          if(sigma.le.0.) sigma = 1.
          gew(n) = sigma * sigma
          bac(n) = back
          if(n.eq.IDZ) goto 1000
        end if
        goto 20

      end if


c --- Zahl der eingelesenen Werte:

1000  izahl = n
      return


c -- Fehlermeldung:

1200  stop ' Error reading data file'

      end


C******************************************************************************
C***            Einlesen von Roentgen-Daten im DUO-Format                   ***
C******************************************************************************

      subroutine duoein(ke,IDZ,thmin,thmax,bla,step,izahl,obs,gew,the)

      real y(10)
      real obs(IDZ), gew(IDZ), the(IDZ)


200   format(8(f7.0,1x))

      iacht = izahl/8
      irest = izahl - 8*iacht

      n = 0


c --- Thetabereich nicht eingeschraenkt:

      if(thmax.le.0.) then

	do 300 i=1,iacht
	   read(ke,200,err=1200) (y(j),j=1,8)
	   do 250 j=1,8
	      n = n + 1
	      obs(n) = y(j)
	      the(n) = bla + (n-1)*step
	      if(y(j).eq.0) then 
                gew(n) = 1.
	      else
		gew(n) = y(j)
	      end if
              if(n.eq.IDZ) goto 600
250        continue
300     continue

	if(irest.ge.1) then
	  read(ke,200,err=1200) (y(j),j=1,irest)
	  do 350 j=1,irest
	     n = n + 1
	     obs(n) = y(j)
	     the(n) = bla + (n-1)*step
	     if(y(j).eq.0) then
	       gew(n) = 1.
	     else
	       gew(n) = y(j)
	     end if
             if(n.eq.IDZ) goto 600
350       continue      
	end if


c --- Thetabereich eingeschraenkt:
     
      else

        k = 0
	do 500 i=1,iacht
	   read(ke,200,err=1200) (y(j),j=1,8)
	   do 450 j=1,8
	      k = k + 1
	      winkel = bla + (k-1)*step
	      if(winkel.ge.thmin) then
		if(winkel.gt.thmax) goto 600
		n = n + 1
		obs(n) = y(j)
		the(n) = winkel
		if(y(j).eq.0.) then
		  gew(n) = 1.
		else
		  gew(n) = y(j)
		end if
                if(n.eq.IDZ) goto 600
	      end if
450        continue     
500     continue

	if(irest.ge.1) then
	  read(ke,200,err=1200) (y(j),j=1,irest)
	  do 550 j=1,irest
	     k = k + 1
	     winkel = bla + (k-1)*step
	     if(winkel.ge.thmin) then 
	       if(winkel.gt.thmax) goto 600
	       n = n + 1
	       obs(n) = y(j)
	       the(n) = winkel
	       if(y(j).eq.0.) then
		 gew(n) = 1.
	       else
		 gew(n) = y(j)
	       end if
               if(n.eq.IDZ) goto 600
	     end if
550       continue
	end if

      end if


c --- Zahl der eingelesenen Werte:

600   izahl = n
      return


c --- Fehlermeldung:

1200  stop ' Error reading data file'

      end


C******************************************************************************
C***            Einlesen von Grenobler Neutronen-Daten                      ***
C******************************************************************************

      subroutine greein(ke,IDZ,thmin,thmax,bla,step,izahl,obs,gew,the)

      real y(10)
      integer igew(10)
      real obs(IDZ), gew(IDZ), the(IDZ)


200   format(10(i2,f6.0))

      izehn = izahl/10
      irest = izahl - 10*izehn

      n = 0


c --- Thetabereich nicht eingeschraenkt:

      if(thmax.le.0.) then

	do 300 i=1,izehn
	   read(ke,200,err=1200) (igew(j),y(j),j=1,10)
	   do 250 j=1,10
	      n = n + 1
	      obs(n) = y(j)
              if(y(j).eq.0.) then
                gew(n) = 1.
              else
	        if(igew(j).eq.0) then
		  gew(n) = y(j)
	        else
		  gew(n) = y(j)/real(igew(j))
	        end if
              end if
	      the(n) = bla + (n-1)*step
              if(n.eq.IDZ) goto 600
250        continue 
300     continue

	if(irest.ge.1) then
	  read(ke,200,err=1200) (igew(j),y(j),j=1,irest)
	  do 350 j=1,irest
	     n = n + 1
	     obs(n) = y(j)
             if(y(j).eq.0.) then
               gew(n) = 1.
             else
	       if(igew(j).eq.0) then
	         gew(n) = y(j)
	       else
	         gew(n) = y(j)/real(igew(j))
	       end if
             end if
	     the(n) = bla + (n-1)*step
             if(n.eq.IDZ) goto 600
350       continue      
	end if


c --- Thetabereich eingeschraenkt:
     
      else

	k = 0
	do 500 i=1,izehn
	   read(ke,200,err=1200) (igew(j),y(j),j=1,10)
	   do 450 j=1,10
	      k = k + 1
	      winkel = bla + (k-1)*step
	      if(winkel.ge.thmin) then
		if(winkel.gt.thmax) goto 600
		n = n + 1
		obs(n) = y(j)
                if(y(j).eq.0.) then
                  gew(n) = 1.
                else
		  if(igew(j).eq.0) then
		    gew(n) = y(j)
		  else
		    gew(n) = y(j)/real(igew(j))
		  end if
                end if
		the(n) = winkel
                if(n.eq.IDZ) goto 600
	      end if
450        continue     
500     continue

	if(irest.ge.1) then
	  read(ke,200,err=1200) (igew(j),y(j),j=1,irest)
	  do 550 j=1,irest
	     k = k + 1
	     winkel = bla + (k-1)*step
	     if(winkel.ge.thmin) then 
	       if(winkel.gt.thmax) goto 600
	       n = n + 1
	       obs(n) = y(j)
               if(y(j).eq.0.) then
                 gew(n) = 1.
               else
	         if(igew(j).eq.0) then
		   gew(n) = y(j)
	         else
		   gew(n) = y(j)/real(igew(j))
	         end if
               end if
	       the(n) = winkel
               if(n.eq.IDZ) goto 600
	     end if
550       continue
	end if

      end if


c --- Zahl der eingelesenen Werte
600   izahl = n
      return


c --- Fehlermeldung:

1200  stop ' Error reading data file'

      end


c******************************************************************************
c***      Berechnet direkte Gitterkonstanten aus den reziproken             ***
c***           einschliesslich der Standardabweichungen                     ***
C******************************************************************************

      subroutine direct(cellr,stdd,celld,delta,vol,dvol)

      parameter (PI = 3.14159265359)
      real celld(6), delta(6), cellr(6), stdd(6)
      real d(6,6), t(3), r(3), dr(3,3), dt(3,3)


c --- Parameter und Variablen:

c     cellr(1) :  A*                celld(1)  :  A
c     cellr(2) :  B*                celld(2)  :  B
c     cellr(3) :  C*                celld(3)  :  C
c     cellr(4) :  cos(Alpha*)       celld(4)  :  Alpha
c     cellr(5) :  cos(Beta*)        celld(5)  :  Beta
c     cellr(6) :  cos(Gamma*)       celld(6)  :  Gamma
c     stdd(6)  :  Standardabweichungen der reziproken Gitterkonstanten
c     delta(6) :  Standardabweichungen der direkten Gitterkonstanten 
c     vol      :  Zellvolumen
c     dvol     :  Standardabweichung des Zellvolumens

c --- Sinuse der rez. Winkel:

      sinar = sqrt(1.-cellr(4)*cellr(4))
      sinbr = sqrt(1.-cellr(5)*cellr(5))
      singr = sqrt(1.-cellr(6)*cellr(6))

c --- Abkuerzungen:

      r(1) = cellr(5)*cellr(6) - cellr(4)
      r(2) = cellr(6)*cellr(4) - cellr(5)
      r(3) = cellr(4)*cellr(5) - cellr(6)
      t(1) = sinbr * singr
      t(2) = singr * sinar
      t(3) = sinar * sinbr

c --- Ableitungen von r nach den Cosinusen der rez. Winkel:

      dr(1,1) = -1.
      dr(1,2) =  cellr(6)
      dr(1,3) =  cellr(5)
      dr(2,1) =  cellr(6)
      dr(2,2) = -1.
      dr(2,3) =  cellr(4)
      dr(3,1) =  cellr(5)
      dr(3,2) =  cellr(4)
      dr(3,3) = -1.

c --- Ableitungen von t nach den Cosinusen der rez. Winkel:

      dt(1,1) =  0.
      dt(1,2) = -cellr(5)/sinbr * singr
      dt(1,3) = -cellr(6)/singr * sinbr
      dt(2,1) = -cellr(4)/sinar * singr
      dt(2,2) =  0.
      dt(2,3) = -cellr(6)/singr * sinar
      dt(3,1) = -cellr(4)/sinar * sinbr
      dt(3,2) = -cellr(5)/sinbr * sinar
      dt(3,3) =  0.

c --- Winkelanteil des reziproken Volumens und Ableitungen:

      u = sqrt(1. + 2.*cellr(4)*cellr(5)*cellr(6) -
     *    cellr(4)*cellr(4) - cellr(5)*cellr(5) - cellr(6)*cellr(6))

      dua = r(1)/u
      dub = r(2)/u
      dug = r(3)/u

c --- direkte Gitterkonstanten:

      celld(1) = sinar/cellr(1)/u
      celld(2) = sinbr/cellr(2)/u
      celld(3) = singr/cellr(3)/u

c --- Ableitungen von a, b und c nach den gesternten Groessen:

      d(1,1) = -celld(1)/cellr(1)
      d(1,2) =  0.
      d(1,3) =  0.
      d(1,4) = -celld(1)*dua/u - cellr(4)/sinar/cellr(1)/u
      d(1,5) = -celld(1)*dub/u
      d(1,6) = -celld(1)*dug/u

      d(2,1) =  0.
      d(2,2) = -celld(2)/cellr(2)
      d(2,3) =  0.
      d(2,4) = -celld(2)*dua/u
      d(2,5) = -celld(2)*dub/u - cellr(5)/sinbr/cellr(2)/u 
      d(2,6) = -celld(2)*dug/u

      d(3,1) =  0.
      d(3,2) =  0.
      d(3,3) = -celld(3)/cellr(3)
      d(3,4) = -celld(3)*dua/u
      d(3,5) = -celld(3)*dub/u
      d(3,6) = -celld(3)*dug/u - cellr(6)/singr/cellr(3)/u 

c --- Cosinuse und Sinuse der direkten Winkel:

      cosad = r(1)/t(1)
      cosbd = r(2)/t(2)
      cosgd = r(3)/t(3)

      sinad = sqrt(1.-cosad*cosad)
      sinbd = sqrt(1.-cosbd*cosbd)
      singd = sqrt(1.-cosgd*cosgd)

c --- Direkte Winkel in Grad:

      celld(4) = 180./PI * acos(cosad)
      celld(5) = 180./PI * acos(cosbd)
      celld(6) = 180./PI * acos(cosgd)

c --- Ableitungen von Alpha, Beta und Gamma nach den gesternten Groessen:

      d(4,1) =  0.
      d(4,2) =  0.
      d(4,3) =  0.
      d(4,4) = (-dr(1,1)*t(1) + r(1)*dt(1,1)) /sinad/t(1)/t(1)
      d(4,5) = (-dr(1,2)*t(1) + r(1)*dt(1,2)) /sinad/t(1)/t(1)
      d(4,6) = (-dr(1,3)*t(1) + r(1)*dt(1,3)) /sinad/t(1)/t(1)

      d(5,1) =  0.
      d(5,2) =  0.
      d(5,3) =  0.
      d(5,4) = (-dr(2,1)*t(2) + r(2)*dt(2,1)) /sinbd/t(2)/t(2)
      d(5,5) = (-dr(2,2)*t(2) + r(2)*dt(2,2)) /sinbd/t(2)/t(2)
      d(5,6) = (-dr(2,3)*t(2) + r(2)*dt(2,3)) /sinbd/t(2)/t(2)

      d(6,1) =  0.
      d(6,2) =  0.
      d(6,3) =  0.
      d(6,4) = (-dr(3,1)*t(3) + r(3)*dt(3,1)) /singd/t(3)/t(3)
      d(6,5) = (-dr(3,2)*t(3) + r(3)*dt(3,2)) /singd/t(3)/t(3)
      d(6,6) = (-dr(3,3)*t(3) + r(3)*dt(3,3)) /singd/t(3)/t(3)

c --- Fehler der direkten Gitterkonstanten:

      do 60 i=1,6
	 delta(i) = 0.
	 do 50 j=1,6
	    delta(i) = delta(i) + d(i,j)*d(i,j)*stdd(j)*stdd(j)
50       continue
	 delta(i) = sqrt(delta(i))
60    continue

c --- Zellvolumen vol und Standardabweichung dvol berechnen:

      vs = 1. + 2.*cosad*cosbd*cosgd 
     *        - cosad*cosad - cosbd*cosbd - cosgd*cosgd 
      vol = celld(1) * celld(2) * celld(3) * sqrt(vs)

      dvol = (delta(1)/celld(1))**2 + (delta(2)/celld(2))**2 +
     *       (delta(3)/celld(3))**2 + 
     *       (delta(4)/vs * sinad * (cosad - cosbd*cosgd))**2 +
     *       (delta(5)/vs * sinbd * (cosbd - cosad*cosgd))**2 +
     *       (delta(6)/vs * singd * (cosgd - cosad*cosbd))**2 
      dvol = vol * sqrt(dvol)

c --- Stdd. der Winkel in Grad umrechnen:

      delta(4) = delta(4) * 180./PI
      delta(5) = delta(5) * 180./PI
      delta(6) = delta(6) * 180./PI

      return
      end


c******************************************************************************
c***                  Eichen der 2-Theta-Skala                              ***
c******************************************************************************

      subroutine eich(th_obs,th_cal,neich,IRS,excl,iexcl,IEZ,
     *                the,izahl,IDZ)

      real th_cal(IRS), th_obs(IRS), the(IDZ), excl(2,IEZ)

      
      if(neich.eq.0) then
      
        write(*,'(2x,a,/2x,a)') 
     *       'WARNING: Number of scale data equal zero',
     *       '         Scaling on standards not possible'

      else if(neich.eq.1) then

c --- Falls es nur eine Eichlinie gibt:
       
        diff = th_cal(1) - th_obs(1)
        do 80 l=1,iexcl
           do 70 m=1,2
              excl(m,l) = excl(m,l) + diff
 70        continue
 80     continue
        do 100 k=1,izahl
           the(k) = the(k) + diff
 100    continue

      else

c --- Eichung der 2-Theta-Skala the:

        ibeg = 1
        do 500 i=1,neich-1
           stg = (th_cal(i+1)-th_cal(i))/(th_obs(i+1)-th_obs(i))
           shift = th_cal(i+1) - stg*th_obs(i+1)
           do 300 k=ibeg,izahl
              if(the(k).gt.th_obs(i+1)) then
                ibeg = k
                goto 500
              end if
              the(k) = stg*the(k) + shift
300        continue
500     continue

        do 200 k=ibeg,izahl
           the(k) = stg*the(k) + shift
200     continue

c --- Eichung der excluded regions:

        if(iexcl.gt.0) then
          do 750 l=1,iexcl
             do 700 m=1,2
                if(excl(m,l).lt.th_obs(1)) then
                  nc = 2
                else if(excl(m,l).gt.th_obs(neich)) then
                  nc = neich
                else
                  do 600 i=2,neich
                     if(th_obs(i).gt.excl(m,l)) then
                       nc = i
                     end if
 600              continue
                end if
                stg = (th_cal(nc)-th_cal(nc-1))/
     *                (th_obs(nc)-th_obs(nc-1))
                shift = th_cal(nc) - stg*th_obs(nc)
                excl(m,l) = stg * excl(m,l) + shift
 700         continue
 750      continue
        end if

      end if

      return
      end


c******************************************************************************
c***                    Eichreflexe einlesen                                ***
c******************************************************************************

      subroutine eichinp(ke,eichfile,title,th_obs,th_cal,neich,IRS)

      real th_cal(IRS), th_obs(IRS)
      character eichfile*80, title*70


      open(ke,file=eichfile,status='old',err=1000)
      read(ke,'(a)',err=1200) title

      n = 0
10    read(ke,*,err=1200,end=100) cal,obs 
      n = n + 1
      th_cal(n) = cal
      th_obs(n) = obs 
      if(n.gt.IRS) goto 100
      goto 10

100   neich = n
      write(*,'(2x,a,i4)') 'Number of reflections = ',neich
      return

1000  stop 'Cannot open SCALE file'
1200  stop 'Error reading SCALE file'

      end


c******************************************************************************
c***    Geeichte Gitterkonstanten von Silizium bei der Temperatur temp      ***
c******************************************************************************

      real function silat(temp)

c --- J. Ihringer, H. Ritter, Version vom 09.12.1996

      external yskal
      parameter(neich = 19)
      real t_eich(neich), a_eich(neich)

      data    c1,     c2,    c3,     c4,       a0,      t0 
     *    / 3.725, 5.88E-3, 124., 5.548E-4, 0.5430741, 273.2 /

c --- Eichtabelle fuer Silizium fuer 10 K < T < 190 K:

      data t_eich / 10.,  20.,  30.,  40.,  50.,  60.,  70.,  80.,
     *              90., 100., 110., 120., 130., 140., 150., 160.,
     *             170., 180., 190. /
      data a_eich / 0.5429833, 0.5429833, 0.5429832, 0.5429826,
     *              0.5429813, 0.5429794, 0.5429771, 0.5429745,
     *              0.5429720, 0.5429699, 0.5429684, 0.5429675,
     *              0.5429678, 0.5429689, 0.5429711, 0.5429743,
     *              0.5429785, 0.542983805, 0.542990051 /


c --- Silizium Temperaturgang nach der Eichtabelle fuer 0 < T < 180 K
c     nach K. G. Lyon, G. L. Salinger, C. A. Swenson and G. K. White,
c      J. Appl. Phys. 43(3), 865 (1977):

      if(temp.ge.0..or.temp.lt.180.) then

        if(temp.LE.t_eich(1)) then
          a = yskal(a_eich(1),a_eich(2),t_eich(1),t_eich(2),temp)
        else
          if(temp.ge.t_eich(neich)) then
             a = yskal(a_eich(neich-1),a_eich(neich),
     *                 t_eich(neich-1),t_eich(neich),temp)
          else
            do 30 i=1,neich-1
               if(temp.gt.t_eich(i).and.temp.le.t_eich(i+1)) then
                 a = yskal(a_eich(i),a_eich(i+1),
     *                     t_eich(i),t_eich(i+1),temp)
               end if
 30         continue
          end if
        end if

c --- Silizium-Temperaturgang fuer 180 K < T < 1500 K nach
c     Y. Okada and Y. Tokumaro, J. Appl. Phys. 56(2), 314 (1984) 

      else if(temp.ge.180..and.temp.le.1500.) then

        a = c1*(temp-t0+exp(c2*c3)*(exp(-c2*temp)-exp(-c2*t0))/c2)
        a = a + c4/2.*(temp**2.-t0**2.)
        a = (a*1E-6 + 1.)*a0

      else

        write(*,'(/2x,a)') 'Temperature out of range'
        a = 0.54309

      end if

      silat = 10. * a

      return
      end


c******************************************************************************
c***                       Function yskal                                   ***
c******************************************************************************

      real function yskal(y1,y2,x1,x2,x)

c --- J. Ihringer, Version vom 22.08.1982

c --- yskal plaziert einen zu x gehoerenden wert yskal auf eine
c     Gerade, die durch zwei Punkte (x1,y1) und (x2,y2) definiert ist
c     oder yskal skaliert x auf die y-Skala.

c     y1,y2: Minimum/Maximum der y-Skala
c     x1,x2: Minimum/Maximum der x-Skala

      yskal = (x-x1)*(y2-y1)/(x2-x1) + y1

      return
      end
c******************************************************************************
c***                     h k l - G e n e r a t o r                          ***
c******************************************************************************

c  fis7 erzeugt eine kodierte Reflexliste (iref) und berechnet die
c  dazugehoerigen Theta-Werte (theta) aller Reflexe im Winkelbereich (xmin)
c  bis (xmax) fuer die Lauegruppe (laue) unter Beruecksichtigung der
c  integralen Ausloeschung (intaus), sowie der serialen und zonalen
c  Ausloeschungen der Raumgruppe. Satellitenreflexe werden bis zur
c  Ordnung (iord) erzeugt. Der Wellenvektor (q) in Richtung der 
c  Modulationswelle ist in Einheiten der rez. Gitterkonstanten anzugeben.
c  Der hkl-Generator in fis7 ist vollstaendig neu entwickelt worden und
c  erzeugt sowohl die Basis- als auch die Satelliten-/Ueberstruktur-Reflexe.

      subroutine fis7(imo,intaus,laue,icent,ism,tran,nsym,igeo,iord,
     *                uu,vv,ww,q,celld,rlamda,cthm,ctha,xmin,xmax,
     *                theta,iref,ref,mult,hwb,rlopo,nuq,nhkl,NORD,IRS,
     *                itemp,ltemp,rtemp)

      parameter (PI = 3.14159265359)
      external lorpol      
      character intaus*1, clau(15)*10
      real q(3), rtemp(IRS), lorpol
      real tran(3,48), celld(6), cellr(13), rlamda(2)
      real theta(IRS), ref(3,IRS), hwb(IRS), rlopo(IRS)
      integer iref(IRS), mult(IRS), nuq(2*NORD+1,IRS)
      integer itemp(IRS), ltemp(IRS), ism(3,3,48)

c --- Eingabe-Daten:

c     IRS:         Maximale Zahl der Reflexe
c     NORD:        Max. Ordnung der Satelliten
c     intaus:      Integrale Ausloeschung (P, F, I, ...)
c     laue:        Nummer der Lauegruppe
c     icent:       Zentrosymmetrie (1 = nein, 2 = ja)
c     ism:         Rotationsmatrizen der Symmetrieelemente der Raumgruppe
c     tran:        Translationsvektoren  der Symmetrieelemente der Raumgruppe
c     nsym:        Zahl der Symmetrieelemente
c     iord:        maximale Ordnung der Satelliten
c     igeo:        Diffraktometer-Typ
c     q(3):        Wellenvektor
c     rlamda(2):   Wellenlaengen
c     xmin,xmax:   kleinster/groesster 2-Theta-Wert
c     celld(6):    direkte Gitterkonstanten
c     uu, vv, ww:  Halbwertsbreite-Parameter
c     cthm         Monochromatorwinkel
c     ctha         Analysatorwinkel

c --- Variablen und Parameter in FIS7:

c     icr:         Nummer des Kristallsystems
c     tmi,tma:     Theta_min, Theta_max 
c     nz,iz:       Parameter aus dem Modul EXTIN 
c     hmax,kmax,lmax: Maximale hkl-Werte
c     ref(3,IRS):  Ort der Reflexe im rez. Raum
c     cellr(13):   rez. Gitterkonstanten (a', b', c', cos(alpha'),
c                  cos(beta'), cos(gamma'), ...)
c     clau(15):    Namen der Lauegruppen
c     itemp,ltemp,temp: Hilfs-Felder in der Subroutine sort
c     lorpol:      Function, die den LoPo zur Geometrie igeo berechnet:

c --- Ausgabe-Daten:

c     nhkl:       Zahl der erzeugten Reflexe
c     iref(IRS):  kodierte Miller'sche Indizes
c     theta(IRS): Theta-Werte der Reflexe
c     mult(IRS):  Multiplizitaet
c     hwb(IRS):   Halbwertsbreite
c     rlopo(IRS): Lorentz-Polarisationsfaktor
c     nuq(2*NORD+1,IRS): Ordnung der Reflexe, die zum Reflex i beitragen


c --- Lauegruppen:

      data clau(1),clau(2),clau(3),clau(4),clau(5),clau(6),clau(7),
     *     clau(8),clau(9),clau(10),clau(11),clau(12),clau(13),
     *     clau(14),clau(15)
     *  /'1bar','2/m (C)','mmm','4/m','4/mmm','3bar ','3bar m 1',
     *   '6/m','6/mmm','m3','m3m','2/m (B)','3bar (R)','3bar m (R)',
     *   '3bar 1 m'/


c --- Lauegruppe ueberpruefen:

      if(laue.ge.1.and.laue.le.15) then
        write(*,'(/2x,a,a,a)') 'Laue symmetry ',clau(laue),
     *  ' will be used to generate indices.'
        if(imo.eq.1) write(*,'(2x,a,3f9.5)') 
     *    'Wave vector = ',(q(i),i=1,3)
      else
        write(*,'(/2x,a,i2/)') 'Unknown Laue group : ',laue
        stop
      end if

c --- ???

      rai = 2.*sin(xmax*PI/360.)/rlamda(1)
      if(rlamda(2).gt.0.001.and.rlamda(2).lt.rlamda(1)) then
        rai = rai*rlamda(1)/rlamda(2)
      end if

c --- Winkelbereich:

      tmi = xmin
      tma = xmax
      if(rlamda(2).gt.rlamda(1)) then
        tmi = xmin*(rlamda(1)/rlamda(2))**2
      end if

c --- reziproke Gitterkonstanten berechnen:

      call rezi(celld,cellr)

c --- Reflexe generieren:

      if(imo.eq.1) then
        call hklgen(intaus,laue,icent,ism,tran,nsym,iord,tmi,tma,rai,
     *              celld,cellr,rlamda,q,iref,ref,mult,theta,nhkl,IRS)
      else
        call fisgen(intaus,laue,icent,ism,tran,nsym,tmi,tma,rai,celld,
     *              cellr,rlamda,iref,mult,theta,nhkl,IRS)
      end if

c --- Zahl der Reflexe ausgeben:

      if(nhkl.gt.0) then
        write(*,'(/2x,a,i6)') 'Number of reflections : ',nhkl
      else
        write(*,'(/2x,a,f8.3,a,f8.3/)')
     *  'No reflections in the region',xmin,' - ',xmax
        stop
      end if

c --- Reflexe nach Theta sortieren:

      call sort(theta,iref,mult,itemp,ltemp,rtemp,nhkl,IRS)

c --- Voreinstellungen zur LoPo-Berechnung:
c     Guinier-Geometrie: 2-Theta-Monochromator = 27.2 (Germanium-(111))
c     Bragg-Brentano:    2-Theta-Monochromator = 28.06 (Silizium-(111))
c     Synchrotron:       d-Wert-Analysator     = 0.15373 (Germanium-(111))

      if(igeo.eq.1.or.igeo.eq.2.or.igeo.eq.6) then
        if(cthm.le.10.) cthm = 27.2
      else if(igeo.eq.3) then
        if(cthm.le.10.) cthm = 28.06
      else if(igeo.eq.4) then
        if(ctha.lt.0.01) ctha = 360./PI * asin(0.15373 * rlamda(1))
      end if

c --- Halbwertsbreiten, LoPo und Multiplizitaeten berechnen und
c     Satellitenbeitraege bestimmen:

      do 300 k=1,nhkl
         if(imo.eq.1) call satfis(iref(k),iord,q,ism,tran,nsym,
     *                            intaus,icent,nuq(1,k),NORD)
         sinth    = sin(theta(k))
         tanth    = sinth/sqrt(1.-sinth*sinth)
         rlopo(k) = lorpol(igeo,cthm,ctha,theta(k))
         hwb2     = uu*tanth*tanth + vv*tanth + ww
         if(hwb2.le.0.) then
           th = 360./PI*theta(k)
           write(*,'(/2x,a,f7.3,a)') 
     *     'ERROR: Fwhm at 2theta = ',th,' degree lower or equal zero.'
           stop
         end if
         hwb(k)   = sqrt(hwb2)
300   continue


      return
      end


c******************************************************************************
c***                        hkl-Generator                                   ***
c******************************************************************************

      subroutine hklgen(intaus,laue,icent,ism,tran,nsym,iord,tmi,
     *                  tma,rai,celld,cellr,rlamda,q,iref,ref,mult,
     *                  theta,nhkl,IRS)

      external icodhkl, loesch, extin2, hhcalc
      parameter (PI = 3.14159265359, EPSY = 0.00001)

      character intaus*1
      real tran(3,48), hs(3,48), h(3)
      real cellr(13), q(3), ref(3,IRS), rlamda(2), celld(6)
      real theta(IRS)
      integer isml(3,3,48), ism(3,3,48)
      integer iref(IRS), mult(IRS), h_min, h_max, icodhkl, extin2


c --- Integrale Ausloeschungsregel ausgeben:

      if(intaus.eq.'P') then
        write(*,'(2x,a)') 'No extinction'
      else if(intaus.eq.'I') then
        write(*,'(2x,a)') 'h, k and l only with h + k + l = 2n'
      else if(intaus.eq.'A') then
        write(*,'(2x,a)') 'h, k and l only with k + l = 2n'
      else if(intaus.eq.'B') then
        write(*,'(2x,a)') 'h, k and l only with h + l = 2n'
      else if(intaus.eq.'C') then
        write(*,'(2x,a)') 'h, k and l only with h + k = 2n'
      else if(intaus.eq.'F') then
        write(*,'(2x,a)') 
     *  'h, k and l only with h + k = 2n, h + l = 2n and k + l = 2n'
      else if(intaus.eq.'R') then
        write(*,'(2x,a)') 'h, k and l only with -h + k + l = 3n'
      end if

c --- Symmetrieelemente der Lauegruppe ermitteln:

      call symlaue(laue,isml,lsym)

c --- Anzahl der Wellenlaengen bestimmen:

      lxn = 2
      if(rlamda(2).le.0.001.or.rlamda(2).eq.rlamda(1)) lxn = 1

c --- hkl's generieren:

      nhkl = 0
      do 500 is=1,-1,-2
         ia = 0
         if(is.lt.0) ia = -1
      do 400 in=ia,is*iord

         h_max = int(rai*celld(1) - in*q(1))
         k_max = int(rai*celld(2) - in*q(2)) 
         l_max = int(rai*celld(3) - in*q(3))
        
         h_min = int(-rai*celld(1) - in*q(1))
         k_min = int(-rai*celld(2) - in*q(2)) 
         l_min = int(-rai*celld(3) - in*q(3))

         do 300 ih=h_max,h_min,-1
            do 200 ik=k_max,k_min,-1
               do 100 il=l_max,l_min,-1
                  call hvec(ih,ik,il,in,q,h)
                  call multp(isml,lsym,h,hs,mlt)
                  do 95 k=1,nhkl
                     do 75 n=1,mlt
                        if(abs(hs(1,n)-ref(1,k)).lt.EPSY.and.
     *                     abs(hs(2,n)-ref(2,k)).lt.EPSY.and.
     *                     abs(hs(3,n)-ref(3,k)).lt.EPSY) goto 100
 75                  continue
 95               continue
                  if(extin2(ih,ik,il,intaus).eq.1) goto 100
                  if(loesch(ih,ik,il,icent,ism,tran,nsym).eq.1) goto 100
                  hh = hhcalc(hs(1,1),cellr)
                  do 99 iq=1,lxn
                     sqt = hh * rlamda(iq)*rlamda(iq)/4.
                     if(sqt.lt.1.) then
                       sinth  = sqrt(sqt)
                       th = asin(sinth)
                       thobs = th * 360./PI
                       if(thobs.ge.tmi.and.thobs.le.tma) then
                         nhkl = nhkl + 1
                         if(nhkl.gt.IRS) then
                           write(*,'(/2x,a,/2x,a)')
     *                     'Too many reflections!!!',
     *                     'Please, select a smaller theta region.'
                           stop
                         end if
                         iref(nhkl)  = icodhkl(ih,ik,il,in,iq)
                         mult(nhkl)  = mlt
                         theta(nhkl) = th
                         do 97 i=1,3
                            ref(i,nhkl) = hs(i,1)
 97                      continue
                       end if
                     end if
 99               continue
 100           continue
 200        continue
 300     continue
 400  continue
 500  continue

      return
      end


c******************************************************************************
c***             Reziproken Gittervektor h berechnen                        ***
c******************************************************************************

      subroutine hvec(ih,ik,il,in,q,h)

      real q(3), h(3)

      h(1) = ih + in * q(1)
      h(2) = ik + in * q(2)
      h(3) = il + in * q(3)
 
      return
      end


c******************************************************************************
c***           Betrag des rez. Gittervektors h berechnen                    ***
c******************************************************************************

      real function hhcalc(h,cellr)

      real cellr(13), h(3)
 
      hh = h(1) * h(1) * cellr(7)  + h(2) * h(2) * cellr(8) + 
     *     h(3) * h(3) * cellr(9)  + h(1) * h(2) * cellr(12) + 
     *     h(1) * h(3) * cellr(11) + h(2) * h(3) * cellr(10)

      hhcalc = hh
      return
      end


c******************************************************************************
c***                Multiplizitaeten bestimmen                              ***
c******************************************************************************

      subroutine multp(ism,nsym,h,hs,mlt)

      parameter(EPSY = 0.00001)
      real h(3), z(3), hs(3,48)
      integer ism(3,3,48)

      mlt = 0
      do 100 n=1,nsym
         do 50 i=1,3
            z(i) = 0.
            do 40 j=1,3
               z(i) = z(i) + ism(j,i,n) * h(j)
 40         continue
 50      continue
         do 60 k=1,mlt
            if(abs(hs(1,k)-z(1)).lt.EPSY.and.
     *         abs(hs(2,k)-z(2)).lt.EPSY.and.
     *         abs(hs(3,k)-z(3)).lt.EPSY) goto 100
 60      continue
         mlt = mlt + 1
         do 70 i=1,3
            hs(i,k) = z(i)
 70      continue
 100  continue

      return
      end


c******************************************************************************
c***           Symmetrieelemente der Lauegruppe bestimmen                   ***
c******************************************************************************

      subroutine symlaue(laue,ism,nsym)

      character laugrp*60, intaus*1
      real tran(3,48)
      integer ism(3,3,48)

      if(laue.eq.1) then
        laugrp = 'P, 1B,,'
      else if(laue.eq.2) then
        laugrp = 'P,1,1,2/M'
      else if(laue.eq.3) then
        laugrp = 'P,2/M,2/M,2/M'
      else if(laue.eq.4) then
        laugrp = 'P,4/M,,'
      else if(laue.eq.5) then
        laugrp = 'P,4/M,2/M,2/M'
      else if(laue.eq.6) then
        laugrp = 'P,3B,,'
      else if(laue.eq.7) then
        laugrp = 'P,3B,2/M,1'
      else if(laue.eq.8) then
        laugrp = 'P,6/M,,'
      else if(laue.eq.9) then
        laugrp = 'P,6/M,2/M,2/M'
      else if(laue.eq.10) then
        laugrp = 'P,M,3B,,'
      else if(laue.eq.11) then
        laugrp = 'P,4/M,3B,2/M'
      else if(laue.eq.12) then
        laugrp = 'P,1,2/M,1'
      else if(laue.eq.13) then
        laugrp = 'R,3B,,,R' 
      else if(laue.eq.14) then
        laugrp = 'R,3B,,,R'
      else if(laue.eq.15) then
        laugrp = 'P,3B,1,2/M'
      end if
      call symint(laugrp,intaus,nl,icent,ism,tran,ns)
      do 25 n=1,ns
         do 15 i=1,3
            do 10 j=1,3
               ism(j,i,ns+n) = -ism(j,i,n)
 10         continue
 15      continue
 25   continue
      nsym = 2 * ns

      return
      end


c******************************************************************************
c***          Sortieren der Reflexe nach steigendem Theta                   ***
c******************************************************************************

      subroutine sort(theta,iref,mult,itemp,l,temp,nhkl,IRS)

      real theta(IRS), temp(IRS)
      integer iref(IRS), mult(IRS), itemp(IRS), l(IRS)


      do 2 i=1,nhkl
         l(i) = i
2     continue
      m = nhkl - 1

      do 15 ll=1,IRS
         k = 0
         do 10 j=1,2
            do 10 i=j,m,2
               inp  = l(i)
               inp1 = l(i+1)
               r = theta(inp1) - theta(inp)   
               if(r.le.0) then
                 iz     = l(i)
                 l(i)   = l(i+1)
                 l(i+1) = iz
                 k = k + 1
               end if
10          continue
         if(k.eq.0) goto 5
15    continue

5     do 30 i=1,nhkl
         itemp(i) = iref(i)
30    continue
      do 31 i=1,nhkl
         lx = l(i)
         iref(i) = itemp(lx)
31    continue

      do 32 i=1,nhkl
         itemp(i) = mult(i)
         temp(i)  = theta(i)
32    continue
      do 33 i=1,nhkl
         lx = l(i)
         mult(i) = itemp(lx)
         theta(i) = temp(lx)
33    continue
      

      return
      end


c******************************************************************************
c***                 Integrale Ausloeschung ermitteln                       ***
c******************************************************************************

      integer function extin2(ih,ik,il,intaus)

      parameter(PII = 6.28318530718, EPSY = 0.00001)
      integer nt(7)
      real tr(3,4,7)
      character*1 intaus

      data nt /1,2,2,2,2,4,3/
      data (tr(i,1,1),i=1,3)         / 0.0 , 0.0, 0.0 /
      data ((tr(i,n,2),i=1,3),n=1,2) / 0.0, 0.0, 0.0,  0.5, 0.5, 0.5 /
      data ((tr(i,n,3),i=1,3),n=1,2) / 0.0, 0.0, 0.0,  0.0, 0.5, 0.5 /
      data ((tr(i,n,4),i=1,3),n=1,2) / 0.0, 0.0, 0.0,  0.5, 0.0, 0.5 /
      data ((tr(i,n,5),i=1,3),n=1,2) / 0.0, 0.0, 0.0,  0.5, 0.5, 0.0 /
      data ((tr(i,n,6),i=1,3),n=1,4) / 0.0, 0.0, 0.0,  0.5, 0.5, 0.0,
     *                                 0.5, 0.0, 0.5,  0.0, 0.5, 0.5 /
      data ((tr(i,n,7),i=1,3),n=1,3) 
     *                           / 0.00000000, 0.00000000, 0.00000000,  
     *                             0.33333333, 0.66666667, 0.66666667,
     *                             0.66666667, 0.33333333, 0.33333333/


c --- Nummer der integralen Ausloeschung bestimmen: 

      if(intaus.eq.'P') then
        ma = 1
      else if(intaus.eq.'I') then
        ma = 2
      else if(intaus.eq.'A') then
        ma = 3
      else if(intaus.eq.'B') then
        ma = 4
      else if(intaus.eq.'C') then
        ma = 5
      else if(intaus.eq.'F') then
        ma = 6
      else if(intaus.eq.'R') then
        ma = 7
      end if

c --- Auf int. Ausloeschung testen:

      s1 = 0.
      s2 = 0.
      do 100 k=1,nt(ma)
         arg = ih * tr(1,k,ma) + ik * tr(2,k,ma) + il * tr(3,k,ma)
         arg = arg * PII
         s1 = s1 + cos(arg)
         s2 = s2 + sin(arg)
 100  continue

      iaus = 0
      if(abs(s1).lt.EPSY.and.abs(s2).lt.EPSY) iaus = 1
      extin2 = iaus

      return
      end


c******************************************************************************
c***         Beitraege der Satelliten zu einem Reflex finden                ***
c******************************************************************************

      subroutine satfis(iref,iord,q,ism,tran,nsym,intaus,icent,nuq,NORD)

      parameter(PI = 3.14159265359, EPSY = 0.00001)

      external loesch, extin2
      integer h0(3), nuq(2*NORD+1), ism(3,3,48), extin2
      real q(3), h(3), tran(3,48)
      character intaus*1


      do 10 k=1,2*NORD+1
         nuq(k) = 999
 10   continue

      call dcodhkl(iref,ih,ik,il,in,iq)
      call hvec(ih,ik,il,in,q,h)

      j = 0 
      do 15 k=-iord,iord
         do 14 l=1,3
            hk = h(l) + k*q(l)
            h0(l) = nint(hk)
            if(abs(h0(l)-hk).gt.EPSY) goto 15
 14      continue
         if(extin2(h0(1),h0(2),h0(3),intaus).eq.1) goto 15
         if(loesch(h0(1),h0(2),h0(3),icent,ism,tran,nsym).eq.1) goto 15
         j = j + 1
         nuq(j) = -k
 15   continue

      return
      end
       

C******************************************************************************
C***                   Integrale Ausloeschungen                             ***
C******************************************************************************

      SUBROUTINE EXTIN(ICR,IH,IK,IL,KO,IRWC,NA,IZ,INTAUS)
       
C --- J. Ihringer, 31-MAI-77
C     J. Maichle, VAX-Version vom DEC-86
C     H. Ritter, ueberarbeitet fuer SIMREF 2.0 im JUL-1991

       
C --- Eingabeparameter sind:
C     ICR       :  Nr. des Kristallsystems
C     IH,IK,IL  :  Miller'sche Indizes des Reflexes (IH,IK,IL)
C     IRWC=2    :  Subr. schreibt Ausloeschungsregel aus
C     IRWC=3    :  Subr. prueft (IH,IK,IL) auf Ausloeschung
C
C --- Ausgabeparameter sind:
C     NA        :  Nummer der integralen Ausloeschungsregel
C     KO=0      :  Reflex ist ausgeloescht
C     KO=1      :  Reflex erscheint
C     Groessen, die von Aufruf zu Aufruf erhalten bleiben:
C     M1,M2     :  Charakterisieren die Ausloeschung:
C     M2=1      :  Keine Ausloeschung
C     M2=2      :  Nur integrale Ausloeschung.
C     IZ        :  Matrix der Koeffizienten der Ausloeschungsregel


      CHARACTER*1 INTAUS, AINT(9)
      DIMENSION IZ(5,6), LKH(3), ISS(6)

      DATA AINT /'F','I','C','B','A','R','H','X','P'/


C --- Voreinstellung: Alle Reflexe erscheinen:

      KO = 1

C --- Voreinstellung der Parameter der Ausloeschungsregel:
C     K nummeriert die Regel, I die Koeffizienten A, B, C, D, F
C     von A*H + B*K + C*L = D*N + F

C --- Ausloeschungsregel wird am Bildschirm ausgegeben:

      IF(IRWC.EQ.2) THEN

	DO 7 K=1,6
	   DO 7 I=1,3
	      IZ(I,K) = 1
	      IZ(4,1) = 2
	      IZ(4,K) = 1
	      IZ(5,K) = 0
7       CONTINUE
  
	M1 = 1
	M2 = 1
10      FORMAT(1A1)


C --- Einlesen der integralen Ausloeschungsregel

	NA = 0
	DO 310 I=1,8
	   IF(AINT(I).EQ.INTAUS) NA = I
310     CONTINUE
	IF(NA.EQ.0) GOTO 199
	M1 = 1
	IF(NA.NE.1) GOTO 20
	IZ(3,1) = 0
	IZ(1,2) = 0
	IZ(4,2) = 2
20      IF(NA.EQ.3) IZ(3,1) = 0
	IF(NA.EQ.4) IZ(2,1) = 0
	IF(NA.EQ.5) IZ(1,1) = 0
	IF(NA.EQ.6.OR.NA.EQ.7) IZ(4,1) = 3
	IF(NA.EQ.6) IZ(1,1) = -1
	M2 = 2


C --- Ausgabe der Ausloeschungsregel

199     IF(M2.EQ.1) THEN
	  write(*,205)
205       format(2x,'No extinction',/)
	  GOTO 201
	END IF

	write(*,'(/2x,a)') 'HKL only with'
	write(*,216)(iz(i,1),i=1,5)
216     format(2x,i2,'*H+',i2,'*K+',i2,'*L=',i2,'*N+',i2)
	write(*,'(2x,a)') 'and'
	write(*,216) (iz(i,2),i=1,5)

249     CONTINUE
250     CONTINUE

      END IF


C --- Probe auf Ausloeschung:

255   IF(IRWC.NE.3) GOTO 201
      IF(M2.EQ.1) GOTO 201
      LKH(1) = IH
      LKH(2) = IK
      LKH(3) = IL
      KO  = 0
      IOK = 0
      IV  = 0

      DO 200 K=M1,M2

	 IZS = 1
	 IF(ICR.EQ.7.OR.ICR.EQ.5.) IZS = 3
	 IF(ICR.EQ.4) IZS = 2
	 IF(ICR.EQ.6.) IZS = 3

	 MIZ = MOD(IZS,2)

	 DO 190 I=1,IZS

	    IV = IV + 1


C --- Kubisches und tetragonales System:

	    IF(ICR.EQ.6) GOTO 605
	    KH1 = (1+MOD((I+2),3))*MIZ+(1-MIZ)*I
	    KH2 = (1+MOD(I,3))*MIZ+(1-MIZ)*(3-I)
	    KH3 = (1+MOD((I+1),3))*MIZ+(1-MIZ)*3


C --- Hexagonales System:

605         IF(ICR.NE.6.OR.I.LT.2) GOTO 610
	    KH1 = 1
	    KH2 = 2
	    KH3 = 3


C --- erste Permutation: -(H+K),H,L

	    IF(I.NE.2) GOTO 607
	    KME1   = LKH(1)
	    KME2   = LKH(2)
	    LKH(1) = -(KME1+KME2)
	    LKH(2) = KME1
607         IF(I.NE.3) GOTO 610


C --- zweite Permutation:  K,-(H+K),L

	    LKH(2) = LKH(1)
	    LKH(1) = KME2
610         CONTINUE

C --- Ausloeschung, falls KO=0 

	    ISS(K) = IZ(1,K)*LKH(KH1)+IZ(2,K)*LKH(KH2)+
     1               IZ(3,K)*LKH(KH3)-IZ(5,K)
	    IDS    = MOD(ISS(K),IZ(4,K))
	    IF(IDS.NE.0) GOTO 190
55          IOK = IOK + 1

190      CONTINUE

200   CONTINUE

      IF(IOK.EQ.IV) KO = 1

201   RETURN
      END


C******************************************************************************
C***         Index-Generator fuer nicht modulierte Strukturen               ***
C******************************************************************************

      subroutine fisgen(intaus,laue,icent,ism,tran,nsym,tmi,tma,rai,
     *                  celld,cellr,rlamda,iref,mult,theta,nhkl,IRS)

      external icodhkl, loesch, hhcalc
      parameter (PI = 3.14159265359)

      real hs(3), celld(6)
      real rlamda(2), theta(IRS), cellr(13), tran(3,48)
      integer h, hmin, hmax, ihi(3), iref(IRS), mult(IRS), iz(5,6)
      integer ism(3,3,48)
      character INTAUS*1
      logical lnull, knull

      EQUIVALENCE (H,IHI(1)),(K,IHI(2)),(L,IHI(3))


c --- Kristallklasse ermitteln:

      if(laue.eq.1.or.laue.eq.2) icr = 1
      if(laue.eq.3) icr = 3
      if(laue.eq.12) icr = 2
      if(laue.eq.4.or.laue.eq.5) icr = 4
      if(laue.ge.6.and.laue.le.9) icr = 6
      if(laue.eq.15) icr = 6
      if(laue.eq.10.or.laue.eq.11) icr = 7
      if(laue.eq.13.or.laue.eq.14) icr = 5

c --- Ausloeschungsregel ausgeben (Modus = 2):

      call extin(icr,ih,ik,il,ko,2,nz,iz,intaus)

c --- Maxima fuer h, k und l bestimmen und Grundreflexe erzeugen:

      hmax = int(rai*celld(1)) 
      kmax = int(rai*celld(2)) 
      lmax = int(rai*celld(3)) 

c --- Bei zwei Wellenlaengen: 

      LXN = 2
      IF(RLAMDA(2).LE.0.001.OR.RLAMDA(2).EQ.RLAMDA(1)) LXN = 1

c --- Parameterbestimmung fuer den Indexgenerator:

      nhkl  = 0
      IK    = 0
      IL    = 0
      HMIN  = 0
      KNULL = .TRUE.
      LNULL = .TRUE.
      GOTO (1,1,1,4,4,2,4,2,4,7,7,1,7,7,4),laue
2     KNULL = .FALSE.
1     GOTO 2222
C3     LNULL = .FALSE.
4     IK    = 1
      GOTO 2222
7     IK    = 1
      IL    = 1
      GOTO 2222

C --- Indexgenerator:

2222  DO 4042 JJ=HMIN,HMAX
	 KMIN = IK*JJ
	 DO 4041 MM=KMIN,KMAX
	    IF(.NOT.KNULL.AND.MM.EQ.0.AND.JJ.NE.0) GOTO 4041
	    LMIN = IL*MM
	    DO 4040 NN=LMIN,LMAX
	       IF(.NOT.LNULL.AND.NN.EQ.0) GOTO 4040

	       IREP  = 0
	       IPERM = 0
	       ITERM = 0
	       H = JJ    
	       K = MM
	       L = NN


C --- Wahl der Reflexe einer Schicht:

28             CONTINUE

	       IPERM = 0
2820           CONTINUE


c --- hkl-Auswahl gemaess der Ausloeschungsregel:

2828           call extin(icr,h,k,l,ko,3,nz,iz,intaus)
	       if(ko.eq.0) goto 35
               if(loesch(h,k,l,icent,ism,tran,nsym).eq.1) goto 35

c --- Theta-Werte berechnen und aussortieren:

               hs(1) = h
               hs(2) = k
               hs(3) = l
               hh = hhcalc(hs,cellr)
	       do 3119 iq=1,lxn
                  sqt = hh * rlamda(iq)*rlamda(iq)/4.
                  if(sqt.lt.1.) then
                    sinth  = sqrt(sqt)
                    th = asin(sinth)
		    thobs = th * 360./PI
		    if(thobs.ge.tmi.and.thobs.le.tma) then
                      nhkl = nhkl + 1
		      if(nhkl.gt.IRS) then
		        write(*,'(/2x,a)') 'Too many reflections!!!'
		        stop
		      end if
		      theta(nhkl) = th
                      iref(nhkl)  = icodhkl(h,k,l,0,iq)
                      mult(nhkl)  = multi(h,k,l,laue)
                    end if
                  end if
3119           continue

35             continue
       

C --- Vorzeichenwahl fuer h, k, und l:

C --- Triklin:

	       IF(laue.NE.1) GOTO 1200
	       IF(IHI(2).EQ.0.AND.IHI(3).EQ.0) GOTO 4040
1105           IREP = IREP+1
	       IF(IREP.GT.3.OR.(IHI(3).EQ.0.AND.IREP.GT.1).OR.
     1           (IHI(1)*IHI(2).EQ.0.AND.IREP.GT.2)) GOTO 4040
	       MO = 2 - MOD(IREP,2)
	       IF(IHI(MO).EQ.0) GOTO 1105
	       IHI(MO) = -IHI(MO)
	       GOTO 28


C --- Monoklin, c-Achse bevorzugt, (laue=2); b-Achse bevorzugt, (laue=12)

1200           IF(laue.NE.2.AND.laue.NE.12) GOTO 1250
	       IF(IREP.EQ.1) GOTO 4040
	       IF(laue.EQ.2.AND.IHI(1)*IHI(2).EQ.0) GOTO 4040
	       IF(laue.EQ.12.AND.IHI(1)*IHI(3).EQ.0) GOTO 4040
	       IREP   =  1
	       IHI(1) = -IHI(1)
	       GOTO 2828


C --- Tetragonal, 4/m, (laue=4)

1250           IF(laue.NE.4)GOTO 1300
	       IF(IREP.EQ.1.OR.(H.EQ.K.OR.H.EQ.0)) GOTO 4040
	       IREP = 1
	       KME  = K
	       K    = H
	       H    = KME
	       GOTO 2828

C --- Kubisch, m3, (laue=10)

1300           IF(laue.NE.10) GOTO 1400
	       IF(IREP.GE.1.OR.(H.EQ.K.OR.K.EQ.L)) GOTO 4040
	       IREP = 1
	       KME  = K
	       K    = L
	       L    = KME
	       GOTO 2828


C --- Triklin, hkl's pos. generiert, (laue=1)


C --- Rhomboedrisch, h<k<l ,3b m (laue=14)


C --- Rhomboedrisch, h<k,l 3b,(laue=13) (+-l wird erzeugt)


1400           IF(laue.NE.13.AND.laue.NE.14) GOTO 1500


C --- Rueckpermutation fuer Lauegruppe 13

	       IF(IPERMI.EQ.0) GOTO 102
	       KMERK  = IHI(2)
	       IHI(2) = IHI(3)
	       IHI(3) = KMERK
102            CONTINUE

	       IF(ITERM.EQ.1.AND.laue.EQ.13) GOTO 104
	       IF(ITERM.EQ.2) IPERMI=0
	       IF(ITERM.EQ.2) GOTO 4040
	       IF(IREP.GE.3) GOTO 4040
	       IF(IHI(2).EQ.0) GOTO 4040
	       IF(IHI(2).EQ.IHI(3)) IPERM=1
	       IF(IHI(1).EQ.IHI(2)) IPERM=2
	       GOTO 105


C --- Permutation fuer Lauegruppe 13

104            ITERM=2
105            CONTINUE
	       IF(IPERMI.EQ.1) GOTO 101
	       IF (laue.EQ.14) GOTO 101
	       IF(IHI(1).EQ.0.AND.IHI(2).EQ.IABS(IHI(3))) GOTO 101
	       IF(IHI(1).EQ.IHI(2).OR.IHI(1).EQ.IHI(3).OR.
     *            IHI(2).EQ.IHI(3)) GOTO 101
	       KMERK  = IHI(2)
	       IHI(2) = IHI(3)
	       IHI(3) = KMERK
	       IPERMI = 1
	       GOTO 2828
101            CONTINUE


C --- l wird negativ gesetzt:

	       IF(IREP.EQ.1) GOTO 100
	       IF(IREP.EQ.2) GOTO 200
	       IHI(3) = -IHI(3)
	       IREP   =  1
	       IPERMI =  0
	       GOTO 2828


C --- k wird negativ gesetzt

100            IHI(3) = -IHI(3)
	       IPERMI =  0
	       IF(IHI(1).EQ.IHI(2).AND.IHI(2).EQ.IHI(3)) GOTO 4040


C --- Naechste 2 Zeilen eingefuegt

	       IF(IHI(1).EQ.0) GOTO 4040
	       IF(IPERM.EQ.1) GOTO 201
	       IF(IPERM.EQ.1.OR.IREP.EQ.2) GOTO 200
	       IHI(2) = -IHI(2)
	       IREP   =  2
	       GOTO 2828


C --- h wird negativ gesetzt:

200            IHI(2) = -IHI(2)
	       IPERMI =  0
	       IF(IPERM.EQ.2) GOTO 4040
201            IHI(1) = -IHI(1)
	       ITERM  =  1
	       IREP   =  3
	       GOTO 2828


C --- Monoklin c- oder b-Achse bevorzugt, hkl's pos. generiert, laue=2, laue=12

C --- Hexagonal, 6 m m (laue=9), R 3b m (laue=7), h<k,l generiert

C --- Hexagonal, 6/m (laue=8), R 3b (laue=6) , hkl's generiert


1500           IF(ICR.NE.2.AND.ICR.NE.6) GOTO 1800
	       IF(IREP.GE.3) GOTO 4040
	       IREP = 3
	       IF(IHI(3).EQ.0) GOTO 4040
	       IF(laue.EQ.6.AND..NOT.(IHI(1).EQ.0.AND.
     *            IHI(2).EQ.0)) GOTO 1818
	       IF(laue.EQ.7.AND.IHI(1).NE.IHI(2)) GOTO 1818
	       IF(laue.EQ.15.AND.IHI(1).NE.0.AND.IHI(2).NE.0) GOTO 1818
	       GOTO 4040
1818           IHI(3) = -IHI(3)
	       GOTO 2828


C --- h k -(h+k) permutation fuer die Reflexe einer Schicht im hex. Syst.
       

1800           IF(ICR.NE.6.OR.IPERM.EQ.2) GOTO 36
	       IPERM =  IPERM + 1
	       KME   =  H
	       H     = -(H+K)
	       K     =  KME
	       GOTO 2820
36             CONTINUE

4040        CONTINUE
4041     continue
4042  continue

      RETURN
      END


c******************************************************************************
c***     Die Function MULTI bestimmt die Multiplizitaet der Reflexe         ***
c***     (H, K, L) fuer die durch LAUE spezifizierte Lauegruppe.            ***
c***     nach Cooper/Rouse, J. Appl. Cryst. (1977), 10, 134-135.            ***
c******************************************************************************

c     J. P. Ihringer, 26-Mai-77, 12-Jan-81
c     J. K. Maichle, 11-Mai-85 (VAX-Version)
c     H. Ritter, 29-Mai-96 

      integer function multi(h,k,l,laue)

      integer iav(14,14), h, k, l

      data iav/16*2,4,2,4,2,2*4,2,5*4,2*2,4,2,2*4,8,2*4,8,4,3*8,
     1         2,4,8,4,8,4,2*8,4,5*8,2,4,8,4,2*8,16,8,4,2*8,2*16,8,
     2         2,13*6,2,4*6,2*12,2*6,12,6,3*12,2,6,12,6,12,6,2*12,
     3         6,5*12,2,6,12,6,2*12,24,12,6,2*12,2*24,12,2*6,12,6,
     4         2*12,24,2*12,24,12,2*24,8,2*6,24,6,2*24,48,2*12,24,
     5         12,2*24,8,2*2,4,2*2,5*4,2,3*4,13*6,2,2*6,12,6,3*12,
     6         6*6,2/

      j = 100
      if((h*h+k*k).eq.0) j = 1
      if((h*h+l*l).eq.0) j = 2
      if(h.eq.0.and.k.ne.l.and.k*l.ne.0) j = 3
      if((k*k+l*l).eq.0) j = 4
      if(k.eq.0.and.h.ne.l.and.h*l.ne.0) j = 5
      if(l.eq.0.and.h.ne.k.and.h*k.ne.0) j = 6
      if(h.ne.k.and.k.ne.l.and.h.ne.l.and.(h*k*l).ne.0) j = 7
      if(h.eq.0.and.k.eq.l) j = 8
      if(l.eq.0.and.h.eq.k) j = 9
      if((h*k*l).ne.0.and.h.eq.k.and.k.ne.l) j = 10
      if(h.eq.l.and.k.eq.0) j = 11
      if((h*k*l).ne.0.and.k.eq.l.and.h.ne.k) j = 12
      if((h*k*l).ne.0.and.h.eq.l.and.k.ne.h) j = 13
      if(h.eq.k.and.k.eq.l) j = 14

      if(j.eq.100) then
        write(*,'(/2x,a)') 'Unknown Multiplicity!'
        stop
      end if

c --- Unterscheidung -3 m 1 (laue = 7) von -3 1 M (laue = 15)

      nl = laue
      if(laue.eq.15) then
        nl = 7
        jme = j
        if(j.eq.3.or.j.eq.5.or.j.eq.8) j = 10
        if(jme.eq.10.or.j.eq.14) j = 3
      end if

      multi = iav(j,nl)

c --- Test auf ( 0 h -h) bei laue = 14 (R3-quer (rhomboedrisch))

      if(laue.eq.14) then
        if((j.eq.3.or.j.eq.5.or.j.eq.6).AND.
     *  (iabs(h).eq.iabs(k).or.iabs(k).eq.iabs(l).or.
     *   iabs(h).eq.iabs(l))) multi = 6
      end if

      return
      end


c******************************************************************************
c*             Berechnung des Lorentz-Polarisationsfaktors                    *
c******************************************************************************

      real function lorpol(igeo,thm,tha,theta)

      parameter (PI = 3.14159265359)


c --- Falls theta < 1 Grad, dann wird lorpol = 0 gesetzt:

      IF(180./PI*THETA.LE.1.0) THEN
	LORPOL = 0.
	RETURN
      END IF


C --- Guinier-Geometrie (Diffraktometer, Transmission):

      IF(IGEO.EQ.1) THEN
	SIGATE = SIN(2.*THETA + 45.*PI/180.)
	C2TMO  = COS(THM*PI/180.)**2
	LORPOL = (1.+C2TMO*COS(2.*THETA)**2.)*EXP(-.0633*SIGATE)/
     1           ((1.+C2TMO)*2.*SIN(THETA)*SIN(2.*THETA)*SIGATE*SIGATE)


C --- 2. Guinier-Geometrie (Film):

      ELSE IF(IGEO.EQ.2) THEN
	SIGATE = SIN(2.*THETA + 45.*PI/180.)
        C2TMO  = COS(THM*PI/180.)**2
	LORPOL = (1.+C2TMO*COS(2.*THETA)**2.)*EXP(-.0633*SIGATE)/
     1           ((1.+C2TMO)*2.*SIN(THETA)*SIN(2.*THETA)*SIGATE)


C --- 3. Bragg-Brentano-Geometrie:

      ELSE IF(IGEO.EQ.3) THEN
        C2TMO = COS(THM*PI/180.)**2
	LORPOL = (1.+C2TMO*COS(2.*THETA)**2.)/
     1           ((1.+C2TMO)*2.*SIN(THETA)*SIN(2.*THETA))


C --- 4. Diffraktometer am Synchrotron (Cox-Geometrie):

      ELSE IF(IGEO.EQ.4) THEN
        costha = abs(cos(PI/180.*tha)) 
	lorpol = ((1-thm) + thm * cos(2.*theta)**2 * costha)
     *           /(2. * sin(theta) * sin(2.*theta))


C --- 5. Neutronen-Pulverdiffraktometer mit Debye-Scherrer-Geometrie:

      ELSE IF(IGEO.EQ.5)  THEN
	LORPOL = 1./(2.*SIN(THETA)*SIN(2.*THETA))
      

C --- 6. Guinier-Geometrie (Diffraktometer, Reflexion):

      ELSE IF(IGEO.EQ.6) THEN
	SIGATE = SIN(PI - 2.*THETA + 45.*PI/180.)
        C2TMO = COS(THM*PI/180.)**2
        LORPOL = (1.+COS(2.*THETA)**2.*C2TMO)*EXP(-.0633*SIGATE)/
     1           ((1+C2TMO)*2.*SIN(THETA)*SIN(2.*THETA)*SIGATE*SIGATE)


      END IF


      RETURN
      END


c******************************************************************************
c***          hkl's aus der Zahl iref decodieren                            ***
c******************************************************************************

      subroutine dcodhkl(iref,h,k,l,n,iq)

      integer iref, h, k, l, n, iq, ip

      n  = mod(iref,8)-4
      l  = mod(iref/8,256)-128
      k  = mod(iref/8/256,256)-128
      h  = mod(iref/8/256/256,256)-128
      iq = mod(iref/8/256/256/256,4)
      ip = iref/8/256/256/256/4

      return
      end

c******************************************************************************
c***          hkl's in einer Interger-Zahl codieren                         ***
c******************************************************************************

      integer function icodhkl(h,k,l,n,iq)

      integer h, k, l, n, iq, ip

      ip = 1
      icodhkl = 8*(256*(256*(256*(4*ip+iq)+128+h)+128+k)+128+l)+n+4

      return
      end


c******************************************************************************
c***               Zonale und seriale Ausloeschungen                        ***
c******************************************************************************

      integer function loesch(h,k,l,icent,ism,tran,nsym)

c     Programm AUSLOESCH   (K. Burger, 30-Jan-1996)
c     Subroutine LOESCH fuer SIMREF (H. Ritter, 30-Jan-1996) 
c
c     Ausgeloeschte Reflexe erfuellen folgende Bedingungen:
c     Das Symmetrieelement S = {R|t} mit der Rotationsmatrix R und dem
c     Translationsvektor t ergibt:
c     Ein Reflex ist genau dann ausgeloescht, wenn gilt:
c     -  Der Vektor (h,k,l) wird durch R auf sich selbst abgebildet:
c        (h,k,l) * R = (h,k,l)
c     -  Das Skalarprodukt t * (h,k,l) ist nicht ganzzahlig:
c        (t1,t2,t3) * (h,k,l) nicht ganzzahlig
c
c     Literatur: Giacovazzo, Fund. of Cryst., Oxford 1992, S. 159
c
c
c     loesch = 0  -> Reflex nicht ausgeloescht
c     loesch = 1  -> Reflex ausgeloescht


      parameter(EPSY = 0.00001)
      integer ism(3,3,48), h, k, l
      real tran(3,48)

      ls = 0
      do 100 n=1,nsym
         x = h * ism(1,1,n) + k * ism(2,1,n) + l * ism(3,1,n)
         y = h * ism(1,2,n) + k * ism(2,2,n) + l * ism(3,2,n)
         z = h * ism(1,3,n) + k * ism(2,3,n) + l * ism(3,3,n)
         q = h * tran(1,n) + k * tran(2,n) + l * tran(3,n)
         if(abs(x-h).lt.EPSY.and.abs(y-k).lt.EPSY.and.
     *      abs(z-l).lt.EPSY.and.abs(q-nint(q)).gt.EPSY) then
           ls = 1
           goto 200
         end if
         if(icent.eq.2) then
           if(abs(-x-h).lt.EPSY.and.abs(-y-k).lt.EPSY.and.
     *        abs(-z-l).lt.EPSY.and.abs(-q-nint(-q)).gt.EPSY) then
             ls = 1
             goto 200
           end if           
         end if
 100  continue

 200  loesch = ls
      return
      end

c******************************************************************************
c***          Eine Zeile einer Datei mit oder ohne Code einlesen            ***
c******************************************************************************

      subroutine getinp(ke,code,ecod,werte,char,max,num,nn,ist)

c     ke:      Kanalnummer
c     code:    Zeilencode, z. B. 'TIT'
c              code = '   ': Zeile ohne Code einlesen
c     ecod:    Code, bei dem das Einlesen abgebrochen wird
c     char:    Daten als Character-String abgespeichert
c     werte:   Daten als Realwerte abgespeichert
c     ist:     Eingabe: = 0 : Zeichenkette einlesen --> char
c                       = 1 : Daten einer Zeile als Realwerte (werte) und
c                             zusaetzlich als character (char) abspeichern 
c              Ausgabe: = 11 : Codewort nicht gefunden!
c                       = 13 : Ende beim Einlesen gefunden!
c     nn:      Zeilennummer
c     line:    Eingelesene Eingabe-Zeile
c              (einschliesslich aller Fortsetzungszeilen)
c     LMAX     Maximale Anzahl der Zeichen pro Zeile 
c     MAXLINE: Maximale Anzahl der Zeichen pro Eingabe-Zeile 
c              (einschliesslich der Fortsetzungszeilen)
c     max:     Maximale Anzahl der Werte pro Eingabe-Zeile
c     num:     Anzahl der gefundenen Werte pro Eingabe-Zeile


      parameter(MAXLINE = 500, LMAX = 132)
      real werte(max)
      character zeile*(LMAX), code*3, ecod*3, char(max)*(LMAX)
      character line*(MAXLINE)


c -- Initialisierung:

      ibeg = 1

      do 5 k=1,max
         char(k) = ' '
5     continue


c --- Zeile einlesen:

 10   k = 0
      line = ' '

 11   zeile = ' '
      read(ke,'(a)',end=1100) zeile
c      write(*,'(a,a)') 'Z = ',zeile(1:70)
      nn = nn + 1

      do 20 i=1,LMAX
         if(zeile(i:i).eq.'\\') then
           if(i.eq.1) then
             goto 11
           else
             if(zeile(i-1:i-1).eq.' ') goto 11
           end if
         end if
         k = k + 1
         if(k.gt.MAXLINE) goto 30
         line(k:k) = zeile(i:i)
 20   continue

c --- Nach der Kennung suchen:

 30   if(code.ne.'   ') then

        if(ecod.ne.'eee'.and.line(1:3).eq.ecod) then
          backspace(ke)
          goto 1300
        end if
        if(line(1:3).ne.code(1:3)) goto 10

c --- ">" suchen:

        do 100 i=1,MAXLINE
           if(line(i:i).eq.'>') then
             ibeg = i + 1
             goto 110
           end if
100     continue
        stop 'ERROR: ">" is missing'

      end if


c --- Daten der Zeile abspeichern:

110   num = 0
      do 500 k=1,max
   
         if(ibeg.gt.MAXLINE) return 

c --- Anfang suchen:
 
         do 200 j=ibeg,MAXLINE
            if(line(j:j).ne.' '.and.line(j:j).ne.',') then
              ibeg = j
              num = num + 1
              goto 250
            end if
200      continue

c --- Ende suchen:

250      if(ist.ne.0) then
           do 300 j=ibeg,MAXLINE
              if(line(j:j).eq.' '.or.line(j:j).eq.',') then
                iend = j - 1
                goto 350
              end if
300        continue
         end if

c --- Daten aus der Zeichenkette einlesen:

350      if(ist.eq.0) then
           m = MAXLINE - ibeg + 1
           char(1)(1:m) = line(ibeg:MAXLINE)
           return
         else if(ist.ge.1) then
           read(line(ibeg:iend),'(f15.0)',err=355) werte(k)
355        m = iend - ibeg + 1 
           char(k)(1:m) = line(ibeg:iend)
         end if
  
         ibeg = iend + 1

500   continue

      return


c --- Fehlermeldungen und Warnungen zurueckgeben:
 
1100  ist = 11
      return
1300  ist = 13
      return

      end


c******************************************************************************
c***          gemischte hkl-Liste aller Phasen ausgeben                     ***
c******************************************************************************

      subroutine hklout(ka,hklfile,imo,titel,iref,mult,indx,theta,
     *                  hwb,rlopo,nhkl,IRS)

      parameter (PI = 3.14159265359)
      integer h,k,l, iref(IRS,2), mult(IRS), indx(IRS)
      character hklfile*80, titel*70
      real theta(IRS), rlopo(IRS), hwb(IRS)

     
      if(ka.ne.6) then
        open(ka,file=hklfile,status='unknown',err=1000)
        write(ka,'(a)') titel
      end if

      if(imo.eq.1) then

        write(ka,'(2x,a,a)')' No. Ph. Co.     2-Theta       Lopo',
     *'        Fwhm        h   k   l   n    Mult'
        do 100 i=1,nhkl
           ii = indx(i)
           ip = iref(ii,2)
           call dcodhkl(iref(ii,1),h,k,l,n,iq)
           th_obs = 360./PI*theta(ii)
           write(ka,'(2x,3i4,3f12.4,4x,4i4,i8)') 
     *     i, ip, iq, th_obs, rlopo(ii), hwb(ii), h, k, l, n, mult(ii)
100     continue

      else

        write(ka,'(2x,a,a)')' No. Ph. Co.     2-Theta       Lopo',
     *'        Fwhm        h   k   l    Mult'
        do 200 i=1,nhkl
           ii = indx(i)
           ip = iref(ii,2)
           call dcodhkl(iref(ii,1),h,k,l,n,iq)
           th_obs = 360./PI*theta(ii)
           write(ka,'(2x,3i4,3f12.4,4x,3i4,i8)') 
     *     i, ip, iq, th_obs, rlopo(ii), hwb(ii), h, k, l, mult(ii)
200     continue

      end if

      if(ka.ne.6) close(ka)
      return

1000  stop ' Cannot open hkl file'
      end


c******************************************************************************
c***                       hkl-Liste ausgeben                               ***
c******************************************************************************

      subroutine hklwrite(ka,imo,cellr,q,iref,mult,theta,hwb,rlopo,
     *                    nhkl,IRS)

      parameter (PI = 3.14159265359)
      external hhcalc
      integer iref(IRS), mult(IRS)
      real theta(IRS), rlopo(IRS), hwb(IRS), h(3), cellr(13), q(3)


      if(imo.eq.1) then

        write(ka,'(2x,a,a)') ' No. Co.   2-theta      d        Lopo',
     *'      Fwhm        h   k   l   n    Mult'
        do 100 i=1,nhkl
           call dcodhkl(iref(i),ih,ik,il,in,iq)
           call hvec(ih,ik,il,in,q,h)
           dwert = 0.
           hh = hhcalc(h,cellr)
           if(hh.gt.0.) dwert = 1./hh
           th_obs = 360./PI*theta(i)
           write(ka,'(2x,2i4,4f10.4,4x,4i4,i8)') 
     *     i,iq,th_obs,dwert,rlopo(i),hwb(i),ih,ik,il,in,mult(i)
100     continue

      else

        write(ka,'(2x,a,a)') ' No. Co.   2-theta      d        Lopo',
     *'      Fwhm        h   k   l    Mult'
        do 200 i=1,nhkl
           call dcodhkl(iref(i),ih,ik,il,in,iq)
           call hvec(ih,ik,il,in,q,h)
           dwert = 0.
           hh = hhcalc(h,cellr)
           if(hh.gt.0.) dwert = 1./hh
           th_obs = 360./PI*theta(i)
           write(ka,'(2x,2i4,4f10.4,4x,3i4,i8)') 
     *     i,iq,th_obs,dwert,rlopo(i),hwb(i),ih,ik,il,mult(i)
200     continue

      end if

    
      return
      end





c******************************************************************************
c***      Sortieren der 2-Theta-Werte nach steigenden Winkel                ***
c******************************************************************************

      subroutine indexx(IRS,theta,indx,nhkl)

      integer indx(IRS)
      real theta(IRS)


      do 11 j=1,nhkl
	 indx(j) = j
11    continue

      if(nhkl.gt.1) then

        l  = nhkl/2 + 1
        ir = nhkl

10      continue

          if(l.gt.1) then
 	    l = l - 1
	    indxt = indx(l)
	    q = theta(indxt)
	  else
	    indxt = indx(ir)
	    q = theta(indxt)
	    indx(ir) = indx(1)
	    ir = ir - 1
	    if(ir.eq.1) then
	      indx(1) = indxt
	      return
	    end if
	  end if

	  i = l
	  j = l + l

20        if(j.le.ir) then
	    if(j.lt.ir) then
	      if(theta(indx(j)).lt.theta(indx(j+1))) j = j + 1
	    end if
	    if(q.lt.theta(indx(j))) then
	      indx(i) = indx(j)
	      i = j
	      j = j + j
	    else
	      j = ir + 1
	    end if
	    goto 20
	  end if

	  indx(i) = indxt

        goto 10

      end if

      end


c******************************************************************************
c*  Intensitaeten aus der Int.-Datei den von FIS erzeugten Reflexen zuordnen  *
c******************************************************************************

      subroutine intinp(ke,intfile,imo,iref,mult,theta,rlopo,rint,
     *                  rsig,cint,nhkl,irf,IRS,ierr)

      parameter(EPSY = 0.00001, PI = 3.14159265359)

      external icodhkl
      character intfile*80, cint(IRS)*5, titel*80
      integer h, k, l, iref(IRS), mult(IRS)
      real rint(IRS), theta(IRS), rlopo(IRS), rsig(IRS)


c --- Datei mit den Intensitaets-Werten oeffnen:

      open(ke,file=intfile,status='old',err=1000)

c --- Titelzeile lesen:

      read(ke,'(a)') titel

      if(nhkl.eq.0) then

c --- Daten einlesen:

        if(imo.eq.1) then
          i = 0
10        i = i + 1
          read(ke,*,err=1100,end=12) num, iq, h, k, l, n, mult(i), ths, 
     *                               rlopo(i), rint(i), rsig(i), icod
          write(cint(i)(1:1),'(i1)') icod
          iref(i)  = icodhkl(h,k,l,n,iq)
          theta(i) = PI/360. * ths
          goto 10
        else
          i = 0
11        i = i + 1
          read(ke,*,err=1100,end=12) num, iq, h, k, l, mult(i), ths, 
     *                               rlopo(i), rint(i), rsig(i), icod
          write(cint(i)(1:1),'(i1)') icod
          iref(i)  = icodhkl(h,k,l,0,iq)
          theta(i) = PI/360. * ths
          goto 11
        end if
12      irf = i - 1
        nhkl = irf

      else

c --- Daten einlesen und sortieren:

        if(imo.eq.1) then
          i = 0
20        i = i + 1
          read(ke,*,err=1100,end=220) 
     *        num, lq, h, k, l, n, mlt, ths, rlp, zint, stdd, icod
          do 30 j=1,nhkl
             call dcodhkl(iref(j),ih,ik,il,in,iq)
             if(ih.eq.h.and.ik.eq.k.and.il.eq.l.and.
     *          in.eq.n.and.iq.eq.lq) then
               rint(j) = zint
               rsig(j) = stdd
               write(cint(j)(1:1),'(i1)') icod
               goto 20
             end if
30        continue
          goto 20
        else
          i = 0
40        i = i + 1
          read(ke,*,err=1100,end=220) 
     *        num, lq, h, k, l, mlt, ths, rlp, zint, stdd, icod
          do 50 j=1,nhkl
             call dcodhkl(iref(j),ih,ik,il,in,iq)
             if(ih.eq.h.and.ik.eq.k.and.il.eq.l.and.iq.eq.lq) then
               rint(j) = zint
               rsig(j) = stdd
               write(cint(j)(1:1),'(i1)') icod
               goto 40
             end if
50        continue
          goto 40
        end if
220     irf = i - 1

      end if


      ierr = 0
      close(ke)
      return

1000  ierr = 1
      return

1100  ierr = 2
      close(ke)
      return

      end

c******************************************************************************
c***           Intensitaeten in der Int.-Datei abspeichern                  ***
c******************************************************************************

      subroutine intout(ka,intfile,filex,imo,iref,mult,theta,rlopo,
     *                  rint,cint,lint,aint,nhkl,IRS,rjac,MSZ,ierr)

      parameter (PI = 3.14159265359, EPSY = 0.00001, MR = 2000)

      external icodhkl
      logical filex
      character intfile*80, cint(IRS)*5, ci(MR)*5
      integer h, k, l, iref(IRS), mult(IRS), lint(IRS), ir(MR), ml(MR)
      real rint(IRS), theta(IRS), rlopo(IRS), aint(IRS), rjac(MSZ,MSZ)
      real rs(MR), th(MR), rl(MR), ri(MR)

      character ctemp(MR)*5
      integer itemp(2,MR), ll(MR)
      real temp(4,MR)

c --- Initialisierung:

      m = nhkl
      do 5 j=1,nhkl
         ir(j) = iref(j)
         ml(j) = mult(j)
         th(j) = theta(j)
         rl(j) = rlopo(j)
         ri(j) = rint(j)
         km = lint(j)
         if(km.ne.0) rs(j) = sqrt(abs(rjac(km,km))) * abs(aint(j))
         ci(j) = cint(j)
5     continue

      if(filex) then

c --- Datei mit den Intensitaets-Werten oeffnen, 
c     Daten einlesen und sortieren:

        open(ka,file=intfile,status='old',err=1000)
        read(ka,*)

        if(imo.eq.1) then
10        read(ka,*,err=1100,end=220) 
     *        num, lq, h, k, l, n, mlt, ths, rlp, zint, stdd, icod
          do 20 j=1,nhkl
             call dcodhkl(iref(j),ih,ik,il,in,iq)
             if(ih.eq.h.and.ik.eq.k.and.il.eq.l.and.
     *          in.eq.n.and.iq.eq.lq) goto 10
20        continue
          m = m + 1
          ir(m) = icodhkl(h,k,l,n,iq)
          ml(m) = mlt
          th(m) = PI/360. * ths
          rl(m) = rlp
          ri(m) = zint
          rs(m) = stdd 
          write(ci(m)(1:1),'(i1)') icod
          goto 10
        else
30        read(ka,*,err=1100,end=220) 
     *        num, lq, h, k, l, mlt, ths, rlp, zint, stdd, icod
          do 40 j=1,nhkl
             call dcodhkl(iref(j),ih,ik,il,in,iq)
             if(ih.eq.h.and.ik.eq.k.and.il.eq.l.and.iq.eq.lq) goto 30
40        continue
          m = m + 1
          ir(m) = icodhkl(h,k,l,0,iq)
          ml(m) = mlt
          th(m) = PI/360. * ths
          rl(m) = rlp
          ri(m) = zint
          rs(m) = stdd 
          write(ci(m)(1:1),'(i1)') icod
          goto 30
        end if
220     close(ka)

c --- Sortieren der Reflexe nach aufsteigendem Theta-Wert:

        if(m.gt.0)
     *    call refsort(ir,ml,th,rl,ri,rs,ci,m,ctemp,itemp,temp,ll,MR)

      end if

c --- Neue Datei anlegen:

      open(ka,file=intfile,status='unknown',err=1000)
      call intwrite(ka,MR,imo,ir,ml,th,rl,ri,rs,ci,m)
      ierr = 0
      close(ka)
      return

1000  ierr = 1
      return

1100  ierr = 2
      close(ka)
      return

      end


c******************************************************************************
c***            Reflexe nach aufsteigendem Theta-Wert sortieren             ***
c******************************************************************************

      subroutine refsort(iref,mult,theta,rlopo,rint,rsig,cint,nhkl,
     *                   ctemp,itemp,temp,l,IRS)

      character cint(IRS)*5
      integer iref(IRS), mult(IRS)
      real theta(IRS), rlopo(IRS), rint(IRS), rsig(IRS)

      character ctemp(IRS)*5
      integer itemp(2,IRS), l(IRS)
      real temp(4,IRS)

      do 2 i=1,nhkl
         l(i) = i
2     continue
      m = nhkl - 1

      do 15 ll=1,IRS
         k = 0
         do 10 j=1,2
            do 10 i=j,m,2
               inp  = l(i)
               inp1 = l(i+1)
               r = theta(inp1) - theta(inp)   
               if(r.le.0) then
                 iz     = l(i)
                 l(i)   = l(i+1)
                 l(i+1) = iz
                 k = k + 1
               end if
10          continue
         if(k.eq.0) goto 5
15    continue

5     do 30 i=1,nhkl
         ctemp(i)   = cint(i)
         itemp(1,i) = iref(i)
         itemp(2,i) = mult(i)
         temp(1,i)  = theta(i)
         temp(2,i)  = rlopo(i)
         temp(3,i)  = rint(i)
         temp(4,i)  = rsig(i)
30    continue
      do 31 i=1,nhkl
         lx = l(i)
         cint(i)  = ctemp(lx)
         iref(i)  = itemp(1,lx)
         mult(i)  = itemp(2,lx)
         theta(i) = temp(1,lx)
         rlopo(i) = temp(2,lx)
         rint(i)  = temp(3,lx)
         rsig(i)  = temp(4,lx)
31    continue
      
      return
      end

 




c******************************************************************************
c***  Bei Reflexen, die am exakt gleichen Ort erscheinen, wird immer nur    ***
c***  einer verfeinert und die anderen gleich Null gesetzt                  ***
c******************************************************************************

      subroutine intsort(laue,defint,ratio,iref,rint,cint,nhkl,IRS)

      character cint(IRS)*5
      integer iref(IRS)
      real rint(IRS), ratio(2)


c --- Kubisch:

      if(laue.eq.10.or.laue.eq.11) then
        do 200 i=1,nhkl
           call dcodhkl(iref(i),ih,ik,il,in1,iq1)
           rint(i) = defint * ratio(iq1)
           cint(i)(1:1) = '1'
           ms1 = ih*ih + ik*ik + il*il 
           do 100 j=1,i-1
              call dcodhkl(iref(j),ih,ik,il,in2,iq2)
              if(iq2.eq.iq1.and.in1.eq.in2) then
                ms2 = ih*ih + ik*ik + il*il 
                if(ms1.eq.ms2) then
                  cint(i)(1:1) = '0'
                  rint(i) = 0.
                  goto 200
                end if
              end if 
 100       continue
 200    continue

c --- Tetragonal:

      else if(laue.eq.4.or.laue.eq.5) then
        do 400 i=1,nhkl
           call dcodhkl(iref(i),ih,ik,il1,in1,iq1)
           rint(i) = defint * ratio(iq1)
           cint(i)(1:1) = '1'
           ms1 = ih*ih + ik*ik 
           do 300 j=1,i-1
              call dcodhkl(iref(j),ih,ik,il2,in2,iq2)
              if(iq2.eq.iq1.and.in1.eq.in2.and.il1.eq.il2) then
                ms2 = ih*ih + ik*ik 
                if(ms1.eq.ms2) then
                  cint(i)(1:1) = '0'
                  rint(i) = 0.
                  goto 400
                end if
              end if 
 300       continue
 400    continue

c --- Hexagonal:

      else if(laue.eq.6.or.laue.eq.7.or.laue.eq.8.or.
     *        laue.eq.9.or.laue.eq.15) then
        do 600 i=1,nhkl
           call dcodhkl(iref(i),ih,ik,il1,in1,iq1)
           rint(i) = defint * ratio(iq1)
           cint(i)(1:1) = '1'
           ms1 = ih*ih + ik*ik + ih*ik 
           do 500 j=1,i-1
              call dcodhkl(iref(j),ih,ik,il2,in2,iq2)
              if(iq2.eq.iq1.and.in1.eq.in2.and.il1.eq.il2) then
                ms2 = ih*ih + ik*ik + ih*ik 
                if(ms1.eq.ms2) then
                  cint(i)(1:1) = '0'
                  rint(i) = 0.
                  goto 600
                end if
              end if 
 500       continue
 600    continue

c --- Rhomboedrisch:

      else if(laue.eq.13.or.laue.eq.14) then
        do 800 i=1,nhkl
           call dcodhkl(iref(i),ih,ik,il,in1,iq1)
           rint(i) = defint * ratio(iq1)
           cint(i)(1:1) = '1'
           ms1 = ih*ih + ik*ik + il*il
           ks1 = ih*ik + ih*il + ik*il
           do 700 j=1,i-1
              call dcodhkl(iref(j),ih,ik,il,in2,iq2)
              if(iq2.eq.iq1.and.in1.eq.in2) then
                ms2 = ih*ih + ik*ik + il*il
                ks2 = ih*ik + ih*il + ik*il
                if(ms1.eq.ms2.and.ks1.eq.ks2) then
                  cint(i)(1:1) = '0'
                  rint(i) = 0.
                  goto 800
                end if
              end if 
 700       continue
 800    continue

c --- Orthorhombisch, monoklin, triklin:

      else
        do 900 i=1,nhkl
           call dcodhkl(iref(i),ih,ik,il,in,iq)
           rint(i) = defint * ratio(iq)
           cint(i)(1:1) = '1'
 900    continue

      end if

      return
      end


c******************************************************************************
c***                    Intensitaeten ausgeben                              ***
c******************************************************************************

      subroutine intwrite(ka,IRS,imo,iref,mult,theta,rlopo,rint,rsig,
     *                    cint,nhkl)

      parameter (PI = 3.14159265359)
      integer h, k, l, iref(IRS), mult(IRS)
      real theta(IRS), rlopo(IRS), rint(IRS), rsig(IRS)
      character cint(IRS)*5

      if(imo.eq.1) then

        write(ka,'(a,a)') ' No. Co.     h   k   l   n  Mult   2-Theta',
     *'     Lopo     Intensity      sigma   R'
        do 100 i=1,nhkl
           call dcodhkl(iref(i),h,k,l,n,iq)
           th_obs = 360./PI * theta(i)
           read(cint(i)(1:1),'(i1)') icod
           write(ka,'(2i4,2x,4i4,i6,2f10.4,f13.4,f12.4,i3)') 
     *     i, iq, h, k, l, n, mult(i), th_obs, rlopo(i), rint(i), 
     *     rsig(i), icod
100     continue

      else

        write(ka,'(a,a)') ' No. Co.     h   k   l  Mult   2-Theta',
     *'     Lopo     Intensity      sigma   R'
        do 200 i=1,nhkl
           call dcodhkl(iref(i),h,k,l,n,iq)
           th_obs = 360./PI * theta(i)
           read(cint(i)(1:1),'(i1)') icod
           write(ka,'(2i4,2x,3i4,i6,2f10.4,f13.4,f12.4,i3)') 
     *     i, iq, h, k, l, mult(i), th_obs, rlopo(i), rint(i), 
     *     rsig(i), icod
200     continue

      end if

      return
      end


c******************************************************************************
c***             beobachtete Intensitaeten ausgeben berechnen               ***
c******************************************************************************

      subroutine iobscalc(nprof,rlim,wdt,t,eta1,eta2,asym,obs,
     *                    calc,bac,the,mit,izahl,IDZ,excl,iexcl,IEZ,
     *                    theta,hwb,rint,riobs,nhkl,IRS)
  
      parameter (PI = 3.14159265359, NP = 3)
      integer mit(IDZ)
      real obs(IDZ), calc(IDZ), bac(IDZ), the(IDZ), dprof(NP), t(3)
      real theta(IRS), hwb(IRS), riobs(IRS), rint(IRS), excl(2,IEZ)

      xmin = the(1) + pkshift(the(1),t,3)
      xmax = the(izahl) + pkshift(the(izahl),t,3)

      do 100 i=1,nhkl

c --- Reflexlage berechnen:

	 thobs  = 360./PI*theta(i)
	 tanth  = tan(theta(i))
	 if(tanth.eq.0.) tanth = 0.0001


C----- Excluded Regions beruecksichtigen:

	 do 75 m=1,iexcl
            ex1 = excl(1,m) + pkshift(excl(1,m),t,3)
            ex2 = excl(2,m) + pkshift(excl(2,m),t,3)
	    if((thobs.gt.ex1).and.(thobs.lt.ex2)) then
              riobs(i) = -1.
              goto 100
            end if
75       continue


c --- Bereich um den Reflex berechnen:

	 rmin = thobs - wdt * hwb(i)
	 rmax = thobs + wdt * hwb(i)
	 rmin = amax1(rmin,xmin)
	 rmax = amin1(rmax,xmax)


c --- beobachtete Intensitaet berechnen:

	 xiobs = 0.
	 do 80 k=1,izahl-1

            thecor = the(k) + pkshift(the(k),t,3)
            thecor1 = the(k+1) + pkshift(the(k+1),t,3)
            if(thecor.ge.rmin.and.thecor1.le.rmax.and.mit(k).eq.1) then

              delt = thecor - thobs

c --- Asymmetrie-Korrektur:

              if(thobs.le.rlim) then
                if(delt.ne.0.) then
                  s = sign(1.,delt)
                else
                  s = 0.
                end if
                as = 1. - asym * delt*delt * s/tanth
              else
                as = 1.
              end if

c --- Iobs berechnen:

              x = delt/hwb(i)
              width = thecor1 - thecor
              call profil(nprof,x,eta1,eta2,prof,dprof,NP)
              xiobs = xiobs + rint(i) * width * prof/hwb(i) * as
     *                       *(obs(k)-bac(k))/amax1(calc(k)-bac(k),1.)

            else if(thecor.gt.rmax) then

              goto 90

            end if

80       continue 

90       if(xiobs.lt.0.) xiobs = 0. 
         riobs(i) = xiobs

100   continue


      return 
      end


c******************************************************************************
c***       Beobachtete u. berechnete Intensitaeten ausgeben                 ***
c******************************************************************************

      subroutine iobswrite(ka,imo,iref,mult,theta,rint,riobs,nhkl,IRS)

      parameter (PI = 3.14159265359)
      integer iref(IRS), mult(IRS)
      real theta(IRS), riobs(IRS), rint(IRS)


      if(imo.eq.1) then

        write(ka,70)
70      format(/,'   No. Co.     h   k   l   n  Mult    Pos.',
     *'       Icalc        Iobs       Diff.')
        do 100 i=1,nhkl
           if(riobs(i).ge.0.) then
             call dcodhkl(iref(i),ih,ik,il,n,iq)
             thobs = 360./PI*theta(i)
             write(ka,82) i, iq, ih, ik, il, n, mult(i), thobs,
     *                    rint(i), riobs(i), riobs(i)-rint(i)
82           format(2x,2i4,2x,4i4,i6,f8.3,3f12.2)
           end if
100     continue

      else

        write(ka,170)
170     format(/,'   No. Co.     h   k   l  Mult    Pos.',
     *'       Icalc        Iobs       Diff.')
        do 200 i=1,nhkl
           if(riobs(i).ge.0.) then
             call dcodhkl(iref(i),ih,ik,il,n,iq)
             thobs = 360./PI*theta(i)
             write(ka,182) i, iq, ih, ik, il, mult(i), thobs,
     *                     rint(i), riobs(i), riobs(i)-rint(i)
182          format(2x,2i4,2x,3i4,i6,f8.3,3f12.2)
           end if
200     continue

      end if


      return
      end


C******************************************************************************
C***  Fitroutine nach J. K. Maichle - Levenberg-Marquardt-Methode           ***
C******************************************************************************

      subroutine jmfit_p(ix,maxs,mcycle,eps,relax,nphase,nprof,ibac,
     *                   ieich,xmin,xmax,wdt,rlim,rlamda,iref,mult,
     *                   theta,rlopo,hwb,corint,ic,imo,gitter,the,obs,
     *                   calc,gew,bac,mit,krr,izahl,excl,iexcl,glb,
     *                   aglb,lglb,par,apar,lpar,rint,aint,lint,ipar,
     *                   rjac,vx,param,out,iout,chisq,rp,rwp,swobs,num,
     *                   dersto,tann,deriv,mxx,myy,rjadu,vxdu,bcl,xloe,
     *                   MAPA,MSZ,IEZ,IDZ,IRS,LPHASE)

      logical ass
      character param(MAPA)*7
      integer imo(LPHASE), mxx(MSZ), myy(MSZ), krr(2,LPHASE,IDZ)
      integer lglb(10), lpar(19,LPHASE), lint(IRS), mit(IDZ)
      integer ipar(MSZ), iref(IRS), mult(IRS), ic(LPHASE)
      real rjac(MSZ,MSZ), vx(MSZ), out(MAPA,MSZ)
      real gitter(6,LPHASE), excl(2,IEZ), relax(30), rlamda(2) 
      real the(IDZ), obs(IDZ), calc(IDZ), gew(IDZ), bac(IDZ)
      real theta(IRS), hwb(IRS), rlopo(IRS), corint(IRS)
      real aglb(10), apar(19,LPHASE), aint(IRS)
      real glb(10), par(19,LPHASE), rint(IRS)
      real rjadu(MSZ,MSZ), vxdu(MSZ), bcl(MSZ,MSZ), tann(IRS)
      real xloe(MSZ), deriv(MSZ), dersto(MSZ,IRS)


c --- Initialisierung:

      ass = .true.
      hdy = 0.01
      urf = 1.00


c --- Schleife ueber die Anzahl der Zyklen:

      do 500 ix=1,mcycle

	 do 120 i=1,maxs
	    vx(i) = 0.
	    do 100 j=1,maxs
	       rjac(i,j) = 0.
100         continue
120      continue


c --- Berechnung von Theta, Hwb, Lopo, Intensitaet und Ableitungen:

         iend = 0
         do 150 ip=1,nphase
            ibeg = iend + 1
            iend = iend + ic(ip)
            call refcalc(maxs,dersto(1,ibeg),deriv,tann(ibeg),
     *                   rlamda,par(8,ip),par(9,ip),par(10,ip),
     *                   par(11,ip),par(14,ip),apar(1,ip),lpar(1,ip),
     *                   aglb,lglb,aint(ibeg),lint(ibeg),iref(ibeg),
     *                   mult(ibeg),theta(ibeg),hwb(ibeg),rlopo(ibeg),
     *                   rint(ibeg),corint(ibeg),ic(ip),IRS,MSZ)
150      continue

         if(ieich.eq.0) then
           xmin = the(1) + pkshift(the(1),glb(1),3)
           xmax = the(izahl) + pkshift(the(izahl),glb(1),3)
         end if

c --- Reflexe den Messpunkten zuordnen und "excluded regions"
c     beruecksichtigen:

         if(ass) then
           call assign(the,krr,mit,izahl,IDZ,LPHASE,glb,wdt,nphase,
     *                 xmin,xmax,excl,iexcl,IEZ,theta,hwb,ic,IRS)
         end if

         do 190 i=1,izahl

c --- Ableitungen auf Null setzen:

            do 165 m=1,maxs
               deriv(m) = 0.
165         continue

c --- Peak-shift correction:

            thecor = the(i) + pkshift(the(i),glb(1),3)

c --- Untergrund an der Stelle thecor und Ableitungen nach den 
c     Untergrund-Parametern berechnen:

            if(ibac.eq.0) then
              call backgr(bac(i),thecor,xmin,xmax,glb,lglb,aglb,
     *                    deriv,maxs,MSZ)
            end if
            calc(i) = bac(i)

c --- Profil ycalc an der Stelle thecor berechnen:

            ycalc = 0.
            if(mit(i).gt.0) then
              call calcxn_p(ycalc,the(i),thecor,krr(1,1,i),nprof,
     *                      nphase,LPHASE,rlim,lglb,par,lpar,
     *                      lint,dersto,deriv,maxs,MSZ,tann,theta,
     *                      hwb,corint,IRS)
            end if

c --- Matrix rjac und den Vektor vx berechnen:

            if(ibac.eq.0.or.(ibac.gt.0.and.mit(i).gt.0)) then
	      calc(i) = calc(i) + ycalc
	      diff = obs(i) - calc(i)
	      do 180 j=1,maxs
	         if(ipar(j).eq.j) then
	           x     = deriv(j) / gew(i)
	           vx(j) = vx(j) + diff * x
	           do 170 k=j,maxs
		      if(ipar(k).eq.k) then
		        rjac(j,k) = rjac(j,k) + x * deriv(k)
		      end if
170                continue
	         end if
180           continue
            end if

190      continue

 	 ilent = 0


c --- R-Werte berechnen:

         call rwert(IDZ,izahl,obs,calc,gew,bac,ibac,mit,chisq,
     *              rp,rwp,swobs,num)


c --- Chisq abspeichern:

	 chialt = chisq


         do 250 i=1,maxs
	    if(ilent.eq.1) then
	      rjac(i,i) = rjac(i,i)*(1.+hdy)
	    end if
	    do 240 j=i+1,maxs
	       rjac(j,i) = rjac(i,j)
240         continue
250      continue

	 do 252 i=1,maxs
	    vxdu(i) = vx(i)/sqrt(rjac(i,i))
	    do 251 j=1,maxs
	       rjadu(i,j) = rjac(i,j)/sqrt(rjac(i,i)*rjac(j,j))
251         continue
252      continue


c --- Gleichungssystem loesen:

	 call pivot(rjadu,MSZ,maxs,bcl,xloe,vxdu,s10,s20,ifehl,mxx,
     *              myy,wert)


c --- R-Werte ausrechnen:

         call rwert(IDZ,izahl,obs,calc,gew,bac,ibac,mit,chisq,
     *              rp,rwp,swobs,num)


	 ilent = 0
	 if(chisq.gt.chialt) ilent = 1

	 if(ilent.ne.0) then

	   lpot2 = 0
	   lpot1 = lpot1 + 1
	   hdy   = urf * (10.**lpot1)
	   goto 500

	 else

	   lpot1 = 0
	   lpot2 = lpot2 + 1
	   hdy   = urf/(10.**lpot2)

	   write(*,'(//2x,a,i3,a)') 'Fit in cycle',ix,':'
	   write(*,'(2x,a/)')       '================'

	   do 331 i=1,maxs
	      vx(i) = xloe(i)/sqrt(rjac(i,i))
	      do 330 j=1,maxs
		 rjadu(i,j) = bcl(i,j)/sqrt(rjac(i,i)*rjac(j,j))
330           continue
331        continue

	   do 334 i=1,maxs
	      do 333 j=1,maxs
		 rjac(i,j) = rjadu(i,j)
333           continue
334        continue

	   oom = chisq/real(num-maxs)
 
	   do 355 i=1,maxs
	      do 354 j=1,maxs
		 rjac(i,j) = rjac(i,j) * oom
354           continue
355        continue      


c --- Ausgabe der Parameter auf dem Bildschirm nach jedem Zyklus:

           call outcyc(ix,maxs,relax,nphase,nprof,imo,gitter,rlamda,
     *                 glb,aglb,lglb,par,apar,lpar,iref,rint,
     *                 aint,lint,ic,rjac,vx,param,out,iout,num,chisq,
     *                 rp,rwp,swobs,LPHASE,MAPA,MSZ,IRS,ass)

	 end if               

	
c ---  Abbruchbedingung:

	 do 450 i=1,maxs
	    x1 = sqrt(abs(rjac(i,i))) * eps
	    if(abs(vx(i)).gt.x1) goto 500
450      continue

	 if(hdy.gt.0.001) then
	   hdy = 0.
	   goto 500
	 end if 

	 goto 600

500   continue


c --- Ende der Iteration:

600   if(ix.gt.mcycle) then
        ix = mcycle
      else if(ix.lt.mcycle) then
        write(*,'(/2x,a,/2x,a)') 'Forced termination',
     *                           '=================='
      end if


      return
      end


C******************************************************************************
C***     Parameter, Verschiebungen und Standardabweichungen pro Zyklus      ***
C******************************************************************************

      subroutine outcyc(icycle,maxs,relax,nphase,nprof,imo,gitter,
     *                  rlamda,glb,aglb,lglb,par,apar,lpar,iref,
     *                  rint,aint,lint,ic,rjac,vx,param,out,iout,num,
     *                  chisq,rp,rwp,swobs,LPHASE,MAPA,MSZ,IRS,ass)

      parameter(RSH = 0.001)
      character tglb(10)*10, cpar(19)*10, cgl(10)*7, cpa(19)*7
      real sd(6), celld(6)

      logical ass
      character param(MAPA)*7, date*9, time*8
      integer lglb(10), lpar(19,LPHASE), lint(IRS), ic(LPHASE)
      integer iref(IRS), imo(LPHASE)
      real rjac(MSZ,MSZ), vx(MSZ), out(MAPA,MSZ)
      real gitter(6,LPHASE), relax(30), dc(6), rlamda(2)
      real glb(10), par(19,LPHASE), rint(IRS)
      real aglb(10), apar(19,LPHASE), aint(IRS)


c --- Texte fuer die Ausgabe:

      data tglb /'Zeropoint ','t1        ','t2        ','c0        ',
     *           'c1        ','c2        ','c3        ','c4        ',
     *           'c5        ','Wavelength'/
      data cgl /' Zero  ',' t1    ',' t2    ',' c0    ',' c1    ',
     *          ' c2    ',' c3    ',' c4    ',' c5    ','Lambda '/
   
      if(nprof.eq.5) then
        cpar(1) = 'Skewness  '
        cpa(1)  = ' Skew  '
      else if(nprof.eq.6) then
        cpar(1) = 'Eta       '
        cpa(1)  = ' Eta   '
      else if(nprof.eq.7) then
        cpar(1) = 'Pearson-M '
        cpa(1)  = ' Pe-M  '
      end if
      cpar(2)  = 'Excess    '
      cpar(3)  = 'Asymmetry '
      cpar(4)  = 'Scale     '
      cpar(5)  = 'O-Temp.   '
      cpar(6)  = 'G1        '
      cpar(7)  = 'G2        '
      cpar(8)  = 'U         '
      cpar(9)  = 'V         '
      cpar(10) = 'W         '
      cpar(11) = 'q1        '
      cpar(12) = 'q2        '
      cpar(13) = 'q3        '
      cpar(14) = 'A         '
      cpar(15) = 'B         '
      cpar(16) = 'C         '
      cpar(17) = 'Alpha     '
      cpar(18) = 'Beta      '
      cpar(19) = 'Gamma     '
      cpa(2)   = ' Exce  '
      cpa(3)   = ' Asym  '
      cpa(4)   = 'Scale  '
      cpa(5)   = 'O-Temp '
      cpa(6)   = ' G1    '
      cpa(7)   = ' G2    '
      cpa(8)   = '  U    '
      cpa(9)   = '  V    '
      cpa(10)  = '  W    '
      cpa(11)  = ' q1    '
      cpa(12)  = ' q2    '
      cpa(13)  = ' q3    '
      cpa(14)  = '  A    '
      cpa(15)  = '  B    '
      cpa(16)  = '  C    '
      cpa(17)  = 'Alpha  '
      cpa(18)  = ' Beta  '
      cpa(19)  = 'Gamma  '

c --- Formate:

110   format(2x,a10,16x,3f10.5)
111   format(2x,a10,10x,i2,4x,3f10.5)
112   format(2x,a,4i4,a,1x,i2,2x,2x,3f10.5)
113   format(2x,a,3i4,a,4x,1x,i2,2x,2x,3f10.5)

c --- Parameter verschieben und ausgeben:

      iout = 0
      write(*,'(22x,a)') 'phs    parameter     shift     stdd.'


c --- Globale Parameter:

      do 10 j=1,10
	 km = lglb(j)
	 if(km.ne.0.and.km.le.maxs) then

           stdd   = sqrt(abs(rjac(km,km))) * abs(aglb(j))
	   shift  = vx(km) * aglb(j) * relax(20+j)
	   glb(j) = glb(j) + shift
	   write(*,110) tglb(j), glb(j), shift, stdd

           if(j.le.3) then
             if(glb(j).eq.0.) then
               ass = .true.
             else if(abs(shift/glb(j)).gt.RSH) then
               ass = .true.
             end if
           end if

           iout = iout + 1
           param(iout) = cgl(j)
           out(iout,icycle) = glb(j)
  
           iout = iout + 1
	   param(iout) = 'Delt   '
	   out(iout,icycle) = shift

	   iout = iout + 1
	   param(iout) = 'Stdd   '
	   out(iout,icycle) = stdd

         end if
10    continue

c --- Wellenlaenge:

      rlamda(1) = glb(10)

c --- Parameter der einzelnen Phasen:

      iend = 0
      do 100 ip=1,nphase

         ibeg = iend + 1
         iend = iend + ic(ip)


c ---- Profilparameter, ... , Halbwertsbreite-Parameter, Wellenvektor:

         do 20 j=1,13
	    km = lpar(j,ip)
	    if(km.ne.0.and.km.le.maxs) then

              stdd      = sqrt(abs(rjac(km,km))) * abs(apar(j,ip))
	      shift     = vx(km) * apar(j,ip) * relax(j)
	      par(j,ip) = par(j,ip) + shift
	      write(*,111) cpar(j), ip, par(j,ip), shift, stdd

              if(j.ge.8) then
                if(par(j,ip).eq.0.) then
                  ass = .true.
                else if(abs(shift/par(j,ip)).gt.RSH) then
                  ass = .true.
                end if
              end if

              iout = iout + 1
              param(iout) = cpa(j)
              out(iout,icycle) = par(j,ip)
  
              iout = iout + 1
	      param(iout) = 'Delt   '
	      out(iout,icycle) = shift

	      iout = iout + 1
	      param(iout) = 'Stdd   '
	      out(iout,icycle) = stdd

            end if
20       continue


c --- reziproke Gitterkonstanten:

         do 30 j=14,19
	    km = lpar(j,ip)
	    if(km.ne.0.and.km.le.maxs) then
              sd(j-13)  = sqrt(abs(rjac(km,km))) * abs(apar(j,ip))
	      shift     = vx(km) * apar(j,ip) * relax(j)
	      par(j,ip) = par(j,ip) + shift
            end if
30       continue


c --- Berechnung der direkten Gitterkonstanten:

         call direct(par(14,ip),sd,celld,dc,vol,dvol)


c --- Gitterkonstanten a, b, c, alpha, beta, gamma:

         do 40 i=1,6
            km = lpar(13+i,ip)
            if(km.ne.0.and.km.le.maxs) then

              shift        = celld(i) - gitter(i,ip)
              stdd         = dc(i)
              gitter(i,ip) = celld(i)
              write(*,111) cpar(13+i), ip, celld(i), shift, stdd

              if(par(j,ip).eq.0.) then
                ass = .true.
              else if(abs(shift/celld(i)).gt.RSH) then
                ass = .true.
              end if

              iout = iout + 1
              param(iout) = cpa(13+i)
              out(iout,icycle) = celld(i)

              iout = iout + 1
              param(iout) = 'Delt   '
              out(iout,icycle) = shift

              iout = iout + 1
              param(iout) = 'Stdd   '
              out(iout,icycle) = stdd

            end if
40       continue


c --- Intensitaeten:

         nn = 0
         do 50 j=ibeg,iend
            nn = nn + 1
	    km = lint(j)
	    if(km.ne.0.and.km.le.maxs) then

              call dcodhkl(iref(j),ih,ik,il,in,iq)
              stdd    = sqrt(abs(rjac(km,km))) * abs(aint(j))
	      shift   = vx(km) * aint(j) * relax(20)
	      rint(j) = rint(j) + shift
              if(imo(ip).eq.1) then
                write(*,112) 
     *               'I(',ih,ik,il,in,')',ip,rint(j), shift, stdd 
              else
                write(*,113) 
     *               'I(',ih,ik,il,')',ip,rint(j), shift, stdd 
              end if

              iout = iout + 1
              param(iout) = 'I      '
              write(param(iout)(2:5),'(i4)') nn
              out(iout,icycle) = rint(j)


              iout = iout + 1
	      param(iout) = 'Delt   '
	      out(iout,icycle) = shift

	      iout = iout + 1
	      param(iout) = 'Stdd   '
	      out(iout,icycle) = stdd

            end if
50       continue

100   continue


c --- R-Werte der einzelnen Datensaetze:

      idges = 1
      do 200 id=1,idges

c --- Profil-R-Wert:
 
         iout = iout + 1
         param(iout) = 'Rp     '
         out(iout,icycle) = rp

c --- Gewichteter Profil-R-Wert:

         iout = iout + 1
         param(iout) = 'Rwp    '
         out(iout,icycle) = rwp

c --- Zahl der Freiheitgrade N - P:

         ii = num - maxs

c --- Erwarteter R-Wert:

         rexp = 100. * sqrt(real(ii)/swobs)
         iout = iout + 1
         param(iout) = 'Rexp   '
         out(iout,icycle) = rexp

c --- Goodness-of-fit:

         gof = sqrt(chisq/real(ii))
         iout = iout + 1
         param(iout) = 'Gof    '
         out(iout,icycle) = gof
 
c --- N_sigma:

         rsig = (chisq - ii)/sqrt(2.*ii)
         iout = iout + 1
         param(iout) = 'Nsig   '
         out(iout,icycle) = rsig

200   continue


c --- Profil-R-Wert:

      iout = iout + 1
      param(iout) = 'Rp     '
      out(iout,icycle) = rp

c --- Gewichteter Profil-R-Wert:

      iout = iout + 1
      param(iout) = 'Rwp    '
      out(iout,icycle) = rwp

c --- Zahl der Freiheitgrade N - P:

      ii = num - maxs

c --- Erwarteter R-Wert:

      rexp = 100. * sqrt(real(ii)/swobs)
      iout = iout + 1
      param(iout) = 'Rexp   '
      out(iout,icycle) = rexp

c --- Goodness-of-fit:

      gof = sqrt(chisq/real(ii))
      iout = iout + 1
      param(iout) = 'Gof    '
      out(iout,icycle) = gof

c --- N_sigma:

      rsig = (chisq - ii)/sqrt(2.*ii)
      iout = iout + 1
      param(iout) = 'Nsig   '
      out(iout,icycle) = rsig

c --- R-Werte ausgeben:

      call datum(date,time)              
      write(*,'(/2x,a,i4,27x,a9,4x,a8)') 
     *'Fit in cycle ',icycle,date,time 
      write(*,'(2x,65a)') ('-',j=1,65)
      write(*,'(3(a,f11.4,2x))')
     *'  Rp    = ',rp, ' Rwp    = ',rwp,     ' Rexp   = ',rexp
      write(*,'(a,f11.4,2x,a,i5,8x,a,f11.4)')
     *'  Gof   = ',gof,' N-P    = ',num-maxs,' Nsig   = ',rsig


      return
      end


C******************************************************************************
C***                     Berechnung der R-Werte                             ***
C******************************************************************************

      subroutine rwert(IDZ,izahl,obs,calc,gew,bac,ibac,mit,chisq,
     *                 rp,rwp,swobs,num)

      integer mit(IDZ)
      real obs(IDZ), calc(IDZ), gew(IDZ), bac(IDZ)


      num   = 0
      chisq = 0.
      swobs = 0.
      sbobs = 0.
      sbdif = 0.         

      if(ibac.eq.0) then
        do 10 j=1,izahl
	   num   = num + 1
	   sbdif = sbdif + abs(obs(j)-calc(j))
	   sbobs = sbobs + abs(obs(j))
	   chisq = chisq + 1./gew(j)*(obs(j)-calc(j))**2.
	   swobs = swobs + 1./gew(j)*obs(j)**2.
10      continue
      else
        do 20 j=1,izahl
	   if(mit(j).eq.1) then
	     num   = num + 1
	     sbdif = sbdif + abs(obs(j)-calc(j))
	     sbobs = sbobs + abs(obs(j)-bac(j))
	     chisq = chisq + 1./gew(j)*(obs(j)-calc(j))**2.
	     swobs = swobs + 1./gew(j)*(obs(j)-bac(j))**2.
	   end if
20      continue
      end if
	
      rp  = 100. * sbdif/sbobs 
      rwp = 100. * sqrt(chisq/swobs)

      return
      end


c******************************************************************************
c***  Testen, ob Gitterkonstanten mit der Laue-Gruppe vertraeglich sind     ***
c******************************************************************************

      integer function metchk(a,laue)
      
      parameter(EPSY = 0.000001)
      real a(6)


      ierr = 0

c --- Alpha-Winkel:

      if((laue.ge.2.and.laue.le.12).or.laue.eq.15) then
        if(abs(a(4)-90.).gt.EPSY) then 
          write(*,'(/2x,a)') 'ERROR: Alpha not equal 90 degrees'
          ierr = ierr + 1
        end if
      end if

c --- Beta-Winkel:

      if((laue.ge.2.and.laue.le.11).or.laue.eq.15) then
        if(abs(a(5)-90.).gt.EPSY) then 
          write(*,'(/2x,a)') 'ERROR: Beta not equal 90 degrees'
          ierr = ierr + 1
        end if
      end if

c --- Gamma-Winkel:

      if((laue.ge.3.and.laue.le.5).or.
     *   (laue.ge.10.and.laue.le.12)) then
        if(abs(a(6)-90.).gt.EPSY) then 
          write(*,'(/2x,a)') 'ERROR: Gamma not equal 90 degrees'
          ierr = ierr + 1
        end if
      else if((laue.ge.6.and.laue.le.9).or.laue.eq.15) then 
        if(abs(a(6)-120.).gt.EPSY) then 
          write(*,'(/2x,a)') 'ERROR: Gamma not equal 120 degrees'
          ierr = ierr + 1
        end if
      end if

c --- a- und b-Achse bei tetragonalen und hexagonalen Zellen:

      if((laue.ge.4.and.laue.le.9).or.laue.eq.15) then
        if(abs(a(1)-a(2)).gt.EPSY) then 
          write(*,'(/2x,a)') 'ERROR: a not equal b '
          ierr = ierr + 1
        end if
      end if

c --- a-, b- und c-Achse bei kubischen und rhomboedrischen Zellen:

      if(laue.eq.10.or.laue.eq.11.or.
     *   laue.eq.13.or.laue.eq.14) then
        if(abs(a(1)-a(2)).gt.EPSY.or.abs(a(1)-a(3)).gt.EPSY.or.
     *     abs(a(2)-a(3)).gt.EPSY) then 
          write(*,'(/2x,a)') 'ERROR: a, b and c are not equal'
          ierr = ierr + 1
        end if
      end if

c --- Alpha-, Beta- und Gamma-Winkel bei rhomboedrischen Zellen:

      if(laue.eq.13.or.laue.eq.14) then
        if(abs(a(4)-a(5)).gt.EPSY.or.abs(a(4)-a(6)).gt.EPSY.or.
     *     abs(a(5)-a(6)).gt.EPSY) then 
          write(*,'(/2x,a)') 
     *    'ERROR: Alpha, beta and gamma are not equal'
          ierr = ierr + 1
        end if
      end if

      metchk = ierr
      return
      end

C******************************************************************************
C***            Name der Ausgabe-Datei erzeugen                             ***
C******************************************************************************

      subroutine outfil(name,file,filspe,laenge,nr)

      parameter(MAX = 80)
      character filspe*3, file*80, name*80, form*4


c --- Initialisierung:

      name = ' '

c --- Zehnerpotenz der Zahl NR bestimmen:

      nz = 0
      if(nr.gt.0) nz = int(alog10(real(nr))) + 1

c --- Ende suchen:

      do 50 i = MAX,1,-1
         if(file(i:i).eq.'.') then
           iend = i - 1
           goto 60
         end if
50    continue

c --- Anfang suchen:

60    do 100 i = MAX,1,-1
         if(file(i:i).eq.'/'.or.file(i:i).eq.']') then
           ibeg = i + 1
           goto 120
         end if
100   continue
      ibeg = 1    

c --- Basisnamen abspeichern:
      
      n = 0
120   do 200 i = ibeg,iend
         if(file(i:i).ne.' ') then
           n = n + 1
           name(n:n) = file(i:i)
         end if
200   continue     
    
c --- Laufende Nummer und Extension anhaengen:

      form = '(i )'
      write(form(3:3),'(i1)') nz
      if(nz.gt.0) write(name(n+1:n+nz),form) nr
      name(n+nz+1:n+nz+1) = '.'
      name(n+nz+2:n+nz+4) = filspe(1:3)
      laenge = n + nz + 4

      return
      end
C******************************************************************************
C***  Ausgabe der Fit-Ergebnisse auf dem Bildschirm nach der Verfeinerung   ***
C******************************************************************************

      subroutine outlas_p(ka,icycle,imo,maxs,relax,phsnm,nphase,nprof,
     *                    ibac,gitter,glb,aglb,lglb,par,apar,lpar,rjac,
     *                    vx,num,swobs,chisq,rp,rwp,LPHASE,MSZ)

      parameter (PI = 3.14159265359)

      real std(19), s(19), thwb(3), hwb(3), shwb(3), delta(6), celld(6)

      character phsnm(LPHASE)*4
      integer lglb(10), lpar(19,LPHASE), imo(LPHASE)
      real relax(30), gitter(6,LPHASE), rjac(MSZ,MSZ), vx(MSZ)
      real glb(10), par(19,LPHASE), aglb(10), apar(19,LPHASE)

      data thwb/20.,60.,100./


      write(ka,'(//2x,a,i4)') 'Cycle number = ',icycle
      write(ka,'(//2x,a,/2x,a)')
     *'New parameters, shifts and standard deviations:',
     *'==============================================='

      do 100 ip=1,nphase

         write(ka,'(/2x,a,i2,a,a4)') 'Phase ',ip,': ',phsnm(ip)

C --- Parameter der einzelnen Phasen:

         DO 60 j=1,19
            KM = LPAR(j,ip)
            IF(KM.NE.0) then
              std(j) = SQRT(ABS(RJAC(KM,KM))) * ABS(APAR(j,ip))
              s(j)   = VX(KM) * APAR(j,ip) * RELAX(j)
            else
	      std(j) = 0.
	      s(j)   = 0.
	    end if
60       CONTINUE

C --- Direkte Gitterkonstanten berechnen:

         call direct(par(14,ip),std(14),celld,delta,vol,dvol)

         DO 70 I=1,6
            KM = LPAR(13+I,ip)
            IF(KM.NE.0.AND.KM.LE.MAXS) THEN
              std(13+i) = DELTA(I)
	      s(13+i)   = CELLD(I) - GITTER(I,ip)
	    ELSE
              std(13+i) = 0.
	      s(13+i)   = 0.
	    END IF
70       CONTINUE

C --- Parameter der Profilfunktion ausgeben:

         if(nprof.eq.5) then
	   write(ka,'(/2x,a,3f8.3,/2x,a,3f8.4)')
     *          'Skewness = ', par(1,ip), std(1), s(1),
     *          'Excess   = ', par(2,ip), std(2), s(2)
         else if(nprof.eq.6) then
           write(ka,'(/2x,a,3f8.4)')
     *          'Eta (Pseudo-Voigt) = ', par(1,ip), std(1), s(1)
         else if(nprof.eq.7) then
	   write(ka,'(/2x,a,3f8.4)')
     *          'Pearson-M = ', par(1,ip), std(1), s(1)
         end if

C --- Asymmetrie-Parameter ausgeben:

         write(ka,'(/2X,A,3F9.5)') 
     *        'Asymmetry parameter = ',PAR(3,ip),std(3),s(3)

C --- Berechnen der Halbwertsbreiten sowie der dazugehoerigen
C     Standardabweichungen
  
         do 80 j=1,3
            th   = thwb(j) * PI/360.
            tgt  = sin(th)/cos(th)
            hwb2 = par(8,ip) * tgt*tgt + par(9,ip) * tgt + par(10,ip)
            if(hwb2.ge.0.) then
              hwb(j)  = sqrt(hwb2)
              shwb(j) = sqrt(tgt**4 * std(8)*std(8) 
     *        + tgt*tgt * std(9)*std(9) + std(10)*std(10))/(2.*hwb(j))
            else
              hwb(j) = -1.0
            end if
80       continue

C --- Halbwertsbreite-Parameter ausgeben:

         write(ka,'(/2x,a,20x,a,3(/2x,a,3f10.6,8x,f6.2,1x,2(1x,f9.6)))')
     *        'Halfwidth parameters:','2-Theta     Fwhm     SFwhm',
     *        'U = ',PAR( 8,ip),std( 8),S( 8), THWB(1),HWB(1),SHWB(1),
     *        'V = ',PAR( 9,ip),std( 9),S( 9), THWB(2),HWB(2),SHWB(2),
     *        'W = ',PAR(10,ip),std(10),S(10), THWB(3),HWB(3),SHWB(3)

C --- Q-Vektor ausgeben:

         if(imo(ip).eq.1) then
	   write(ka,'(/2x,a,3(/2x,a,3f9.5))')
     *          'Wave vector of the modulation:',
     *          'q1 = ',par(11,ip), std(11), s(11),
     *          'q2 = ',par(12,ip), std(12), s(12),
     *          'q3 = ',par(13,ip), std(13), s(13)
         end if

C --- Gitterkonstanten ausgeben:

         write(ka,'(/2x,a,6(/2x,a,3f11.6))')
     *        'Cell parameters:',
     *        'A     = ',celld(1), std(14), s(14),
     *        'B     = ',celld(2), std(15), s(15),
     *        'C     = ',celld(3), std(16), s(16),
     *        'Alpha = ',celld(4), std(17), s(17),
     *        'Beta  = ',celld(5), std(18), s(18),
     *        'Gamma = ',celld(6), std(19), s(19)

         write(ka,'(/2x,a,2f11.3)') 'Cell volume = ',vol, dvol

100   continue


c --- Globale Parameter:

      do 190 j=1,10
         km = lglb(j)
         if(km.ne.0) then
           std(j) = sqrt(abs(rjac(km,km))) * abs(aglb(j))
   	   s(j)   = vx(km) * aglb(j) * relax(20+j)
         else
           std(j) = 0.
           s(j)   = 0.
         end if
190   continue

      write(ka,'(//2x,a)') 'Global parameters:'

c --- Peak-Shift-Parameter ausgeben:

      write(ka,'(/2x,a,3f8.4,2(/2x,a,3(2x,g10.4)))')
     *     'Zeropoint = ', glb(1), std(1), s(1),
     *     'Peak-shift parameter t1 = ', glb(2), std(2), s(2),
     *     'Peak-shift parameter t2 = ', glb(3), std(3), s(3)

c --- Untergrund-Parameter ausgeben:

      if(ibac.eq.0) then
        write(ka,'(/2x,a,6(/2x,a,3f7.2))')
     *       'Background parameters:',
     *       'c0 = ',glb(4), std(4), s(4),
     *       'c1 = ',glb(5), std(5), s(5),
     *       'c2 = ',glb(6), std(6), s(6),
     *       'c3 = ',glb(7), std(7), s(7),
     *       'c4 = ',glb(8), std(8), s(8),
     *       'c5 = ',glb(9), std(9), s(9)
      end if

c --- Wellenlaenge:

         write(ka,'(/2x,a,3f10.6)')
     *        'Wavelength L1 = ',glb(10),std(10),s(10)

C --- Gesamt-R-Werte ausgeben:

      ii = num - maxs
      gof  = sqrt(chisq/real(ii))
      rsig = (chisq - ii)/sqrt(2.*ii)
      rexp = 100.*sqrt(ii/swobs)

      write(ka,'(//2x,a,/2x,a)')  'R-Factors:',
     *                            '=========='
      write(ka,'(/2x,3(a,f8.2))')
     *'Rp  = ',rp,'     Rwp = ',rwp,'     Rexp = ',rexp
      write(ka,'(/2x,a,i8,a,f8.2,a,f8.2)') 
     *'N-P = ',ii,'     Gof = ',gof,'     Nsig = ',rsig     
      write(ka,'(/2x,a,g10.4/)') 'Res = ',chisq

      return
      end


c******************************************************************************
c***               Schreiben des CYCLUS-Files                               ***
c******************************************************************************

      SUBROUTINE OUTMAT(KCYC,ICYCLE,IDGES,ISP,MCYCLE,MAPA,MSZ,IDAT,
     *                  titel,PARAM,OUT,IOUT)

      CHARACTER PARAM(MAPA)*7, titel(IDAT)*70, date*9, time*8
      REAL OUT(MAPA,MSZ)


c --- Datum, Uhrzeit und Titel schreiben:

      call datum(date,time)
      write(kcyc,'(1x,a,4x,a)') date, time
      do 15 id=1,idges
         write(kcyc,'(/1x,a)') titel(id)
15    continue
      write(kcyc,*)
      write(kcyc,*)


c --- Zahl der R-Werte:

      ID4 = IDGES*5 + 5 


c --- Ausgabe mit 80 Zeichen pro Zeile:

      IF(ISP.EQ.0) THEN

	IMOD = 0
	MA   = (IOUT-ID4)/3
	IMOD = MOD(MA,2)
	IF(IMOD.NE.0) THEN
	  MA = MA-1
	END IF
	MA = MA/2

	DO 320 K=1,MA
	   WRITE(KCYC,340) (PARAM(IP),IP=(K-1)*6+1,(K-1)*6+6)
	   DO 300 I=1,ICYCLE
	      WRITE(KCYC,310) I,(OUT(J,I),J=(K-1)*6+1,(K-1)*6+6)
300        CONTINUE
	   WRITE(KCYC,*)
320     CONTINUE

	IF(IMOD.NE.0) THEN
	  WRITE(KCYC,340) (PARAM(IP),IP=MA*6+1,MA*6+3)
	  DO 302 I=1,ICYCLE
	     WRITE(KCYC,310) I,(OUT(J,I),J=MA*6+1,MA*6+3)
302       CONTINUE
	  WRITE(KCYC,*)
	END IF

310     FORMAT(1x,I2,2(' |',F10.5,F9.5,F9.5))
340     FORMAT(4x,2(4X,A7,3X,A7,2X,A7))


c --- Ausgabe mit 132 Zeichen pro Zeile:

      ELSE

	IMOD = 0
	MA   = (IOUT-5)/3
	IMOD = MOD(MA,4)
	IF(IMOD.NE.0) THEN
	  MA = MA-IMOD
	END IF
	MA = MA/4

	DO 420 K=1,MA
	   WRITE(KCYC,440) (PARAM(IP),IP=(K-1)*12+1,(K-1)*12+12)
	   DO 400 I=1,ICYCLE
	      WRITE(KCYC,410) I,(OUT(J,I),J=(K-1)*12+1,(K-1)*12+12)
400        CONTINUE
	   WRITE(KCYC,*)
420     CONTINUE

	IF(IMOD.NE.0) THEN
	  IEND = IMOD*3
	  WRITE(KCYC,440) (PARAM(IP),IP=MA*12+1,MA*12+IEND)
	  DO 402 I=1,ICYCLE
	     WRITE(KCYC,410) I,(OUT(J,I),J=MA*12+1,MA*12+IEND)
402       CONTINUE
	  WRITE(KCYC,*)
	END IF

410     FORMAT(1x,I2,4(' |',F10.5,F8.5,F8.5))       
440     FORMAT(4x,4(4X,A7,2X,A7,1X,A7))

      END IF


c --- R-Werte pro Zyklus ins CYCLUS-File schreiben :

      DO 367 K=1,IDGES + 1

	 IR1 = (K-1)*5 + 1
	 IR2 = (K-1)*5 + 5
	 WRITE(KCYC,316) (PARAM(IP),IP=IOUT-ID4+IR1,IOUT-ID4+IR2)
	 DO 330 I=1,ICYCLE
	    WRITE(KCYC,315) I,(OUT(J,I),J=IOUT-ID4+IR1,IOUT-ID4+IR2)
330      CONTINUE

315      FORMAT(1x,I2,5(' |',F12.5))
316      FORMAT(5x,5(6X,A7,1X))

367   CONTINUE


c --- Forced termination:

      IF(ICYCLE.LT.MCYCLE) THEN
	WRITE(KCYC,'(//1X,A,/1X,A)') 'Forced termination',
     *                               '=================='
      END IF


      RETURN
      END


c******************************************************************************
c***                   Kodierung der Parameter                              ***
c******************************************************************************

      subroutine parcod(cglb,cpar,cint,aglb,apar,aint,lglb,lpar,lint,
     *                  ipar,iref,ic,IRS,LPHASE,nphase,nprof,MSZ,maxs,
     *                  laue,imo,ratio)

      parameter(EPSY = 0.000001)

      external mprchk

      integer jcd(15)
      integer ic(LPHASE), ipar(MSZ), laue(LPHASE), imo(LPHASE)
      integer lglb(10), lpar(19,LPHASE), lint(IRS), iref(IRS)
      real aglb(10), apar(19,LPHASE), aint(IRS), ratio(2)
      character*5 cglb(10), cpar(20,LPHASE), cint(IRS)
      character cg(10)*33, cp(19)*33

      data jcd /1,2,3,8,9,10,11,12,13,14,15,16,17,18,19/

      data cg /'peak-shift param. t0 (zeropoint) ',
     *         'peak-shift parameter t1          ',
     *         'peak-shift parameter t2          ',
     *         'background parameter c0          ',
     *         'background parameter c1          ',
     *         'background parameter c2          ',
     *         'background parameter c3          ',
     *         'background parameter c4          ',
     *         'background parameter c5          ',
     *         'Wavelength L1                    '/
      data cp /'skewness/eta/Pearson-M           ',
     *         'excess                           ',
     *         'asymmetry parameter              ',
     *         'overall scale factor s           ',
     *         'overall temperature factor       ',
     *         'preferred orientation parameter 1',
     *         'preferred orientation parameter 1',
     *         'halfwidth parameter U            ',
     *         'halfwidth parameter V            ',
     *         'halfwidth parameter W            ',
     *         'wave vector component q1         ',
     *         'wave vector component q2         ',
     *         'wave vector component q3         ',
     *         'a axis                           ',
     *         'b axis                           ',
     *         'c axis                           ',
     *         'alpha angle                      ',
     *         'beta angle                       ',
     *         'gamma angle                      '/


      k = 0

111   format('Too many parameters! Only ',i5,' parameters are allowed.')   


c --- Globale Parameter:

c --- Code auf unzulaessige Zeichen untersuchen und freie Parameter suchen:

      do 10 n=1,10
         if(cglb(n)(1:1).ne.'0'.and.cglb(n)(1:1).ne.'1') then
           write(*,'(/2x,2a)') 'ERROR: Bad coding of the ',cg(n)   
           stop
         end if
         aglb(n) = 0.
         if(cglb(n)(1:1).eq.'1') then
           k = k + 1
           if(k.gt.MSZ) then
             write(*,111) MSZ
             stop
           end if
           aglb(n) = 10. * k + 1.
         else if(cglb(n)(1:1).eq.'=') then
           read(cglb(n)(2:3),'(i2)') j 
           aglb(n) = aglb(j)
         end if
10    continue

c --- Ausgabe der Kodierung:

      if(aglb(1).gt.0.01.or.aglb(2).gt.0.01.or.aglb(3).gt.0.01) 
     *  write(*,'(2x,a,3f8.2)') 
     *  'Zeropoint, peak-shift param. = ',(aglb(i),i=1,3)
      if(aglb(4).gt.0.01.or.aglb(5).gt.0.01.or.aglb(6).gt.0.01.or.
     *   aglb(7).gt.0.01.or.aglb(8).gt.0.01.or.aglb(9).gt.0.01)
     *  write(*,'(2x,a,6f8.2)') 
     *       'Background parameters = ',(aglb(i),i=4,9)
      if(aglb(10).gt.0.01) 
     *  write(*,'(2x,a,f8.2)') 'Wavelength L1 = ',aglb(10)

      do 11 n=1,10
         x = aglb(n)
         iyy = int(abs(x)/10.)
         lglb(n) = iyy
         aglb(n) = (abs(x)-10.*iyy) * sign(1.,x)
         if(iyy.ne.0) ipar(iyy) = iyy
11    continue


c --- Parameter der Phasen (1-17):

      iend = 0
      do 100 ip=1,nphase
         ibeg = iend + 1
         iend = iend + ic(ip)

         nph = 0 
         do 18 n=1,20
            if(cpar(n,ip)(1:1).ne.'0') nph = nph + 1
18       continue

         if(nphase.gt.1.and.nph.gt.0) 
     *     write(*,'(/2x,a,i2,a)') 'Phase ',ip,':'

c --- Profilparameter, ... , Halbwertsbreiten-Parameter, 
c     Wellenvektor und Gitterkonstanten:

c --- Code auf unzulaessige Zeichen untersuchen:

         do 30 n=1,19
            if(cpar(n,ip)(1:1).ne.'0'.and.cpar(n,ip)(1:1).ne.'1'.and.
     *         cpar(n,ip)(1:1).ne.'%'.and.cpar(n,ip)(1:1).ne.'=') then
              write(*,'(/2x,2a)') 'ERROR: Bad coding of the ',cp(n)   
              stop
            end if
            if(cpar(n,ip)(1:1).eq.'%') then
              read(cpar(n,ip)(2:3),'(i2)') np
              if(np.le.0.or.np.ge.ip) then
                write(*,'(/2x,2a)') 'ERROR: Bad coding of the ',cp(n)   
                stop
              end if
            end if
30       continue

c --- Kodierung der Gitterkonstanten ueberpruefen:

         if(mprchk(cpar(14,ip),laue(ip)).ne.0) stop

c --- Freie Parameter suchen:

         do 40 n=1,19
            apar(n,ip) = 0.
            if(cpar(n,ip)(1:1).eq.'1') then
              k = k + 1
              if(k.gt.MSZ) then
                write(*,111) MSZ
                stop
              end if
              apar(n,ip) = 10. * k + 1.
            else if(cpar(n,ip)(1:1).eq.'=') then
              read(cpar(n,ip)(2:3),'(i2)') j
              apar(n,ip) = apar(jcd(j),ip)
            else if(cpar(n,ip)(1:1).eq.'%') then
              read(cpar(n,ip)(2:3),'(i2)') j 
              apar(n,ip) = apar(n,j)
            end if
40       continue

c --- Profilparameter:

         if(nprof.le.4.or.nprof.eq.8) then
           if(apar(1,ip).gt.0.01.or.apar(2,ip).gt.0.01) then
             write(*,'(/2x,3a)') 
     *       'ERROR: Profile parameter "Skewness/Eta/Pearson-M"
     * cannot be refined'
             stop
           end if

         else if(nprof.eq.5) then
           if(apar(1,ip).gt.0.01.or.apar(2,ip).gt.0.01) then
             write(*,'(2x,a,2f8.2)') 
     *       'Skewness, Excess = ',apar(1,ip), apar(2,ip)
           end if

         else if(nprof.eq.6.or.nprof.eq.7) then
           if(apar(2,ip).gt.0.01) then 
             write(*,'(/2x,2a)') 
     *       'ERROR: Profile parameter "Excess" cannot be refined'   
             stop
           end if
           if(apar(1,ip).gt.0.01) then
             if(nprof.eq.6) then
               write(*,'(2x,a,f8.2)') 'Eta (Pseudo-Voigt) = ',apar(1,ip)
             else if(nprof.eq.7) then         
               write(*,'(2x,a,f8.2)') 'Pearson-M = ',apar(1,ip)
             end if
           end if
         end if

c --- Asymmetrie-Parameter:

         if(apar(3,ip).gt.0.01) write(*,'(2x,a,f8.2)') 
     *     'Asymmetry parameter = ',apar(3,ip)

c --- Halbwertsbreite-Parameter:

         if(apar(8,ip).gt.0.01.or.apar(9,ip).gt.0.01.or.
     *      apar(10,ip).GT.0.01) write(*,'(2x,a,3f8.2)') 
     *     'Halfwidth parameters = ',(apar(n,ip),n=8,10) 

c --- Wellenvektor:

         if(apar(11,ip).gt.0.01.or.apar(12,ip).gt.0.01.or.
     *      apar(13,ip).gt.0.01) then
           if(imo(ip).eq.1) then
             write(*,'(2x,a,3f8.2)') 
     *       'Wave vector of the modulation = ',(apar(n,ip),n=11,13)
           else
             write(*,'(/2x,2a)') 'ERROR: Wave vector cannot be refined'
           end if
         end if

c --- Gitterkonstanten:

         if(apar(14,ip).gt.0.01.or.apar(15,ip).gt.0.01.or.
     *      apar(16,ip).gt.0.01.or.apar(17,ip).gt.0.01.or.
     *      apar(18,ip).gt.0.01.or.apar(19,ip).gt.0.01)
     *     write(*,'(2x,a,6f8.2)') 
     *     'Cell constants = ',(apar(n,ip),n=14,19)


c --- Intensitaeten:

         if(cpar(20,ip)(1:1).eq.'1') then
           do 90 n=ibeg,iend
              call dcodhkl(iref(n),ih,ik,il,in,iq)
              do 85 j=ibeg,n-1
                 call dcodhkl(iref(j),jh,jk,jl,jn,jq)
                 if(ih.eq.jh.and.ik.eq.jk.and.il.eq.jl.and.
     *              in.eq.jn) then
                    aint(n) = aint(j) - 1. + ratio(iq)
                    goto 90
                 end if
85            continue
              aint(n) = 0.
              if(cint(n)(1:1).eq.'1') then
                k = k + 1
                if(k.gt.MSZ) then
                  write(*,111) MSZ
                  stop
                end if
                aint(n) = 10. * k + 1
              else if(cint(n)(1:1).eq.'=') then
                read(cint(n)(2:5),'(i4)') j 
                aint(n) = aint(j)
              end if
90         continue
           itop = nint(amin1(7.,real(ic(ip))))
           write(*,'(2x,a,7f8.2)') 'Intensities =   ',
     *     (aint(n),n=ibeg,ibeg+itop-1)
           write(*,'(2x,9f8.2)') (aint(n),n=ibeg+itop+1,iend)
         else
           do 92 n=ibeg,iend
              aint(n) = 0.
              lint(n) = 0
92         continue
         end if

100   continue

      maxs = k


      iend = 0
      do 200 ip=1,nphase
         ibeg = iend + 1
         iend = iend + ic(ip)

         do 150 n=1,19
            x = apar(n,ip)
            iyy = int(abs(x)/10.)
            lpar(n,ip) = iyy
            apar(n,ip) = (abs(x)-10.*iyy)*sign(1.,x)
            if(iyy.ne.0) ipar(iyy) = iyy
150      continue

         do 170 n=ibeg,iend
            x = aint(n)
            iyy = int(abs(x)/10.)
            lint(n) = iyy
            aint(n) = (abs(x)-10.*iyy)*sign(1.,x)
            if(iyy.ne.0) ipar(iyy) = iyy
170      continue

200   continue


      return
      end


c******************************************************************************
c***           Kodierung der Parameter testen                               ***
c******************************************************************************

      integer function mprchk(cmet,laue)

      character cmet(6)*5

      ierr = 0

c --- Alpha-Winkel:

         if((laue.ge.2.and.laue.le.12).or.laue.eq.15) then
           if(cmet(4)(1:1).eq.'1'.or.cmet(4)(1:1).eq.'%') then 
             write(*,'(/2x,a)') 'ERROR: Alpha cannot be refined'
             ierr = ierr + 1
           end if
         end if

c --- Beta-Winkel:

         if((laue.ge.2.and.laue.le.11).or.laue.eq.15) then
           if(cmet(5)(1:1).eq.'1'.or.cmet(5)(1:1).eq.'%') then 
             write(*,'(/2x,a)') 'ERROR: Beta cannot be refined'
             ierr = ierr + 1
           end if
         end if

c --- Gamma-Winkel:

         if((laue.ge.3.and.laue.le.12).or.laue.eq.15) then
           if(cmet(6)(1:1).eq.'1'.or.cmet(6)(1:1).eq.'%') then 
             write(*,'(/2x,a)') 'ERROR: Gamma cannot be refined'
             ierr = ierr + 1
           end if
         end if

c --- a- und b-Achse bei tetragonalen und hexagonalen Zellen:

         if((laue.ge.4.and.laue.le.9).or.laue.eq.15) then
           if(cmet(1).ne.cmet(2)) then
             write(*,'(/2x,a)') 'ERROR: Bad coding of a and b'
             ierr = ierr + 1
           end if
           if(cmet(1)(1:1).eq.'1'.and.cmet(2)(1:1).eq.'1') then
             cmet(1) = '1    '
             cmet(2) = '=10  '
           end if
         end if

c --- a-, b- und c-Achse bei kubischen und rhomboedrischen Zellen:

         if(laue.eq.10.or.laue.eq.11.or.
     *      laue.eq.13.or.laue.eq.14) then
           if(cmet(1)(1:1).ne.cmet(2)(1:1).or.
     *        cmet(1)(1:1).ne.cmet(3)(1:1).or.
     *        cmet(2)(1:1).ne.cmet(3)(1:1)) then
             write(*,'(/2x,a)') 'ERROR: Bad coding of a, b and c'
             ierr = ierr + 1
           end if
           if(cmet(1)(1:1).eq.'1'.and.cmet(2)(1:1).eq.'1'.and.
     *        cmet(3)(1:1).eq.'1') then
             cmet(1) = '1    '
             cmet(2) = '=10  '
             cmet(3) = '=10  '
           end if
         end if

c --- Alpha-, Beta- und Gamma-Winkel bei rhomboedrischen Zellen:

         if(laue.eq.13.or.laue.eq.14) then
           if(cmet(4)(1:1).ne.cmet(5)(1:1).or.
     *        cmet(4)(1:1).ne.cmet(6)(1:1).or.
     *        cmet(5)(1:1).ne.cmet(6)(1:1)) then
             write(*,'(/2x,a)') 
     *            'ERROR: Bad coding of alpha, beta and gamma'
             ierr = ierr + 1
           end if
           if(cmet(4)(1:1).eq.'1'.and.cmet(5)(1:1).eq.'1'.and.
     *        cmet(6)(1:1).eq.'1') then
             cmet(4) = '1    '
             cmet(5) = '=13  '
             cmet(6) = '=13  '
           end if
         end if

100   continue


      mprchk = ierr
      return
      end

c******************************************************************************
c***                     INPUT-File einlesen                                ***
c******************************************************************************

      subroutine parinp(ke,inpfile,titel,datfile,bacfile,eichfile,
     *                  intfile,rlamda,ratio,thmin,thmax,igeo,nprof,
     *                  ihkl,lhkl,isp,ibac,ieich,ifis,istru,wdt,rlim,
     *                  cthm,ctha,excl,iexcl,IEZ,glb,cglb,nphase,phsnm,
     *                  laue,intaus,spgrp,imo,iord,gitter,defint,par,
     *                  cpar,mcycle,eps,relax,LPHASE,NORD)

      parameter(maxline = 132, max = 18, PI = 3.14159265359)

      external metchk

      integer laue(LPHASE), imo(LPHASE), iord(LPHASE)
      character*80 inpfile, datfile, bacfile, eichfile, 
     *             intfile(LPHASE)
      character titel*70, phsnm(LPHASE)*4, intaus(LPHASE)*1
      character char(max)*132, ecod*3, text*132
      character*5 cglb(10), cpar(20,LPHASE), spgrp(LPHASE)*60
      real celld(6), cellr(13), gitter(6,LPHASE), relax(30)
      real werte(max), par(19,LPHASE), glb(10), rlamda(2)
      real excl(2,IEZ), defint(LPHASE), ratio(2)


c --- Initialisierung:

      nn = 0
      ecod = 'eee'


c --- Formate:

11    format(/2x,'Error in INPUT file: Line "',a3,'> ..." is missing')
21    format(/2x,'Error in INPUT file: Line "',a3,
     *  '> ..." is missing for phase ',i2)
111   format(/2x,'Error in INPUT file: wrong number of parameters,',
     *' it should be ',i2,',',/23x,'line "',a3,'> ..."')
121   format(/2x,'Error in INPUT file: wrong number of parameters,',
     *' it should be ',i2,',',/23x,'line "',a3,'> ..." , phase ',i2)

c --- Datei oeffnen:

      open(ke,file=inpfile,status='old',err=1000)


c --- Titel einlesen:

      ist = 0
      call getinp(ke,'TIT',ecod,werte,char,max,num,nn,ist)
      if(ist.eq.11) then
        write(*,11) 'TIT'
        stop
      else
        titel(1:70) = char(1)(1:70)
      end if
      write(*,'(/2x,2a)') 'Title: ',titel


c --- Code einlesen:

      ist = 1
      call getinp(ke,'COD',ecod,werte,char,max,num,nn,ist)
      if(ist.eq.11) then
        write(*,11) 'COD'
        stop
      else
        iz = 9
        if(num.ne.iz) then
          write(*,111) iz,'COD'
          stop
        end if
        igeo  = nint(werte(1))
        nprof = nint(werte(2))
        ihkl  = nint(werte(3))
        lhkl  = nint(werte(4))
        isp   = nint(werte(5))
        ibac  = nint(werte(6))
        ieich = nint(werte(7))
        ifis  = nint(werte(8))
        istru = nint(werte(9))
      end if
      if(igeo.eq.1) then
        write(*,'(2x,a)') 'Guinier geometry (transmission)'
      else if(igeo.eq.2) then
        write(*,'(2x,a)') 'Guinier geometry (film)'
      else if(igeo.eq.3) then
        write(*,'(2x,a)') 'Bragg-Brentano for X-ray'
      else if(igeo.eq.4) then
        write(*,'(2x,a)') 'Bragg-Brentano for synchrotron'
      else if(igeo.eq.5) then
        write(*,'(2x,a)') 'Debye-Scherrer for neutron'
      else if(igeo.eq.6) then
        write(*,'(2x,a)') 'Guinier geometry (reflection)'
      else
        write(*,'(2x,a)') 'Undefined diffraction geometry!'
        stop
      end if
      if(nprof.gt.8.or.nprof.lt.1) then
        write(*,'(2x,a,i2)')
     *  'Unknown profile function No. ',nprof
      else
        write(*,'(2x,a,i1,a,i2)')
     *  'The ',nprof,'th profile function was selected'
      end if
      if(ihkl.ne.0) write(*,'(2x,a)') 'Print reflection list'
      if(lhkl.ne.0) write(*,'(2x,a)') 'Print merged reflection list'
      if(isp.eq.0) then
        write(*,'(2x,a)') 'Number of columns in CYCLE file = 80'
      else
        write(*,'(2x,a)') 'Number of columns in CYCLE file = 132'
      end if
      if(ibac.eq.0) then
        write(*,'(2x,a)') 'Background refinement'
      else
        write(*,'(2x,a)') 'Read background data file'
      end if
      if(ieich.eq.1) write(*,'(2x,a)') '2-theta scaling'
      if(ieich.eq.2) write(*,'(2x,a)') '2-theta scaling with silicon'
      if(ifis.eq.1) write(*,'(2x,a)') 'Generate reflections'
      if(istru.eq.1) write(*,'(2x,a)') 'Output `observed'' Intensities'

c --- Anzahl der Rechenzyklen, Epsylon, Relaxationfaktoren:

      ist = 1
      call getinp(ke,'FIT',ecod,werte,char,max,num,nn,ist)
      if(ist.eq.11) then
        write(*,11) 'FIT'
        stop
      else
        iz = 10
        if(num.ne.iz) then
          write(*,111) iz,'FIT'
          stop
        end if
        mcycle    = nint(werte(1))
        eps       = werte(2)
        do 26 i=1,3
           relax(i) = werte(3)
26      continue
        do 28 i=8,10
           relax(i) = werte(4)
28      continue  
        do 29 i=11,13
           relax(i) = werte(5)
29      continue 
        do 30 i=14,19
           relax(i) = werte(6)
30      continue
        relax(20) = werte(7)
        do 31 i=21,23
           relax(i) = werte(8)
31      continue
        do 32 i=24,29   
           relax(i) = werte(9)
32      continue
        relax(30) = werte(10)
      end if
      write(*,'(2x,a,i4)') 'Number of cycles = ',mcycle
      write(*,'(2x,a,f6.1)') 'EPS-value = ',eps
      write(*,'(2x,a,8(/2x,a,f5.2))')
     *     'Relaxation factors  - ',
     *     'for profile parameters = ',relax(1),
     *     'for halfwidth parameters = ',relax(8),
     *     'for wave vector = ',relax(11),
     *     'for lattice constants = ',relax(14),
     *     'for intensities = ',relax(20),
     *     'for wavelength L1 = ',relax(30),
     *     'for background parameters = ',relax(24),
     *     'for zeropoint and peak shift = ',relax(21)

c --- Datei mit den gemessene Daten:

      ist = 0
      call getinp(ke,'DAT',ecod,werte,char,max,num,nn,ist)
      if(ist.eq.11) then
        write(*,11) 'DAT'
        stop
      else
        datfile(1:80) = char(1)(1:80)
      end if
      text = ' '
      text = '  Data file: '//datfile
      call writline(6,text,maxline)

c --- Untergrund:

      if(ibac.eq.0) then

c --- Excluded regions:

        iexcl = 0
38      ist = 1
        call getinp(ke,'EXC','BAC',werte,char,max,num,nn,ist)
        if(ist.eq.11) then
          write(*,11) 'EXC'
          stop
        else if(ist.eq.13) then
          if(iexcl.eq.0) write(*,'(2x,a)') 'No excluded regions'
          goto 39
        else
          iz = 2
          if(num.ne.iz) then
            write(*,111) iz,'EXC'
            stop
          end if
          iexcl = iexcl + 1
          excl(1,iexcl) = werte(1)
          excl(2,iexcl) = werte(2)
          write(*,'(2x,a,2f10.4)') 
     *         'Excluded region = ',excl(1,iexcl),excl(2,iexcl)
        end if
        goto 38

c --- Untergrund-Parameter:

39      ist = 1
        call getinp(ke,'BAC',ecod,werte,char,max,num,nn,ist)
        if(ist.eq.11) then
          write(*,11) 'BAC'
          stop
        else
          iz = 6
          if(num.ne.iz) then
            write(*,111) iz,'BAC'
            stop
          end if
          do 40 i=1,6
             glb(3+i) = werte(i)
40        continue
          write(*,'(2x,a,6f8.3)') 
     *         'Background parameters = ',(glb(3+i),i=1,6)
        end if

      else

c --- Datei mit den Untergrund-Stuetzpunkten einlesen:

        ist = 0
        call getinp(ke,'BAC',ecod,werte,char,max,num,nn,ist)
        if(ist.eq.11) then
          write(*,11) 'BAC'
          stop
        else
          bacfile(1:80) = char(1)(1:80)
        end if
        text = ' '
        text = '  Background data file: '//bacfile
        call writline(6,text,maxline)

      end if

c --- Datei mit den Eichdaten:

      if(ieich.eq.1) then
        ist = 0
        call getinp(ke,'SCL',ecod,werte,char,max,num,nn,ist)
        if(ist.eq.11) then
          write(*,11) 'SCL'
          stop
        else
          eichfile(1:80) = char(1)(1:80)
          text = ' '
          text = '  Scale data file: '//eichfile
          call writline(6,text,maxline)
        end if
      end if

c --- Wellenlaengen:

      ist = 1
      call getinp(ke,'WVL',ecod,werte,char,max,num,nn,ist)
      if(ist.eq.11) then
        write(*,11) 'WVL'
        stop
      else
        iz = 3
        if(num.ne.iz) then
          write(*,111) iz,'WVL'
          stop
        end if
        rlamda(1) = werte(1)
        rlamda(2) = werte(2)
        ratio(1)  = 1.
        ratio(2)  = werte(3)
        glb(10)   = rlamda(1)
      end if
      if(rlamda(1).lt.0..or.rlamda(2).lt.0.) then
        write(*,'(/2x,a,i3,a,/2x,a)')
     *  'Error in INPUT file at line ',nn,':',
     *  'Wavelengths must be greater or equal zero'
        stop
      end if
      write(*,'(/2x,a,f10.6,a,f10.6,a,f10.6)')
     *'The wavelengths are ',rlamda(1),' and ',rlamda(2),
     *' with a ratio of ',ratio(2)

c --- 2-Thetabereich, Nullpunkt und Peak-Shift-Parameter:

      ist = 1
      call getinp(ke,'THE',ecod,werte,char,max,num,nn,ist)
      if(ist.eq.11) then
        write(*,11) 'THE'
        stop
      else
        iz = 5
        if(num.ne.iz) then
          write(*,111) iz,'THE'
          stop
        end if
        thmin  = werte(1)
        thmax  = werte(2)
        glb(1) = werte(3)
        glb(2) = werte(4)
        glb(3) = werte(5)
      end if
      if(thmin.lt.0.) then
        write(*,'(/2x,a,i3,a,/2x,a)')
     *  'Error in INPUT file at line ',nn,':',
     *  '2-theta minimum must be greater or equal zero'
        stop
      end if
      if(thmax.lt.thmin) then
        write(*,'(/2x,a,i3,a,/2x,a)')
     *  'Error in INPUT file at line ',nn,':',
     *  '2-theta maximum must be greater than 2-theta minimum'
        stop
      end if
      write(*,'(2x,a,f10.5)') 'Zeropoint = ',glb(1)
      write(*,'(2x,a,1x,g10.4,2x,g10.4)') 
     *'Peak-shift parameters = ',glb(2),glb(3)

c --- Korrektur-Parameter: Reflexweite, Monochromatorwinkel, 
c     Grenzwinkel fuer Asymmetriekorrektur:
 
      ist = 1
      call getinp(ke,'COR',ecod,werte,char,max,num,nn,ist)
      if(ist.eq.11) then
        write(*,11) 'COR'
        stop
      else
        iz = 4
        if(num.ne.iz) then
          write(*,111) iz,'COR'
          stop
        end if
        wdt  = werte(1) 
        rlim = werte(2) 
        cthm = werte(3)
        ctha = werte(4)
        if(ctha.lt.0.01) ctha = 360./PI * asin(0.15373 * rlamda(1))
      end if
      write(*,626) wdt
626   format(2x,'Base of peak = 2 * Fwhm *',f5.2)
      write(*,627) rlim
627   format(2x,'Asymmetry correction for angles less than ',f8.3,
     *' degrees ')
      if(igeo.eq.4) then
        write(*,628) cthm
628     format(2x,'Polarisation parameter = ',f8.4)
        write(*,629) ctha
629     format(2x,'Analysator correction = ',f8.4)
      else
        write(*,630) cthm
630     format(2x,'Monochromator correction = ',f8.4)
      end if

c --- Globale Parameter:

      ist = 1
      call getinp(ke,'GLB',ecod,werte,char,max,num,nn,ist)
      if(ist.eq.11) then
        write(*,11) 'GLB'
        stop
      else
        iz = 10
        if(num.ne.iz) then
          write(*,111) iz,'GLB'
          stop
        end if
        do 45 i=1,10
           cglb(i)(1:5) = char(i)(1:5)
45      continue
      end if


c --- Pharameter der Phasen --------------------------------------------

      ip = 0

c --- Name der Phase, Integrale Ausloeschung, Lauegruppe, 
c     moduliert/nicht moduliert, maximale Ordnung der Satelliten:
   
50    ist = 1
      call getinp(ke,'PHS',ecod,werte,char,max,num,nn,ist)
      if(ist.eq.11) then
        if(ip.eq.0) then
          write(*,21) 'PHS',ip
          stop
        else if(ip.gt.LPHASE) then
          write(*,'(/2x,a,i2,a,/2x,a,i2,a)') 
     *    'The number of phases is greater than ',LPHASE,'.',
     *    'Only ',LPHASE,' phases are allowed.'
          stop
        else
          nphase = ip
          close(ke)
          return
        end if
      else
        ip = ip + 1
        iz = 6
        if(num.ne.iz) then
          write(*,121) iz,'PHS',ip
          stop
        end if
        phsnm(ip)  = char(1)(1:4)
        intaus(ip) = char(2)(1:1)
        laue(ip)   = nint(werte(3))
        imo(ip)    = nint(werte(4))
        iord(ip)   = nint(werte(5))
        defint(ip) = werte(6)
      end if

      write(*,'(/2x,a,i2,a,a)') 
     *'Phase ',ip,': ',phsnm(ip)
      if(intaus(ip).ne.'P'.and.intaus(ip).ne.'I'.and.
     *   intaus(ip).ne.'F'.and.intaus(ip).ne.'A'.and.
     *   intaus(ip).ne.'B'.and.intaus(ip).ne.'C'.and.
     *   intaus(ip).ne.'R') then
        write(*,'(/2x,a,i3,a,a)')
     *  'Error in INPUT file at line ',nn,': ',
     *  'Bad extinction rule'
        stop
      else
        write(*,'(2x,a,a)') 'Extinction rule: ',intaus(ip)
      end if
      if(laue(ip).lt.1.or.laue(ip).gt.15) then
        write(*,'(/2x,a,i3,a,/2x,a)')
     *  'Error in INPUT file at line ',nn,':',
     *  'The Number of the Laue group must be between 1 and 15'
        stop
      else
        write(*,'(2x,a,i2)') 
     *  'Number of the Laue group = ',laue(ip)
      end if
      if(imo(ip).eq.1) then
        if(iord(ip).gt.NORD.or.iord(ip).lt.0) then
          write(*,'(/2x,a,i2)')
     *    'Max. order of the satellites must be between 0 and ',NORD
          stop
        else
          write(*,'(2x,a,i4)')
     *    'Max. order of the satellite peaks: ',iord(ip)
        end if
      end if
      write(*,'(2x,a,f12.2)') 'Default Bragg intensity = ',defint(ip)

c --- Raumgruppen-Symbol einlesen, falls vorhanden:

      ist = 0
      call getinp(ke,'SPG','INT',werte,char,max,num,nn,ist)
      if(ist.eq.11.or.ist.eq.13) then
        spgrp(ip) = ' '
      else
        spgrp(ip)(1:60) = char(1)(1:60)
        write(*,'(2x,a,a)') 'Space group: ',spgrp(ip)
      end if

c --- Datei mit den Intensitaeten:

      ist = 0
      call getinp(ke,'INT',ecod,werte,char,max,num,nn,ist)
      if(ist.eq.11) then
        write(*,21) 'INT'
        stop
      else
        intfile(ip)(1:80) = char(1)(1:80)
      end if
      text = ' '
      text = '  Intensity data file: '//intfile(ip)
      call writline(6,text,maxline)

c --- Gitterkonstanten:

      ist = 1
      call getinp(ke,'MET',ecod,werte,char,max,num,nn,ist)
      if(ist.eq.11) then
        write(*,21) 'MET',ip
        stop
      else
        iz = 6
        if(num.ne.iz) then
          write(*,121) iz,'MET',ip
          stop
        end if
        do 70 k=1,6
           celld(k) = werte(k)
70      continue
      end if
      write(*,'(2x,a,6f9.5)') 
     *'Direct Cell Param. = ',(celld(k),k=1,6)
      if(metchk(celld,laue(ip)).gt.0) stop
      call rezi(celld,cellr)
      do 75 k=1,6
         gitter(k,ip) = celld(k)
         par(13+k,ip) = cellr(k)
75    continue

c --- Wellenvektor:

      if(imo(ip).eq.1) then
        ist = 1
        call getinp(ke,'WAV',ecod,werte,char,max,num,nn,ist)
        if(ist.eq.11) then
          write(*,21) 'WAV',ip
          stop
        else
          iz = 3
          if(num.ne.iz) then
            write(*,121) iz,'WAV',ip
            stop
          end if
          do 60 k=1,3
             par(10+k,ip) = werte(k)
60        continue
        end if
        write(6,'(2x,a,3f9.5)')
     *  'Wave vector = ',(par(k,ip),k=11,13)
      end if

c --- Profilparameter:

      ist = 1
      call getinp(ke,'PRO',ecod,werte,char,max,num,nn,ist)
      if(ist.eq.11) then
        write(*,21) 'PRO',ip
        stop
      else
        iz = 3
        if(num.ne.iz) then
          write(*,121) iz,'PRO',ip
          stop
        end if
        do 66 k=1,3
           par(k,ip) = werte(k)
66      continue
      end if
      write(*,'(2x,a,f8.5)') 
     *     'Asymmetry parameter = ',par(3,ip)
      if(nprof.eq.5) write(*,'(2x,a,2f8.3)') 
     *         'Skewness and Excess = ',par(1,ip),par(2,ip)
      if(nprof.eq.6) write(*,'(2x,a,f8.3)') 
     *                    'Eta (Pseudo-Voigt) = ',par(1,ip)
      if(nprof.eq.7) write(*,'(2x,a,f8.3)') 
     *                    'Pearson-M = ',par(1,ip)

c --- Halbwertsbreite-Parameter:

      ist = 1
      call getinp(ke,'HWB',ecod,werte,char,max,num,nn,ist)
      if(ist.eq.11) then
        write(*,21) 'HWB',ip
        stop
      else
        iz = 3
        if(num.ne.iz) then
          write(*,121) iz,'HWB',ip
          stop
        end if
        do 65 k=1,3
           par(7+k,ip) = werte(k)
65      continue
      end if
      write(*,'(2x,a,3f12.5)') 
     *'Halfwidth parameters (Caglioti) = ',(par(k,ip),k=8,10)
 
c --- Parameter der Phase:

      ist = 1
      call getinp(ke,'PAR',ecod,werte,char,max,num,nn,ist)
      if(ist.eq.11) then
        write(*,11) 'PAR',ip
        stop
      else
        iz = 16
        if(num.ne.iz) then
          write(*,121) iz,'PAR',ip
          stop
        end if
        cpar(1,ip) = char(1)(1:5)
        cpar(2,ip) = char(2)(1:5)
        cpar(3,ip) = char(3)(1:5)
        cpar(4,ip) = '0    '
        cpar(5,ip) = '0    '
        cpar(6,ip) = '0    '
        cpar(7,ip) = '0    '
        do 80 i=4,16
           cpar(4+i,ip)(1:5)  = char(i)(1:5)
80      continue        
      end if

      goto 50


c --- Fehlermeldungen:

1000  stop ' Error: Cannot open INPUT file'

      end


c******************************************************************************
c***                   Neues Inputfile schreiben                            ***
c******************************************************************************

      subroutine parneu(ke,ka,inpfile,outfile,imo,ibac,nphase,rlamda,
     *                  ratio,thmin,thmax,gitter,glb,par,LPHASE)

      parameter(maxline=132)
      integer imo(LPHASE)
      real gitter(6,LPHASE), glb(10), par(19,LPHASE)
      real rlamda(2), ratio(2)
      character line*132, inpfile*80, outfile*80


c --- Datei oeffnen:
   
      open(ke,file=inpfile,status='old',err=1000)
      open(ka,file=outfile,status='unknown',err=1100)


c --- Untergrund-Parameter:

      if(ibac.eq.0) then
        iwrt = 0
 10     read(ke,'(a)') line
        if(line(1:3).eq.'BAC') then
          write(ka,'(a,6(f9.2,1x))') 
     *         'BAC> ',(glb(i),i=4,9)
          iwrt = 1
        else
          call writline(ka,line,maxline)
        end if
        if(iwrt.eq.0) goto 10
      end if

c --- Wellenlaengen:

      iwrt = 0
 15   read(ke,'(a)') line
      if(line(1:3).eq.'WVL') then
        write(ka,'(a,2(f10.6,1x),f9.5)') 
     *       'WVL> ',rlamda(1),rlamda(2),ratio(2)
        iwrt = 1
      else
        call writline(ka,line,maxline)
      end if
      if(iwrt.eq.0) goto 15         


c --- Winkelbereich, Nullpunkt und Peak-Shift-Parameter:

      iwrt = 0
 20   read(ke,'(a)') line
      if(line(1:3).eq.'THE') then
        write(ka,'(a,3(f9.5,1x),2(1x,g10.4,1x))') 
     *       'THE> ',thmin,thmax,(glb(i),i=1,3)
        iwrt = 1
      else
        call writline(ka,line,maxline)
      end if
      if(iwrt.eq.0) goto 20

      do 100 ip=1,nphase

c --- Gitterkonstanten:

         iwrt = 0
 30      read(ke,'(a)') line
         if(line(1:3).eq.'MET') then
           write(ka,'(a,1x6(f9.5,1x))') 
     *          'MET> ',(gitter(k,ip),k=1,6)
           iwrt = 1
         else
           call writline(ka,line,maxline)
         end if
         if(iwrt.eq.0) goto 30

c --- Wellenvektor:

         if(imo(ip).eq.1) then
           iwrt = 0
 40        read(ke,'(a)') line
           if(line(1:3).eq.'WAV') then
             write(ka,'(a,1x,3(f9.5,1x))') 
     *            'WAV> ',(par(k,ip),k=11,13)
             iwrt = 1
           else
             call writline(ka,line,maxline)
           end if
           if(iwrt.eq.0) goto 40
         end if

c --- Profilparameter:

         iwrt = 0
50       read(ke,'(a)') line
         if(line(1:3).eq.'PRO') then
           write(ka,'(a,1x,3(f9.5,1x))') 
     *          'PRO> ',(par(k,ip),k=1,3)
           iwrt = 1
         else
          call writline(ka,line,maxline)
         end if
         if(iwrt.eq.0) goto 50    

c --- Halbwertsbreite-Parameter:
 
         iwrt = 0
 60      read(ke,'(a)') line
         if(line(1:3).eq.'HWB') then
           write(ka,'(a,1x,3(f9.5,1x))') 
     *          'HWB> ',(par(k,ip),k=8,10)
           iwrt = 1
         else
           call writline(ka,line,maxline)
         end if
         if(iwrt.eq.0) goto 60

100   continue


900   read(ke,'(a)',end=999) line
      call writline(ka,line,maxline)
      goto 900

999   close(ke)
      close(ka)
      return

1000  stop ' Cannot open INPUT file'
1100  stop ' Cannot open OUPUT file'

      end

C******************************************************************************
C*                                                                            *
C*    Dieses Unterprogramm loest das Gleichungssystem  A x X = Z              *
C*    mit der reellen quadratischen N x N - Matrix A.                         *
C*    Die Matrixinversion wird mit dem Austauschverfahren (Pivot) gemacht.    *
C*                                                                            *
C******************************************************************************

      SUBROUTINE PIVOT(A,IA,N,B,X,Z,S1,S2,IFEHL,MX,MY,WERT)

      REAL A(IA,N),B(IA,N),X(N),Z(N)
      INTEGER MX(N),MY(N)

C --- BERECHNUNG DES MASCHINENRUNDUNGSFEHLERS FMACHN.

      FMACHN=1.
  5   FMACHN=0.5*FMACHN
      IF(1..LT.1.+FMACHN) GOTO 5
      FMACHN=FMACHN*2.

C --- UMSPEICHERN DER MATRIX A AUF B

      DO 10 I=1,N
	DO 10 J=1,N
	  B(I,J)=A(I,J)
10    CONTINUE

C --- VORBESETZEN DER PIVOTVEKTOREN MX UND MY MIT NULL

      DO 20 I=1,N
	MX(I)=0
	MY(I)=0
20    CONTINUE

C --- BESTIMMUNG DES PIVOTELEMENTES

      DO 30 I=1,N
	PIVO=0.
	DO 40 IX=1,N
	  IF(MX(IX).EQ.0) THEN
	    DO 50 IY=1,N
	      IF(MY(IY).EQ.0) THEN
		IF(ABS(B(IX,IY)).GT.ABS(PIVO)) THEN
		  PIVO=B(IX,IY)
		  NX=IX
		  NY=IY
		END IF
	      END IF
50          CONTINUE
	  END IF
40      CONTINUE

C --- FALLS DAS PIVOTELEMENT NULL IST, IST DIE MATRIX SINGULAER.

	IF(ABS(PIVO).LT.4.*FMACHN) THEN
	  WERT=PIVO
	  IFEHL=2
	  RETURN
	END IF

C --- MERKEN DER INDIZES DES PIVOTELEMENTES

	MX(NX)=NY
	MY(NY)=NX

C --- BERECHNUNG DER MATRIXELEMENTE GEMAESS DER RECHENREGELN FUER
C     EINEN AUSTAUSCHSCHRITT

	HILF=1./PIVO
	DO 60 J=1,N
	  IF(J.NE.NX) THEN
	    FAKTOR=B(J,NY)*HILF
	    DO 70 K=1,N
	      B(J,K)=B(J,K)-B(NX,K)*FAKTOR
	      B(J,NY)=-FAKTOR
70          CONTINUE
	  END IF
60      CONTINUE
	DO 80 K=1,N
	  B(NX,K)=B(NX,K)*HILF
	  B(NX,NY)=HILF
80      CONTINUE
30    CONTINUE

C --- ZEILEN- UND SPALTENVERTAUSCHUNGEN RUECKGAENGIG MACHEN

      DO 90 I=1,N
	J=MX(I)
	IF(J.NE.I) THEN
	  DO 100 K=1,N
	    H=B(I,K)
	    B(I,K)=B(J,K)
	    B(J,K)=H
100       CONTINUE
	  MX(I)=MX(J)
	  MX(J)=J
	END IF
	J=MY(I)
	IF(J.NE.I) THEN
	  DO 110 K=1,N
	    H=B(K,I)
	    B(K,I)=B(K,J)
	    B(K,J)=H
110       CONTINUE
	  MY(I)=MY(J)
	  MY(J)=J
	END IF
90    CONTINUE

C --- BILDUNG DER DIFFERENZMATRIX S=(A*B-E)M, E=EINHEITSMATRIX.
C     BILDUNG DER SUMME S1 DER BETRAEGE DER DIAGONALELEMENTE VON S
C     UND DER SUMME S2 DER BETRAEGE ALLER UEBRIGEN GLIEDER.
C     THEORETISCH MUESSTEN S1 UND S2 NULL SEIN.

      S1=0.
      S2=0.
      DO 120 I=1,N
	DO 120 J=1,N
	  H=0.
	  DO 130 K=1,N
	    H=H+A(I,K)*B(K,J)
130       CONTINUE
	  IF(I.EQ.J) THEN
	    S1=S1+ABS(H-1.)
	  ELSE
	    S2=S2+ABS(H)
	  END IF
120   CONTINUE
      IFEHL=1

C --- BERECHNUNG DES LOESUNGSVEKTORS

      DO 140 K=1,N
	SUM=0.
	DO 150 I=1,N
	  SUM=SUM+B(K,I)*Z(I)
150     CONTINUE
      X(K)=SUM
140   CONTINUE
      RETURN
      END


c******************************************************************************
c***                    Peak-shift correction                               ***
c******************************************************************************

      real function pkshift(theta,t,NC)

      parameter(PI=3.14159265359)
      real t(NC)

      d2t = t(1)
      do 100 m=2,NC
         d2t = d2t + t(m) * theta**(m-1)
100   continue

      pkshift = d2t
      return
      end
C******************************************************************************
C***                Plotfile anlegen (*.PLOT)                               ***
C******************************************************************************

      subroutine plotout(ka,plotfile,titel,step,temp,t,obs,calc,bac,
     *                   the,mit,izahl,IDZ)

      external pkshift
      integer mit(IDZ)
      character plotfile*80,titel*70
      real obs(IDZ), calc(IDZ), bac(IDZ), the(IDZ), t(3)


C --- Plotfile oeffnen:

      open(ka,file=plotfile,status='unknown',err=1000)

C --- Titel schreiben:

      write(ka,'(a)') titel

c --- Kopfzeile schreiben:

      xmin = the(1) + pkshift(the(1),t,3)
      xmax = the(izahl) + pkshift(the(izahl),t,3)
      write(ka,'(a,f15.4,f12.4,f15.4,f15.2,i10)') 
     *     'SIM',xmin,step,xmax,temp,izahl

c --- Daten ins Plotfile schreiben

      do 100 n=1,izahl
         ths = the(n) + pkshift(the(n),t,3)
         if(mit(n).ge.0) then
           write(ka,'(f12.4,4(1x,f12.0))') 
     *          ths,obs(n),calc(n),obs(n)-calc(n),bac(n)
         else
           write(ka,'(f12.4,4(1x,f12.0))') 
     *          ths,obs(n),0.,0.,0.
         end if
100   continue

      close(ka)
      return

1000  stop ' Cannot open plotfile'
      end


C******************************************************************************
C***             Korrektur der Vorzugsorientierung                          ***
C******************************************************************************

      subroutine precor(pref,g1,g2,al,h,sinlam,dpref1,dpref2,proc)

      real pref(3), al(3,3), h(3)

      pp = 0.
      ph = 0.
      do 20 i=1,3
	 do 10 j=1,3
	    pp = pp + pref(i) * pref(j) * al(i,j)
	    ph = ph + pref(i) * h(j) * al(i,j)
10       continue
20    continue
      cosq   = ph*ph / (4.*sinlam) * pp
      gamma  = 1.570796327
      if(cosq.ne.0.) gamma = atan(sqrt(abs((1.-cosq)/cosq)))
      gam2   = gamma * gamma      
      prexp  = exp(-g1*gam2) 
      prf    = (1.-g2) * prexp
      proc   = g2 + prf
      dpref1 = gam2 * prf
      dpref2 =  1. - prexp

      return
      end


C******************************************************************************
C***       Berechnung der Profilfunktion und ihrer Ableitungen             ****
C******************************************************************************

      subroutine profil(nprof,x,eta1,eta2,prof,dprof,NP)

      real dprof(NP)

      data g1,g2,pi  /0.939437279, 2.772588722, 3.14159265359/
      data c1,c15,c2 /4.000000000, 2.349604208, 1.656854249/
      data r1,r15,r2 /0.636619772, 0.766420936, 0.819449653/


c --- Gauss-Funktion (1):
    
      if(nprof.eq.1) then
        y        = g2 * x*x 
	if(y.gt.23.) y = 23.
	prof     = g1 * exp(-y)
        dprof(1) = -2.*g2*x * prof

c --- Lorentz-Funktion (2):

      else if(nprof.eq.2) then
        y        = c1 * x*x
        pl       = 1. + y
        prof     = r1 / pl
        dprof(1) = -2. * c1 * x * prof / pl

c --- Intermediate Lorentz-Funktion - Potenz 1.5 (3):

      else if(nprof.eq.3) then
        y        = c15 * x*x
        pl       = 1. + y
        prof     = r15 / pl**1.5
        dprof(1) = -3. * c15 * x * prof / pl

c --- Modifizierte Lorentz-Funktion - Potenz 2 (4):

      else if(nprof.eq.4) then
        y        = c2 * x*x
        pl       = 1. + y
        prof     = r2 / pl**2
        dprof(1) = -4. * c2 * x * prof / pl

c --- Edgeworth Reihe (5):

      else if(nprof.eq.5) then
        y        = 2. * g2 * x*x
        gauss    = g1 * exp(-0.5*y)
        a1       = eta1/6.       * 4.*(g2**2.)*x*(3.-y)
        a2       = eta2/24.      * 4.*(g2**2.)*(y*(y-6.)+3.)
        a3       = eta1*eta1/72. * 8.*(g2**3.)*(y*(y*(y-15.)+45.)-15.)
        prof     = gauss * (1. - a1 + a2 + a3) 
        dprof(1) = gauss * (-2.*g2*x -
     *             eta1/6.* 4.*(g2**2.)*(y*(y-6.)+3.) +
     *             eta2/24. * 8.*(g2**3.)*x*(y*(10.-y)-15.) +
     *             eta1*eta1/72. * 
     *             16.*(g2**4.)*x*(y*(y*(84.-y)-210.)+105.) )
        dprof(2) = gauss * (a1/eta1 + 2.*a3/eta1)
        dprof(3) = gauss * a2/eta2

c --- Pseudo-Voigt-Funktion (6):

      else if(nprof.eq.6) then
        y        = g2 * x*x
        if(y.gt.23.) y = 23.
        prg      = g1 * exp(-y)
        pl       = 1./(1.+c1*x*x)
        prl      = r1 * pl
        gss      = 1. - eta1
        prof     = eta1 * prl + gss * prg
        dprof(1) = -2.*x*(gss * g2*prg + eta1 * c1*pl*prl)
        dprof(2) = prl - prg

c --- Pearson-VII-Funktion (7):   

      else if(nprof.eq.7) then
	cm       = 4.*(2.**(1./eta1)-1.)
        y        = cm * x*x
        pl       = 1./(1. + y)
	prof     = sqrt(cm/pi) * exp(gammln(eta1)-gammln(eta1-0.5)) *
     *             pl**eta1
        dprof(1) = -2.*eta1*cm*x*pl * prof
        dprof(2) = (1./2. - y*alog(1.+y))/cm * prof *
     *             2**(1./eta1+1.)/eta1

c --- Doppel-Gauss-Funktion (8):
    
      else if(nprof.eq.8) then
        x        = x * 0.7786267
        y        = g2 * x*x
        gd       = 2./5.*g1 * 0.7786267
        prg1     = 2.*gd * exp(-y)
        prg2     = gd * exp(-4.*y)
        prof     = prg1 + prg2
        dprof(1) = -2.*g2*x * (prg1 + 4.*prg2)

      end if


      return
      end


C******************************************************************************
C***     Berechnung des nat. Logarithmus der Gamma-Funktion fuer XX>0       ***
C******************************************************************************

      REAL FUNCTION GAMMLN(XX)

      REAL*8 COF(6),STP,HALF,ONE,FPF,X,TMP,SER

      DATA COF,STP/76.18009173D0,-86.50532033D0,24.01409822D0,
     *    -1.231739516D0,.120858003D-2,-.536382D-5,2.50662827465D0/
      DATA HALF,ONE,FPF/0.5D0,1.0D0,5.5D0/

      X   = XX - ONE
      TMP = X + FPF
      TMP = (X+HALF) * LOG(TMP) - TMP
      SER = ONE

      DO 11 J=1,6
	 X = X + ONE
	 SER = SER + COF(J)/X
11    CONTINUE

      GAMMLN = TMP + LOG(STP*SER)

      RETURN
      END


C******************************************************************************
C***       Bragg-R-Wert (Nuklearer Intensitaets-R-Wert) berechnen           ***
C******************************************************************************

      subroutine rbragg(kcyc,idges,nphase,LPHASE,IRS,IDAT,riobs,rint,ic)

      integer nphase(IDAT), ic(LPHASE,IDAT)
      real riobs(IRS,IDAT), rint(IRS,IDAT)
      real sumdd(10), sumdo(10)

      nph = 1
      do 10 id=1,idges
         nph = max(nph,nphase(id))
c         if(nphase(id).gt.nph) nph = nphase(id)
10    continue
     
      do 20 ip=1,nph
         sumdd(ip) = 0.
         sumdo(ip) = 0.
20    continue

      do 150 id=1,idges

         iend = 0
         do 120 ip=1,nphase(id)

            ibeg = iend + 1
            iend = iend + ic(ip,id)

            sumdiff = 0
            sumiobs = 0
	    do 100 i=ibeg,iend
               if(riobs(i,id).ge.0.) then
                 sumiobs = sumiobs + riobs(i,id)
                 sumdiff = sumdiff + abs(riobs(i,id) - rint(i,id)) 
               end if
100         continue

	    sumdd(ip) = sumdd(ip) + sumdiff
	    sumdo(ip) = sumdo(ip) + sumiobs

	    if(idges.gt.1) then
  	      rnuc = 100.*sumdiff/sumiobs
	      if(nph.eq.1) then
	        write(*,83) id,rnuc 
   	        write(kcyc,83) id,rnuc
83              format(/2x,'Derived BRAGG R-Factor for data set '
     1                 ,i2,' = ',f8.2)
	      else
	        write(*,84) ip,id,rnuc
	        write(kcyc,84) ip,id,rnuc
84              format(/2X,'Derived BRAGG R-Factor for phase '
     1                 ,i2,' of data set ',i2,' = ',f8.2)
	      end if
            end if

120      continue       
150   continue

      if(nph.eq.1) then
        rnuc = 100. * sumdd(1)/sumdo(1)
        if(idges.gt.1) then
          write(*,200) rnuc
          write(kcyc,200) rnuc
200       format(/2x,
     *    'Derived BRAGG R-Factor for all data sets = ',f8.2)
        else
          write(*,210) rnuc
          write(kcyc,210) rnuc
210       format(/2x,'Derived BRAGG R-Factor = ',f8.2)
        end if
      else
        do 300 ip=1,nph
           rnuc = 100.*sumdd(ip)/sumdo(ip)
           if(idges.gt.1) then
	     write(*,250) ip,rnuc
	     write(kcyc,250) ip,rnuc
250          format(/2x,'Derived BRAGG R-Factor of phase ',i2,
     *       ' for all datasets = ',f8.2)
           else
             write(*,260) ip,rnuc
             write(kcyc,260) ip,rnuc
260          format(/2x,'Derived BRAGG R-Factor for phase '
     *              ,i2,' = ',f8.2)
           end if
300     continue
      end if

      return
      end


C******************************************************************************
C***            Berechnen der Intensitaeten und Ableitungen                 ***
C******************************************************************************

      subroutine refcalc(maxs,dersto,deriv,tann,rlamda,
     *                   uu,vv,ww,q,a,apar,lpar,aglb,lglb,aint,
     *                   lint,iref,mult,theta,hwb,rlopo,rint,corint,
     *                   nhkl,IRS,MSZ)

      parameter(PIQ = 9.869604401, PI = 3.14159265359)

      integer iref(IRS), mult(IRS), lglb(10), lpar(19), lint(IRS)
      real rlamda(2), a(6), q(3), al(3,3), h(3), deriv(MSZ) 
      real theta(IRS), rlopo(IRS), hwb(IRS), rint(IRS), tann(IRS)
      real dersto(MSZ,IRS), aglb(10), apar(19), aint(IRS)
      real corint(IRS)


C --- reziproke Gitterkonstanten :

      al(1,1) = a(1) * a(1)
      al(2,2) = a(2) * a(2)
      al(3,3) = a(3) * a(3)
      al(1,2) = a(1) * a(2) * a(6)
      al(1,3) = a(1) * a(3) * a(5)
      al(2,3) = a(2) * a(3) * a(4)
      al(2,1) = al(1,2)
      al(3,1) = al(1,3)
      al(3,2) = al(2,3)


      do 200 i=1,nhkl

c --- hkl's decodieren:

         call dcodhkl(iref(i),ih,ik,il,in,iq)


c --- Reziproker Gittervektor h und 
c     dessen Betragsquadrat hh berechnen:

         call hvec(ih,ik,il,in,q,h)

         hh = 0.
         do 22 l=1,3
            do 22 j=1,3
               hh = hh + h(l)*h(j)*al(l,j)
22       continue


c --- Reflexlage, Lorentz-Polarisations-Faktor, Halbwertsbreite,
c     tan(Theta) und tan(2-Theta) berechnen:

         sinth       = 0.5 * rlamda(iq) * sqrt(hh)
         sinlam      = hh/4.
         if(sinlam.eq.0.) sinlam = 0.0001
         if(abs(sinth).gt.1.) sinth = 0.
         th          = asin(sinth)
         tanth       = sinth/sqrt(1.-sinth*sinth)
         if(tanth.eq.0.) tanth = 0.0001
         tann(i)     = tanth
         theta(i)    = th
         hwb2        = uu*tanth*tanth + vv*tanth + ww
         if(hwb2.ge.0.) then
           hwb(i)    = sqrt(hwb2)
         else
           write(*,'(/2x,a,f9.4,a)') 
     *     'Error: fwhm < 0 at 2theta = ', 360./PI * th, ' degrees'
           stop
         end if 

c --- Intensitaet berechnen:

         corint(i) = rlopo(i) * mult(i) * rint(i)

c --- Ableitungen von y_calc(i), die nicht von x(i) abhaengen:

         do 110 m=1,maxs
            deriv(m) = 0.
110      continue  

c --- Parameter der Profilfunktion, Asymmetrieparameter:

         k = lpar(1)
         if(k.ne.0) deriv(k) = deriv(k) + apar(1)*corint(i)
         k = lpar(2)
         if(k.ne.0) deriv(k) = deriv(k) + apar(2)*corint(i)
         k = lpar(3)
         if(k.ne.0) deriv(k) = deriv(k) + apar(3)*corint(i)/tanth

c --- Halbwertsbreite-Parameter U, V, W:

         rb = (0.5/hwb(i)) * corint(i)

         k = lpar(8)
         if(k.ne.0) deriv(k) = deriv(k) + apar(8)*rb*tanth*tanth 
         k = lpar(9)
         if(k.ne.0) deriv(k) = deriv(k) + apar(9)*rb*tanth 
         k = lpar(10)
         if(k.ne.0) deriv(k) = deriv(k) + apar(10)*rb 

c --- Q-Vektor:

         rqa = 90./PI * tanth/sinlam * corint(i)

         k = lpar(11)
         if(k.ne.0) deriv(k) = deriv(k) + apar(11) * rqa * in *
     *                         (h(1)*al(1,1)+h(2)*al(1,2)+h(3)*al(1,3))
         k = lpar(12)
         if(k.ne.0) deriv(k) = deriv(k) + apar(12) * rqa * in *
     *                         (h(2)*al(2,2)+h(1)*al(1,2)+h(3)*al(2,3))
         k = lpar(13)
         if(k.ne.0) deriv(k) = deriv(k) + apar(13) * rqa * in *
     *                         (h(3)*al(3,3)+h(1)*al(1,3)+h(2)*al(2,3))  

c --- reziproke Gitterkonstanten:

         k = lpar(14)
         if(k.ne.0) deriv(k) = deriv(k) + apar(14) * rqa *
     *                         (h(1)*h(1)*a(1)+h(1)*h(2)*a(2)*a(6)
     *                                        +h(1)*h(3)*a(3)*a(5))
         k = lpar(15)  
         if(k.ne.0) deriv(k) = deriv(k) + apar(15) * rqa *
     *                         (h(2)*h(2)*a(2)+h(2)*h(1)*a(1)*a(6)
     *                                        +h(2)*h(3)*a(3)*a(4))
         k = lpar(16)      
         if(k.ne.0) deriv(k) = deriv(k) + apar(16) * rqa *
     *                         (h(3)*h(3)*a(3)+h(3)*h(1)*a(1)*a(5)
     *                                        +h(3)*h(2)*a(2)*a(4))
         k = lpar(17)
         if(k.ne.0) deriv(k) = deriv(k) + apar(17) * rqa *
     *                         h(2)*h(3)*a(2)*a(3)
         k = lpar(18)
         if(k.ne.0) deriv(k) = deriv(k) + apar(18) * rqa *
     *                         h(1)*h(3)*a(1)*a(3)
         k = lpar(19)
         if(k.ne.0) deriv(k) = deriv(k) + apar(19) * rqa *
     *                         h(1)*h(2)*a(1)*a(2)

c --- Nullpunkt t0 und peak-shift parameter t1 und t2:

         k = lglb(1)         
         if(k.ne.0) deriv(k) = deriv(k) + aglb(1)*corint(i)
         k = lglb(2)         
         if(k.ne.0) deriv(k) = deriv(k) + aglb(2)*corint(i)
         k = lglb(3)         
         if(k.ne.0) deriv(k) = deriv(k) + aglb(3)*corint(i)

c --- Wellenlaenge:

         k = lglb(10) 
         if(k.ne.0) deriv(k) = deriv(k) +  
     *              aglb(10) * corint(i) * tanth/rlamda(1) * 360./PI

c --- Intensitaeten:

         k = lint(i)
         if(k.ne.0) deriv(k) = deriv(k) + aint(i) * rlopo(i) * mult(i)

c --- Ableitungen fuer jeden Reflex abspeichern:

         do 180 m=1,maxs
            dersto(m,i) = deriv(m)
180      continue


200   continue


      return
      end


C******************************************************************************
C***           Berechnet dir Reziproken Gitterkonstanten                    ***
C******************************************************************************

      SUBROUTINE REZI(CELLD,CELLR)

      parameter (PI = 3.14159265359)
      REAL CELLD(6),CELLR(13)

C     CELLD(1) = A          CELLR(1)  = A*
C     CELLD(2) = B          CELLR(2)  = B*
C     CELLD(3) = C          CELLR(3)  = C*
C     CELLD(4) = Alpha      CELLR(4)  = cos(Alpha*)
C     CELLD(5) = Beta       CELLR(5)  = cos(Beta*)
C     CELLD(6) = Gamma      CELLR(6)  = cos(Gamma*)
C                           CELLR(7)  = (A*)**2
C                           CELLR(8)  = (B*)**2.
C                           CELLR(9)  = (C*)**2.
C                           CELLR(10) = 2.*(A*)*(B*)*COS(Gamma*)
C                           CELLR(11) = 2.*(A*)*(C*)*COS(Beta*)
C                           CELLR(12) = 2.*(B*)*(C*)*COS(Alpha*)
C                           CELLR(13) = 1./Volumen


C --- Achsen:

      A = CELLD(1)
      B = CELLD(2)
      C = CELLD(3)

C --- Cosinuse und Sinuse der Winkel:

      COSAA = COS(CELLD(4)*PI/180.)
      COSBB = COS(CELLD(5)*PI/180.)
      COSGG = COS(CELLD(6)*PI/180.)

      SINAA = sqrt(1. - cosaa * cosaa)
      SINBB = sqrt(1. - cosbb * cosbb)
      SINGG = sqrt(1. - cosgg * cosgg)

C --- Zellvolumen:

      VOL = A*B*C*SQRT(1. + 2.*COSAA*COSBB*COSGG -
     1                 COSAA*COSAA - COSBB*COSBB - COSGG*COSGG)

C --- reziproke Gitterkonstanten und reziprokes Volumen:

      AREZ = B*C*SINAA/VOL
      BREZ = C*A*SINBB/VOL
      CREZ = A*B*SINGG/VOL

      CELLR(1) = AREZ
      CELLR(2) = BREZ
      CELLR(3) = CREZ

      ALREZ = (COSBB*COSGG-COSAA)/(SINBB*SINGG)
      BEREZ = (COSGG*COSAA-COSBB)/(SINGG*SINAA)
      GAREZ = (COSAA*COSBB-COSGG)/(SINAA*SINBB)

      CELLR(4) = ALREZ
      CELLR(5) = BEREZ
      CELLR(6) = GAREZ

      ASTERN = AREZ*AREZ
      BSTERN = BREZ*BREZ
      CSTERN = CREZ*CREZ

      CELLR(7) = ASTERN
      CELLR(8) = BSTERN
      CELLR(9) = CSTERN

      ALSTE = 2.*BREZ*CREZ*ALREZ
      BESTE = 2.*CREZ*AREZ*BEREZ
      GASTE = 2.*AREZ*BREZ*GAREZ

      CELLR(10) = ALSTE
      CELLR(11) = BESTE
      CELLR(12) = GASTE

      CELLR(13) = 1./VOL


      RETURN
      END


c******************************************************************************
c***                       hkl-Liste ausgeben                               ***
c******************************************************************************

      subroutine satwrite(ka,cellr,q,iref,mult,theta,nhkl,IRS)

      parameter (PI = 3.14159265359)
      external hhcalc
      integer iref(IRS), mult(IRS)
      real theta(IRS), cellr(13), h(3), q(3)

      write(ka,'(2x,2a)') ' No. Co.     h   k   l   n',
     *'     H       K       L    Mult   2-theta      d'
      do 300 i=1,nhkl
         call dcodhkl(iref(i),ih,ik,il,in,iq)
         thobs = 360./PI * theta(i)
         call hvec(ih,ik,il,in,q,h)
         dwert = 0.
         hh = hhcalc(h,cellr)
         if(hh.gt.0.) dwert = 1./hh
         write(ka,'(2x,2i4,2x,4i4,3(f8.3),i6,2x,f8.3,f10.5)')
     *         i,iq,ih,ik,il,in,(h(j),j=1,3),mult(i),thobs,dwert
300   continue

    
      return
      end





c******************************************************************************
c***                    Altes Inputfile sichern                             ***
c******************************************************************************

      subroutine savinp(ke,ka,inpfile,savefile)

      parameter(maxline=132)
      character line*132, inpfile*80, savefile*80, chr*1


c --- Name der Sicherungskopie bestimmen:

      iend = 81
      do 50 i=0,79
         chr = inpfile(80-i:80-i)
         if(chr.ne.' '.and.iend.eq.81) iend = i
         if(chr.eq.'.') then
           k = 80-i-1               
           goto 60         
         end if
50    continue
      k = iend
                             
60    savefile(1:k) = inpfile(1:k)
      savefile(k+1:k+4) = '.bak'


c --- Sichern:

      open(ke,file=inpfile,status='old',err=1000)
      open(ka,file=savefile,status='unknown',err=1100)

100   read(ke,'(a)',err=1200,end=500) line
      call writline(ka,line,maxline)
      goto 100

500   close(ke)
      close(ka)
      return


c --- Fehlermeldungen:

1000  stop ' Cannot open input file'
1100  stop ' Cannot open save file'
1200  stop ' ERROR: Error reading input file'

      end


C******************************************************************************
C***               Symmetrie-Karten einlesen                                ***
C******************************************************************************

      subroutine syminp(ke,symfile,imo,ismat,spgrp,intaus,laue,icent,
     *                  ism,tran,nsym)

      parameter(maxline = 132, PI = 3.14159265359)
      real tran(3,48), trp(3,48), trs(3,48)
      character spgrp*60, symfile*80, intaus*1, line*132
      character csym(48)*3, symor(48)*9, clau(15)*8
      integer ism(3,3,48), numsy(48), num(48)

c --- Lauegruppen:

      data clau(1),clau(2),clau(3),clau(4),clau(5),clau(6),clau(7),
     *     clau(8),clau(9),clau(10),clau(11),clau(12),clau(13),
     *     clau(14),clau(15)
     * /'1b','2/m (C)','m m m','4/m','4/m m m','3b','3b m 1',
     *  '6/m','6/m m m','m 3','m 3b m','2/m (B)','3b (R)','3b m (R)',
     *  '3b 1 m'/

c --- Symmetriekarten einlesen:

      if(spgrp(1:3).eq.'   ') then
        write(*,*)
        line = ' '
        line = '  Space group file: '//symfile
        call writline(6,line,maxline)
        call symcar(ke,symfile,intaus,laue,icent,ism,tran,nsym)
      else
        write(*,'(/2x,a,a)') 'Space group: ',spgrp
        call symint(spgrp,intaus,laue,icent,ism,tran,nsym)
      end if

c --- Bei modulierten Strukturen und Zentrosymmetrie
c     die Inversion auf alle Symmetrieelemente anwenden:

      if(imo.eq.1.and.icent.eq.2) then
        ns = nsym
        do 700 n=1,nsym
           ns = ns + 1
           do 660 i=1,3
              tran(i,ns) = tran(i,n)
              do 650 j=1,3
                 ism(i,j,ns) = -ism(i,j,n)
650           continue
660        continue
700     continue
        nsym = ns
        icent = 1
      end if

c --- Kristallsystem bestimmen:

      nc = 1
      if(laue.eq.6.or.laue.eq.7.or.laue.eq.8.or.
     *   laue.eq.9.or.laue.eq.15) nc = 2

c --- Symmetrieelemente sortieren:

      call symsort(nc,csym,symor,ism,tran,trp,trs,num,numsy,nsym,48)

c --- Symmetriekarten rausschreiben, falls erwuenscht:

      write(*,'(2x,a,i4)') 'Number of symmetry cards = ',nsym
      if(icent.eq.2) then
        write(*,'(2x,a)') 'This space group is centrosymmetric'
      else
        write(*,'(2x,a)') 'This space group is non-centrosymmetric'
      end if
      write(*,'(2x,a,a,4x,a,a)')
     *'Int. Ausl. : ',intaus,'    Laue-group : ',clau(laue)
      if(ismat.eq.1) then
        write(*,'(/2x,a/)') 'S y m m e t r y   c a r d s'
        do 135 n=1,nsym
           write(*,132) csym(n),symor(n),
     *          (real(ism(1,j,n)),j=1,3),tran(1,n),trp(1,n),
     *          ((real(ism(j,i,n)),i=1,3),tran(j,n),trp(j,n),j=2,3)
132        format(2x,a,1x,a,' :',8x,3f5.1,8x,f5.2,8x,f5.2,/,
     *            21x,'R=  ',3f5.1,'    T=  ',f5.2,'    Tp= ',f5.2,/,
     *            25x,3f5.1,8x,f5.2,8x,f5.2/)
135     continue
      end if

      return
      end


c******************************************************************************
c***   Symmetriekarten und Auslenkungsfelder aus einer Datei einlesen       ***
c******************************************************************************

      subroutine symcar(ke,symfile,intaus,laue,icent,ism,tran,nsym)

      parameter(max = 30, PI = 3.14159265359)
      integer ism(3,3,48)
      real werte(max), tran(3,48)
      character symfile*80, intaus*1, char(max)*132, ecod*3

      ecod = 'eee'


c --- Formate:

 31   format(/2x,'Error in space group file: Line "',a3,
     *  '> ..." is missing')

c --- Symmetriekarten-File oeffnen:

      open(ke,file=symfile,status='old',err=1000)

c --- Int. Ausl., Lauegruppe, Zentrosymmetrie einlesen:

      ist = 1
      call getinp(ke,'COD',ecod,werte,char,max,num,nn,ist)
      if(ist.eq.11) then
        write(*,31) 'COD'
        stop
      else
        iz = 3
        if(num.ne.iz) then
          write(*,131) iz
131       format(/2x,
     *    'Error in space group file: wrong number of parameters,',
     *    ' it should be ',i2,',',/29x,'line "COD> ..."')
          stop
        end if
        intaus = char(1)(1:1)
        laue   = nint(werte(2))
        icent  = nint(werte(3))
      end if

c --- Symmetriekarten einlesen:

      n = 0
100   ist = 1
      call getinp(ke,'SYM',ecod,werte,char,max,num,nn,ist)
      if(ist.eq.11.or.ist.eq.13) then
        if(n.eq.0) then
          write(*,31) 'SYM'
          stop
        else
          nsym = n
          goto 400
        end if
      else
        n = n + 1
        iz = 13
        if(num.ne.iz) then
          write(*,141) iz,n
141       format(/2x,
     *    'Error in space group file: wrong number of parameters,',
     *    ' it should be ',i2,',',
     *    /29x,'line "SYM> ...", symmetry card ',i3)
          stop
        end if
        do 120 i=1,3
           tran(i,n) = werte(10+i)
           do 130 j=1,3
              ism(i,j,n) = nint(werte(3*(i-1)+j+1))
130        continue
120     continue
      end if
      goto 100


c --- Datei schliessen:

400   close(ke)


c --- Falls die Symmetriekarte (x,y,z) fehlt, wird sie ergaenzt:

      iall = 0
      do 500 n=1,nsym
         idi = 0
	 do 499 i=1,3
	    if(ism(i,i,n).eq.1.and.tran(i,n).eq.0.) idi = idi + 1
499      continue
	 if(idi.eq.3) iall = 1
500   continue

      if(iall.ne.1) then
        nsym = nsym + 1
        n = nsym
        do 600 i=1,3
           tran(i,n) = 0.
           do 599 j=1,3
              ism(i,j,n) = 0
599        continue
           ism(i,i,n) = 1
600     continue
      end if

      return


c --- Fehlermeldungen:

1000  stop ' Error: Cannot open space group file' 
  
      end

C******************************************************************************
C***               KODIERUNG DER SYMMETRIEKARTEN                            ***
C******************************************************************************

      SUBROUTINE SYMINT(STRING,CZENT,NL,ICENT,ISM,TRAN,NSYM)

      PARAMETER (MAXS = 100)

      INTEGER ISM(3,3,48)
      REAL TRAN(3,48)
 
      CHARACTER HEX(30)*13, TET(85)*14, KUB(42)*14, RHO(32)*14
      CHARACTER ORT(70)*14, MON(60)*13, TRI(2)*13

      COMMON /CHAHEX/ HEX
      COMMON /CHATET/ TET
      COMMON /CHARHO/ RHO
      COMMON /CHAKUB/ KUB
      COMMON /CHAORT/ ORT
      COMMON /CHAMON/ MON
      COMMON /CHATRI/ TRI

      COMMON /INHEX/ IHEX(30,24)
      COMMON /INTET/ ITET(85,16)
      COMMON /INRHO/ IRHO(32,12)
      COMMON /INKUB/ IKUB(42,48)
      COMMON /INORT/ IORT(70,8)
      COMMON /INMON/ IMON(60,4)
      COMMON /INTRI/ ITRI(2,2) 

      CHARACTER CH*3, CZENT*1, C1C*4, C2C*4, C3C*4, CUR*1, STRING*60
      INTEGER LL(0:3), LMAT(3,3), NITR(3), IDUM(MAXS)
      COMMON /CH/ CH, CUR
      COMMON /IENTE/ IH(9)


c --- Initialisierung:

      CZENT(1:1) = ' '
      C1C(1:4)   = '    '
      C2C(1:4)   = '    '
      C3C(1:4)   = '    '
      CUR(1:1)   = ' '

c --- Raumgruppen-Symbol:

      CALL SYMMK(STRING,CZENT,C1C,C2C,C3C,CUR)

C --- Interpretation des Symbols:

      IF(C2C(1:1).EQ.'3') THEN
C        WRITE(*,*) ' Kubische RG.'
	ICO = 43
      ELSE IF(C1C(1:1).EQ.'4') THEN
C        WRITE(*,*) ' Tetragonale RG.'
	ICO = 4
      ELSE IF(C1C(1:1).EQ.'6') THEN
C        WRITE(*,*) ' Hexagonale RG.'
	ICO = 6
      ELSE IF(C1C(1:1).EQ.'3') THEN
C        WRITE(*,*) ' Trigonale RG.'
	ICO = 3
      ELSE IF(C1C(1:1).EQ.'1') THEN
	  IF(C2C(1:1).EQ.' ') THEN
C            WRITE(*,*) ' Trikline RG.'
	    ICO = 1
	  ELSE
C            WRITE(*,*) ' Monokline RG.'
	    ICO = 2
	  END IF
      ELSE IF (C1C(1:1).EQ.'1'.OR.C2C(1:1).EQ.'1'.OR.
     *         C3C(1:1).EQ.'1') THEN
C        WRITE(*,*) ' Monokline RG.'
	ICO = 2
      ELSE
C        WRITE(*,*)' Orthorhombische RG.'
	ICO = 5
      END IF


c --- Tetragonale Raumgruppen:

      IF(ICO.EQ.4) THEN
C        WRITE(*,*)' Tetragonale Rg. ',CZENT,' ',C1C,' ',C2C,' ',C3C,
C     *  ' ',CUR

	IMAXS = 16
	LSYM  =  0 
	DO 477 K=1,85
	  IF(CUR(1:1).EQ.'2') THEN
	    IF(TET(K)(14:14).NE.'2') GOTO 477
	  END IF
	  IF(TET(K)(1:1).NE.CZENT(1:1)) GOTO 477
	  IF(TET(K)(2:5).NE.C1C(1:4)) GOTO 477
	  IF(TET(K)(6:9).NE.C2C(1:4)) GOTO 477
	  IF(TET(K)(10:13).NE.C3C(1:4)) GOTO 477
	  LSYM = K
	  GOTO 478
477     CONTINUE

	IF(LSYM.EQ.0) THEN
	  WRITE(*,*) ' This space group is unknown (TET)'
	  WRITE(*,*) CZENT,' ',C1C,' ',C2C,' ',C3C,' ',CUR
	  STOP
	END IF

478     CONTINUE
	DO 452 L=1,IMAXS
	  IDUM(L) = ITET(LSYM,L)
452     CONTINUE


c --- Hexagonale Raumgruppen:

      ELSE IF (ICO.EQ.6) THEN
C        WRITE(*,*)' Hexagonale Rg. ',CZENT,' ',C1C,' ',C2C,' ',C3C,
C     *  ' ',CUR

	IMAXS = 24
	LSYM  =  0
	DO 677 K=1,30
	  IF(HEX(K)(1:1).NE.CZENT(1:1)) GOTO 677
	  IF(HEX(K)(2:5).NE.C1C(1:4)) GOTO 677
	  IF(HEX(K)(6:9).NE.C2C(1:4)) GOTO 677
	  IF(HEX(K)(10:13).NE.C3C(1:4)) GOTO 677
	  LSYM = K
	  GOTO 678
677     CONTINUE

	IF(LSYM.EQ.0) THEN
	  WRITE(*,*) ' This space group is unknown (HEX)'
	  WRITE(*,*) CZENT,' ',C1C,' ',C2C,' ',C3C,' ',CUR
	  STOP
	END IF

678     CONTINUE
	DO 651 L=1,IMAXS
 	   IDUM(L) = IHEX(LSYM,L)
651     CONTINUE


c --- Trigonale Raumgruppen:

      ELSE IF (ICO.EQ.3) THEN
c        WRITE(*,*)' Rhomboedr. Rg. ',CZENT,' ',C1C,' ',C2C,' ',C3C,
c     *  ' ',CUR

	IMAXS = 12
	LSYM  =  0
	DO 377 K=1,32
	  IF(RHO(K)(1:1).NE.CZENT(1:1)) GOTO 377
	  IF(RHO(K)(2:5).NE.C1C(1:4)) GOTO 377
	  IF(RHO(K)(6:9).NE.C2C(1:4)) GOTO 377
	  IF(RHO(K)(10:13).NE.C3C(1:4)) GOTO 377
	  IF(RHO(K)(14:14).NE.CUR(1:1)) GOTO 377
	  LSYM = K
	  GOTO 378
377     CONTINUE

	IF(LSYM.EQ.0) THEN
	  WRITE(*,*) ' This space group is unknown (RHO)'
	  WRITE(*,*) CZENT,' ',C1C,' ',C2C,' ',C3C,' ',CUR
	  STOP
	END IF

378     CONTINUE

C --- BEI RHOMBOEDRISCHEN RAUMGRUPPEN STEHT EIN "R" AN ERSTER STELLE, DAS ALS 
C     INTEGRALE AUSLOESCHUNG INTERPRETIERT WIRD. DESHALB WIRD HIER IN 'CZENT' 
C     EIN "P" REINGESCHRIEBEN.

        if(cur.eq.'R') CZENT(1:1) = 'P'

	DO 351 L=1,IMAXS
	  IDUM(L) = IRHO(LSYM,L)
351     CONTINUE


c --- Kubische Raumgruppen:

      ELSE IF (ICO.EQ.43) THEN
C        WRITE(*,*)' Kubische Rg. ',CZENT,' ',C1C,' ',C2C,' ',C3C,
C     *  ' ',CUR

	IMAXS = 48
	LSYM  =  0
	DO 4377 K=1,42
	  IF(CUR(1:1).EQ.'2') THEN
	    IF(KUB(K)(14:14).NE.'2') GOTO 4377
	  END IF
	  IF(KUB(K)(1:1).NE.CZENT(1:1)) GOTO 4377
	  IF(KUB(K)(2:5).NE.C1C(1:4)) GOTO 4377
	  IF(KUB(K)(6:9).NE.C2C(1:4)) GOTO 4377
	  IF(KUB(K)(10:13).NE.C3C(1:4)) GOTO 4377
	  LSYM = K
	  GOTO 4378
4377    CONTINUE

	IF(LSYM.EQ.0) THEN
	  WRITE(*,*) ' This space group is unknown (KUB)'
	  WRITE(*,*) CZENT,' ',C1C,' ',C2C,' ',C3C,' ',CUR
	  STOP
	END IF

4378    CONTINUE
	DO 4351 L=1,IMAXS
	  IDUM(L) = IKUB(LSYM,L)
4351    CONTINUE


c --- Trikline Raumgruppen:

      ELSE IF (ICO.EQ.1) THEN
C        WRITE(*,*)' Trikline Rg. ',CZENT,' ',C1C,' ',C2C,' ',C3C,
C     *  ' ',CUR

	IMAXS = 2
	LSYM  = 0
	DO 177 K=1,2
	  IF(TRI(K)(1:1).NE.CZENT(1:1)) GOTO 177
	  IF(TRI(K)(2:5).NE.C1C(1:4)) GOTO 177
	  IF(TRI(K)(6:9).NE.C2C(1:4)) GOTO 177
	  IF(TRI(K)(10:13).NE.C3C(1:4)) GOTO 177
	  LSYM = K
	  GOTO 178
177     CONTINUE

	IF(LSYM.EQ.0) THEN
	  WRITE(*,*) ' This space group is unknown (TRI)'
	  WRITE(*,*) CZENT,' ',C1C,' ',C2C,' ',C3C,' ',CUR
	  STOP
	END IF

178     CONTINUE
	DO 151 L=1,IMAXS
	   IDUM(L) = ITRI(LSYM,L)
151     CONTINUE


c --- Monokline Raumgruppen:

      ELSE IF (ICO.EQ.2) THEN
C        WRITE(*,*)' Monokline Rg. ',CZENT,' ',C1C,' ',C2C,' ',C3C,
C     *  ' ',CUR

	IMAXS = 4
	LSYM  = 0
	DO 277 K=1,60
	  IF(MON(K)(1:1).NE.CZENT(1:1)) GOTO 277
	  IF(MON(K)(2:5).NE.C1C(1:4)) GOTO 277
	  IF(MON(K)(6:9).NE.C2C(1:4)) GOTO 277
	  IF(MON(K)(10:13).NE.C3C(1:4)) GOTO 277
	  LSYM = K
	  GOTO 278
277     CONTINUE

	IF(LSYM.EQ.0) THEN
	  WRITE(*,*) ' This space group is unknown (MON)'
	  WRITE(*,*) CZENT,' ',C1C,' ',C2C,' ',C3C,' ',CUR
	  STOP
	END IF

278     CONTINUE
	DO 251 L=1,IMAXS
	   IDUM(L) = IMON(LSYM,L)
251     CONTINUE


c --- Orthorhombische Raumgruppen:

      ELSE IF (ICO.EQ.5) THEN
C        WRITE(*,*)' Orthor. Rg. ',CZENT,' ',C1C,' ',C2C,' ',C3C,
C     *  ' ',CUR

	IMAXS = 8
	LSYM  = 0
	DO 577 K=1,70
	  IF(CUR(1:1).EQ.'2') THEN
	    IF(ORT(K)(14:14).NE.'2') GOTO 577
	  END IF
	  IF(ORT(K)(1:1).NE.CZENT(1:1)) GOTO 577
	  IF(ORT(K)(2:5).NE.C1C(1:4)) GOTO 577
	  IF(ORT(K)(6:9).NE.C2C(1:4)) GOTO 577
	  IF(ORT(K)(10:13).NE.C3C(1:4)) GOTO 577
	  LSYM = K
	  GOTO 578
577     CONTINUE

	IF(LSYM.EQ.0) THEN
	  WRITE(*,*) ' This space group is unknown (ORT)'
	  WRITE(*,*) CZENT,' ',C1C,' ',C2C,' ',C3C,' ',CUR
	  STOP
	END IF

578     CONTINUE
	DO 551 L=1,IMAXS
	  IDUM(L) = IORT(LSYM,L)
551     CONTINUE

c --- Ungueltiges Raumgruppensymbol:
 
      ELSE

	WRITE(*,*)' This space group is unknown '

      END IF

c --- Schleife ueber die Matrizen:

      ISC = 0
900   CONTINUE

      DO 771 M=1,IMAXS

	 IF(IDUM(M).LE.0) GOTO 771

         ISC = ISC + 1
         ICODE = IDUM(M)
 
c --- Entcodierung:

         CALL ENTCOD(ISC,ICODE,LAUE,ICE,NNENN,LL,NITR)

         DO 500 M1=1,3
	    DO 500 M2=1,3
	       LMAT(M1,M2) = 0
500      CONTINUE

         CALL MATRIX(LL,LMAT)

         IF(ISC.EQ.1) THEN
	   NL = LAUE
	   ICENT = ICE
C           WRITE(*,*)' SYMINT LAUEGRUPPE = ',LAUE
C           WRITE(*,*)' SYMINT ZENTROSY. = ',ICE
         END IF

         IF(NNENN.EQ.0) THEN
	   DO 213 N1=1,3
	      DO 213 N2=1,3
	         ISM(N1,N2,ISC) = LMAT(N1,N2)
213        CONTINUE
C           DO 215 N1=1,3  
C              WRITE(*,*) (ISM(N1,N2,ISC),N2=1,3)
C215        CONTINUE
         ELSE
  	   DO 212 N1=1,3
	      TRANS = REAL(NITR(N1))/REAL(NNENN)
	      TRAN(N1,ISC) = TRANS    
	      DO 212 N2=1,3
	         ISM(N1,N2,ISC) = LMAT(N1,N2)
212        CONTINUE
C           DO 216 N1=1,3  
C              WRITE(*,*) (ISM(N1,N2,ISC),N2=1,3),TRAN(N1,ISC)
C216        CONTINUE
         END IF

C         WRITE(*,*)' DIE ',ISC,' TE MATRIX'

771   CONTINUE

      NSYM = ISC
C      WRITE(*,*)'ISC',ISC,'NSYM=',NSYM
   
      RETURN
      END


C******************************************************************************
C***            Einlesen von Symmetrie-Daten                                ***
C******************************************************************************

      SUBROUTINE SYMMK(STRING,CZENT,C1C,C2C,C3C,CUR)

      PARAMETER (ISTR = 60)

      CHARACTER STRING*60, STRANG*60
      CHARACTER CZENT*1, C1C*4, C2C*4, C3C*4, CUR*1

      INTEGER IKOM(0:20)


c --- Initialisierung:

      do 110 i=0,20
         ikom(i) = 0
 110  continue

C --- Die 'Blanks' werden rausgeschmissen:

      DO 140 ISP=1,ISTR
	 STRANG(ISP:ISP) = ' '
140   CONTINUE

      ISPEN = 0   
210   DO 150 ISP=1,ISTR
	 IF(STRING(ISP:ISP).NE.' ') THEN
	   ISPEN = ISPEN + 1
	   STRANG(ISPEN:ISPEN) = STRING(ISP:ISP)
	 END IF
150   CONTINUE

c      WRITE(*,*) ' SYMM - STRANG ',STRANG

C --- Kommata werden festgelegt:

      IKOMM = 0
      DO 160 JJ=1,ISPEN
	 IF(STRANG(JJ:JJ).EQ.',') THEN
	   IKOMM = IKOMM + 1
	   IKOM(IKOMM) = JJ
	 END IF
160   CONTINUE

      IF(IKOMM.GT.21) THEN
	WRITE(*,*) ' Too many commas in space group symbol'
	STOP
      END IF

      I1  = IKOM(1) - 1
      CZENT(1:1) = STRANG(1:I1)
      I1  = I1 + 2
      I2  = IKOM(2) - 1
      C1C = STRANG(I1:I2)
      I1  = I2 + 2
      I2  = IKOM(3) - 1
      IF(I1.LE.I2) C2C = STRANG(I1:I2)
      I1  = I2 + 2
      IF(IKOM(4).EQ.0) THEN
	C3C = STRANG(I1:I1+4)
	CUR = ' '
      ELSE
	I2  = IKOM(4) - 1
	IF(I1.LE.I2) C3C = STRANG(I1:I2)
	I1  = I2 + 2
	CUR = STRANG(I1:I1)
      END IF

c      WRITE(*,*) ' SYMM: ',CZENT,C1C,C2C,C3C,CUR

9999  RETURN
      END


C******************************************************************************
C***            Entkodierung der Raumgruppen                                ***
C******************************************************************************

      SUBROUTINE ENTCOD(ISC,ICODE,LAUE,ICE,NNENN,LL,NITR)

      INTEGER LL(0:*),NITR(*)

      COMMON/IENTE/IH(9)

      IF(ISC.EQ.1) THEN
	LAUE  = ICODE/IH(9)
	ICODE = ICODE-LAUE*IH(9)
	ICE   = ICODE/IH(8)
	ICODE = ICODE-ICE*IH(8)
      END IF

      LL(0)   = ICODE/IH(7)-4
      ICODE   = ICODE-(LL(0)+4)*IH(7)
      LL(1)   = ICODE/IH(6)-4
      ICODE   = ICODE-(LL(1)+4)*IH(6)
      LL(2)   = ICODE/IH(5)-4
      ICODE   = ICODE-(LL(2)+4)*IH(5)
      LL(3)   = ICODE/IH(4)-4
      ICODE   = ICODE-(LL(3)+4)*IH(4)
      NNENN   = ICODE/IH(3)
      ICODE   = ICODE-NNENN*IH(3)
      NITR(1) = ICODE/IH(2)
      ICODE   = ICODE-NITR(1)*IH(2)
      NITR(2) = ICODE/IH(1)
      ICODE   = ICODE-NITR(2)*IH(1)
      NITR(3) = ICODE

      RETURN
      END    


C******************************************************************************
C***                                                                        ***
C******************************************************************************

      SUBROUTINE MATRIX(KK,IMAT)

      INTEGER KK(0:3),IMAT(3,3)

      IF(KK(0).EQ.0) THEN
	IF(KK(1).EQ. 1) IMAT(1,1) =  1
	IF(KK(1).EQ. 2) IMAT(1,2) =  1
	IF(KK(1).EQ. 3) IMAT(1,3) =  1
	IF(KK(1).EQ.-1) IMAT(1,1) = -1
	IF(KK(1).EQ.-2) IMAT(1,2) = -1
	IF(KK(1).EQ.-3) IMAT(1,3) = -1
	IF(KK(2).EQ. 1) IMAT(2,1) =  1
	IF(KK(2).EQ. 2) IMAT(2,2) =  1
	IF(KK(2).EQ. 3) IMAT(2,3) =  1
	IF(KK(2).EQ.-1) IMAT(2,1) = -1
	IF(KK(2).EQ.-2) IMAT(2,2) = -1
	IF(KK(2).EQ.-3) IMAT(2,3) = -1
	IF(KK(3).EQ. 1) IMAT(3,1) =  1
	IF(KK(3).EQ. 2) IMAT(3,2) =  1
	IF(KK(3).EQ. 3) IMAT(3,3) =  1
	IF(KK(3).EQ.-1) IMAT(3,1) = -1
	IF(KK(3).EQ.-2) IMAT(3,2) = -1
	IF(KK(3).EQ.-3) IMAT(3,3) = -1
      ELSE
	IF(KK(3).EQ. 1) IMAT(3,1) =  1
	IF(KK(3).EQ. 2) IMAT(3,2) =  1
	IF(KK(3).EQ. 3) IMAT(3,3) =  1
	IF(KK(3).EQ.-1) IMAT(3,1) = -1
	IF(KK(3).EQ.-2) IMAT(3,2) = -1
	IF(KK(3).EQ.-3) IMAT(3,3) = -1
	IF(ABS(KK(0)).EQ.1) THEN
	  IF(KK(2).EQ. 1) IMAT(2,1) =  1
	  IF(KK(2).EQ. 2) IMAT(2,2) =  1
	  IF(KK(2).EQ. 3) IMAT(2,3) =  1
	  IF(KK(2).EQ.-1) IMAT(2,1) = -1
	  IF(KK(2).EQ.-2) IMAT(2,2) = -1
	  IF(KK(2).EQ.-3) IMAT(2,3) = -1
	  IF(KK(0).EQ.1) THEN
	    IMAT(1,1) =  1
	    IMAT(1,2) = -1
	  ELSE
	    IMAT(1,1) = -1
	    IMAT(1,2) =  1
	  END IF
	END IF
	IF(ABS(KK(0)).EQ.2) THEN
	  IF(KK(1).EQ. 1) IMAT(1,1) =  1
	  IF(KK(1).EQ. 2) IMAT(1,2) =  1
	  IF(KK(1).EQ. 3) IMAT(1,3) =  1
	  IF(KK(1).EQ.-1) IMAT(1,1) = -1
	  IF(KK(1).EQ.-2) IMAT(1,2) = -1
	  IF(KK(1).EQ.-3) IMAT(1,3) = -1
	  IF(KK(0).EQ.2) THEN
	    IMAT(2,1) =  1
	    IMAT(2,2) = -1
	  ELSE
	    IMAT(2,1) = -1
	    IMAT(2,2) =  1
	  END IF
	END IF
      END IF

      RETURN
      END

c******************************************************************************
c***                  Symmetrieelemente sortieren                           ***
c******************************************************************************

      subroutine symsort(nc,csym,symor,ism,tran,trp,trs,num,numsy,
     *                   nsym,NSY)

      parameter(MAX = 48)
      real trp(3,NSY), tran(3,NSY), trs(3,NSY)
      character csym(NSY)*3, symor(NSY)*9, cm*4, so*9
      integer irot(3,3), ism(3,3,NSY)
      integer num(NSY), numsy(NSY)


c --- Nummer des Symmetrieelementes bestimmen:

      do 100 n=1,nsym
         do 50 k=1,MAX
            call rotmat(k,nc,cm,so,irot)
            ng = 0
            do 30 i=1,3
               do 20 j=1,3
                  if(ism(j,i,n).eq.irot(j,i)) ng = ng + 1
 20            continue
 30         continue
            if(ng.eq.9) goto 60
 50      continue
 60      if(ng.eq.9) then
           num(n) = k
           do 70 i=1,3
              trs(i,k) = tran(i,n)
 70        continue           
         else
           write(*,'(/2x,a,i2,a)') 
     *     'ERROR: Symmetry element ',n,' not identified'
           stop
         end if
 100  continue

c --- Symbol bestimmen und Rotationsmatrizen und Translationen nach oben 
c     gegebener Reihenfolge abspeichern:

      ns = 0
      do 200 k=1,MAX
         do 150 n=1,nsym
            if(num(n).eq.k) then

              ns = ns + 1
              numsy(ns) = k
              call rotmat(k,nc,cm,so,irot)
              do 130 i=1,3
                 tran(i,ns) = trs(i,k) 
                 do 120 j=1,3
                    ism(j,i,ns) = irot(j,i)
 120             continue
 130          continue
              csym(ns) = cm
              symor(ns) = so

c --- Pruefen, ob ein Symmetrieelement {ism|tran} phasenschiebend ist
c     und den phasenschiebenden Translationsanteil trp bestimmen
c     (npt gibt an, wie oft man das Symmetrieelement anwenden muss,
c     um wieder die Einheitsmatrix zu erhalten):

              call tranphs(trp(1,ns),npt,ism(1,1,ns),tran(1,ns))

c --- Test auf Gleitspiegelebene/Schraubenachse:

              call transbl(csym(ns),npt,tran(1,ns),trp(1,ns))

              goto 200

            end if
 150     continue
 200  continue


      return
      end


c******************************************************************************
c***                 Symmetrieelement bestimmen                             ***
c******************************************************************************

      subroutine rotmat(k,nc,csym,symor,ism)

      parameter(MAX = 48)
      character csym*3, symor*9, cm(MAX,2)*3, so(MAX,2)*9
      integer irot(3,3,MAX,2), ism(3,3)


c --- Rotationsmatrizen fuer das trikline, monokline, orthorhombische,
c     tetragonale, rhomboedrische und kubische System:

      data (cm(n,1),so(n,1),((irot(j,i,n,1),i=1,3),j=1,3),n=1,48)
     *  / '  1',  '         ',   1, 0, 0,   0, 1, 0,   0, 0, 1,    
     *    ' 3+',  '  [1,1,1]',   0, 0, 1,   1, 0, 0,   0, 1, 0,   
     *    ' 3+',  '[1,-1,-1]',   0, 0,-1,  -1, 0, 0,   0, 1, 0,
     *    ' 3+',  '[-1,1,-1]',   0, 0, 1,  -1, 0, 0,   0,-1, 0,
     *    ' 3+',  '[-1,-1,1]',   0, 0,-1,   1, 0, 0,   0,-1, 0,
     *    ' 3-',  '  [1,1,1]',   0, 1, 0,   0, 0, 1,   1, 0, 0,
     *    ' 3-',  '[1,-1,-1]',   0,-1, 0,   0, 0, 1,  -1, 0, 0,
     *    ' 3-',  '[-1,1,-1]',   0,-1, 0,   0, 0,-1,   1, 0, 0,
     *    ' 3-',  '[-1,-1,1]',   0, 1, 0,   0, 0,-1,  -1, 0, 0,
     *    ' 4+',  '  [1,0,0]',   1, 0, 0,   0, 0,-1,   0, 1, 0,
     *    ' 4+',  '  [0,1,0]',   0, 0, 1,   0, 1, 0,  -1, 0, 0,
     *    ' 4+',  '  [0,0,1]',   0,-1, 0,   1, 0, 0,   0, 0, 1,
     *    ' 4-',  '  [1,0,0]',   1, 0, 0,   0, 0, 1,   0,-1, 0,
     *    ' 4-',  '  [0,1,0]',   0, 0,-1,   0, 1, 0,   1, 0, 0,
     *    ' 4-',  '  [0,0,1]',   0, 1, 0,  -1, 0, 0,   0, 0, 1,
     *    '  2',  '  [1,0,0]',   1, 0, 0,   0,-1, 0,   0, 0,-1,
     *    '  2',  '  [0,1,0]',  -1, 0, 0,   0, 1, 0,   0, 0,-1,
     *    '  2',  '  [0,0,1]',  -1, 0, 0,   0,-1, 0,   0, 0, 1,
     *    '  2',  '  [1,1,0]',   0, 1, 0,   1, 0, 0,   0, 0,-1,
     *    '  2',  '  [1,0,1]',   0, 0, 1,   0,-1, 0,   1, 0, 0,
     *    '  2',  '  [0,1,1]',  -1, 0, 0,   0, 0, 1,   0, 1, 0,
     *    '  2',  ' [1,-1,0]',   0,-1, 0,  -1, 0, 0,   0, 0,-1,
     *    '  2',  ' [-1,1,0]',   0, 0,-1,   0,-1, 0,  -1, 0, 0,
     *    '  2',  ' [-1,0,1]',  -1, 0, 0,   0, 0,-1,   0,-1, 0,
     *    ' 1b',  '         ',  -1, 0, 0,   0,-1, 0,   0, 0,-1,
     *    '3b+',  '  [1,1,1]',   0, 0,-1,  -1, 0, 0,   0,-1, 0,
     *    '3b+',  '[1,-1,-1]',   0, 0, 1,   1, 0, 0,   0,-1, 0,
     *    '3b+',  '[-1,1,-1]',   0, 0,-1,   1, 0, 0,   0, 1, 0,
     *    '3b+',  '[-1,-1,1]',   0, 0, 1,  -1, 0, 0,   0, 1, 0,
     *    '3b-',  '  [1,1,1]',   0,-1, 0,   0, 0,-1,  -1, 0, 0,
     *    '3b-',  '[1,-1,-1]',   0, 1, 0,   0, 0,-1,   1, 0, 0,
     *    '3b-',  '[-1,1,-1]',   0, 1, 0,   0, 0, 1,  -1, 0, 0,
     *    '3b-',  '[-1,-1,1]',   0,-1, 0,   0, 0, 1,   1, 0, 0,
     *    '4b+',  '  [1,0,0]',  -1, 0, 0,   0, 0, 1,   0,-1, 0,
     *    '4b+',  '  [0,1,0]',   0, 0,-1,   0,-1, 0,   1, 0, 0,
     *    '4b+',  '  [0,0,1]',   0, 1, 0,  -1, 0, 0,   0, 0,-1,
     *    '4b-',  '  [1,0,0]',  -1, 0, 0,   0, 0,-1,   0, 1, 0,
     *    '4b-',  '  [0,1,0]',   0, 0, 1,   0,-1, 0,  -1, 0, 0,
     *    '4b-',  '  [0,0,1]',   0,-1, 0,   1, 0, 0,   0, 0,-1,
     *    '  m',  '  [1,0,0]',  -1, 0, 0,   0, 1, 0,   0, 0, 1,
     *    '  m',  '  [0,1,0]',   1, 0, 0,   0,-1, 0,   0, 0, 1,
     *    '  m',  '  [0,0,1]',   1, 0, 0,   0, 1, 0,   0, 0,-1,
     *    '  m',  '  [1,1,0]',   0,-1, 0,  -1, 0, 0,   0, 0, 1,
     *    '  m',  '  [1,0,1]',   0, 0,-1,   0, 1, 0,  -1, 0, 0,
     *    '  m',  '  [0,1,1]',   1, 0, 0,   0, 0,-1,   0,-1, 0,
     *    '  m',  ' [1,-1,0]',   0, 1, 0,   1, 0, 0,   0, 0, 1,
     *    '  m',  ' [-1,1,0]',   0, 0, 1,   0, 1, 0,   1, 0, 0,
     *    '  m',  ' [-1,0,1]',   1, 0, 0,   0, 0, 1,   0, 1, 0/


c --- Rotationmatrizen fuer das hexagonale System:

      data (cm(n,2),so(n,2),((irot(j,i,n,2),i=1,3),j=1,3),n=1,24)
     *  / '  1',  '         ',   1, 0, 0,   0, 1, 0,   0, 0, 1,
     *    ' 3+',  '  [0,0,1]',   0,-1, 0,   1,-1, 0,   0, 0, 1,
     *    ' 3-',  '  [0,0,1]',  -1, 1, 0,  -1, 0, 0,   0, 0, 1,
     *    ' 6+',  '  [0,0,1]',   1,-1, 0,   1, 0, 0,   0, 0, 1,
     *    ' 6-',  '  [0,0,1]',   0, 1, 0,  -1, 1, 0,   0, 0, 1, 
     *    '  2',  '  [0,0,1]',  -1, 0, 0,   0,-1, 0,   0, 0, 1,
     *    '  2',  '  [1,0,0]',   1,-1, 0,   0,-1, 0,   0, 0,-1,
     *    '  2',  '  [0,1,0]',  -1, 0, 0,  -1, 1, 0,   0, 0,-1,
     *    '  2',  '  [1,1,0]',   0, 1, 0,   1, 0, 0,   0, 0,-1,
     *    '  2',  ' [1,-1,0]',   0,-1, 0,  -1, 0, 0,   0, 0,-1,
     *    '  2',  '  [1,2,0]',  -1, 1, 0,   0, 1, 0,   0, 0,-1,
     *    '  2',  '  [2,1,0]',   1, 0, 0,   1,-1, 0,   0, 0,-1,
     *    ' 1b',  '         ',  -1, 0, 0,   0,-1, 0,   0, 0,-1,
     *    '3b+',  '  [0,0,1]',   0, 1, 0,  -1, 1, 0,   0, 0,-1,
     *    '3b-',  '  [0,0,1]',   1,-1, 0,   1, 0, 0,   0, 0,-1,
     *    '6b+',  '  [0,0,1]',  -1, 1, 0,  -1, 0, 0,   0, 0,-1,
     *    '6b-',  '  [0,0,1]',   0,-1, 0,   1,-1, 0,   0, 0,-1,
     *    '  m',  '  [0,0,1]',   1, 0, 0,   0, 1, 0,   0, 0,-1,
     *    '  m',  '  [1,0,0]',  -1, 1, 0,   0, 1, 0,   0, 0, 1,
     *    '  m',  '  [0,1,0]',   1, 0, 0,   1,-1, 0,   0, 0, 1,
     *    '  m',  '  [1,1,0]',   0,-1, 0,  -1, 0, 0,   0, 0, 1,
     *    '  m',  ' [1,-1,0]',   0, 1, 0,   1, 0, 0,   0, 0, 1,
     *    '  m',  '  [1,2,0]',   1,-1, 0,   0,-1, 0,   0, 0, 1,
     *    '  m',  '  [2,1,0]',  -1, 0, 0,  -1, 1, 0,   0, 0, 1/

      csym  = cm(k,nc)
      symor = so(k,nc)
      do 20 i=1,3
         do 10 j=1,3
            ism(j,i) = irot(j,i,k,nc)
 10      continue
 20   continue

      return
      end


c******************************************************************************
c***        Test auf Gleitspiegelebene/Schraubenachse                       ***
c******************************************************************************

      subroutine transbl(csym,npt,tran,trp)

      parameter(NGP = 10, EPSY = 0.0001)
      real tran(3), trp(3), tgp(3,NGP)
      character csym*3, chr*1, gp(NGP)*3

c --- Gleitspiegelebenen:

      data (gp(k),(tgp(i,k),i=1,3),k=1,NGP)
     *   /'  a',  0.5,  0.,   0.,   '  b',  0.,   0.50, 0.,
     *    '  c',  0.,   0.,   0.50, '  n',  0.50, 0.50, 0.,
     *    '  n',  0.,   0.50, 0.50, '  n',  0.50, 0.  , 0.50,
     *    '  n',  0.50, 0.50, 0.50, '  n', -0.50, 0.50, 0.50,
     *    '  n',  0.50,-0.50, 0.50, '  n',  0.50, 0.50,-0.50/


c --- Test auf a,b,c,n,d-Gleitspiegelebene:

      if(index(csym,'m').gt.0) then
        do 245 l=1,NGP
           if(abs(trp(1)-tgp(1,l)).lt.EPSY.and.
     *        abs(trp(2)-tgp(2,l)).lt.EPSY.and.
     *        abs(trp(3)-tgp(3,l)).lt.EPSY) then
             csym = gp(l)
             goto 250
           end if
 245    continue
        do 247 j=1,3
           xx = npt * trp(j)
           if(abs(amod(xx,1.)).gt.EPSY) then
             csym = '  d'
             goto 250
           end if
 247    continue
      end if

c --- Test auf Schraubenachse: 

 250  if(abs(trp(1)).gt.EPSY.or. 
     *   abs(trp(2)).gt.EPSY.or.abs(trp(3)).gt.EPSY) then
        do 340 j=1,6
           write(chr,'(i1)') j
           na = index(csym,chr)
           if(na.gt.0) then
             write(csym(na-1:na),'(2i1)') j, npt - 1
             goto 350
           end if
 340    continue
      end if
 350  continue

      return
      end
c******************************************************************************
c***  Bestimmung der Phasenschiebende Translation der Symmetrieelemente     ***
c******************************************************************************

      subroutine tranphs(trp,ns,ism,tran)

      parameter (EPSY = 0.0001)
      integer m(3,3), mp(3,3), me(3,3), ism(3,3)
      real t(3), tp(3), tran(3), trp(3)

      data me / 1,0,0,  0,1,0,  0,0,1 /


c --- Initialisierung:

      do 3 i=1,3
         trp(i) = 0.
 3    continue


      if(abs(tran(1)).gt.EPSY.or.abs(tran(2)).gt.EPSY.or.
     *   abs(tran(3)).gt.EPSY) then
         
c --- Die Matrix m und den Vektor t initialisieren:

        ns = 1
        do 5 i=1,3
           t(i) = tran(i)
           do 4 j=1,3
              m(i,j) = ism(i,j)
 4         continue
 5      continue

c --- Die Produktmatrix {mp|tp} = {ism|tran} * {m|t} berechnen:

 7      ns = ns + 1
        call symprd(ism,tran,m,t,mp,tp)

c --- Testen, ob erzeugte die Produktmatrix mp die Einheitsmatrix me ist
c     und ob die dazugehoerige Translation tp der Einheitsvektor ist.
c     Falls dies der Fall ist, ist das Symmetrieelement n nicht 
c     phasenschiebend: 

        iw = 0
        do 45 i=1,3
           do 44 j=1,3
              if(mp(i,j).ne.me(i,j)) iw = 1
44         continue
45      continue

        if(iw.eq.0) then

c --- Testen, ob nach ns-facher Anwendung des Symmetrieelementes {ism|tran}
c     der Translationsanteil tp von Null verschieden ist. Wenn ja, wird
c     der Translationsanteil pro Anwendung berechnet:

          if(abs(tp(1)).gt.EPSY.or.abs(tp(2)).gt.EPSY.or.
     *       abs(tp(3)).gt.EPSY) then
            do 46 i=1,3
               trp(i) = tp(i)/real(ns)
46          continue
          end if

        else

c --- Matrix m und den Vektor t auffuellen:

47        do 60 i=1,3
             t(i) = tp(i)
             do 50 j=1,3
                m(i,j) = mp(i,j)
50           continue
60        continue
          goto 7

        end if

      end if


      return
      end


c******************************************************************************
c***            Produkt zweier Symmetrieelemente                            ***
c******************************************************************************

c     {mc|tc} = {ma|ta} * {mb|tb} = {ma * mb| ma*tb + ta}

      subroutine symprd(ma,ta,mb,tb,mc,tc)

      integer ma(3,3), mb(3,3), mc(3,3)
      real ta(3), tb(3), tc(3)

      do 50 i=1,3
         tc(i) = ta(i)
         do 40 j=1,3
            tc(i) = tc(i) + ma(j,i) * tb(j)
            mc(j,i) = 0
            do 30 k=1,3
               mc(j,i) = mc(j,i) + ma(k,i) * mb(j,k)   
30          continue
40       continue
50    continue

      return
      end


c******************************************************************************
c***                Eine Zeile ins INPUT-File schreiben                     ***
c******************************************************************************

      subroutine writline(ka,line,maxline)

      character line*132, form*6

      form = '(a000)'

      do 10 n=0,maxline-1
         if(line(maxline-n:maxline-n).ne.' ') then
           npos = n
           goto 12
         end if
10    continue
      npos = maxline - 1

12    write(form(3:5),'(i3)') maxline - npos
      write(ka,fmt=form) line

      return
      end


